
/**
 * CLASS GraphicHotSpot: adds the ability to draw itself on a panel
 * Company:      DML<p>
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;
import javax.swing.*;
import java.awt.Point;
import java.awt.event.*;
import java.awt.Graphics2D;
import java.awt.*;
import java.io.*;
import java.util.Vector;

public class GraphicHotSpot extends AbstractHotSpot implements Serializable, ActionListener
{ private String displayName="default";
  JPopupMenu popUp=new JPopupMenu();
  protected JMenuItem item=new JMenuItem();
  Vector hotSpotClickedListeners = new Vector();


  //Point location, int hotRadius, String tagData
  public GraphicHotSpot()
  {
   // panel.addMouseMotionListener(ml );
    try {
      jbInit();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }



  void writeObject(ObjectOutputStream oos) throws IOException {
    oos.defaultWriteObject();
  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
    ois.defaultReadObject();
  }

  public void setDisplayName(String newDisplayName) {
    displayName = newDisplayName;
    this.item.setText(newDisplayName);
  }

  public String getDisplayName() {
    return displayName;
  }

  private void jbInit() throws Exception {
    this.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseEntered(MouseEvent e) {
        this_mouseEntered(e);
      }

      public void mouseExited(MouseEvent e) {
        this_mouseExited(e);
      }

      public void mouseClicked(MouseEvent e) {
        this_mouseClicked(e);
      }
    });

    //popUp=new JPopupMenu();
    this.setEnabled(true);
   // this.add(popUp);
    popUp.setBorderPainted(false);
    popUp.setInvoker(this);

    item.addActionListener(this);


/*    item.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseClicked(MouseEvent e)
      {
        popUp_mouseClicked(e);
      }
    });
*/
    item.setText(this.displayName);
    popUp.add(item);
    //this.add(popUp);
    this.setMinimumSize(new Dimension(20,20));

  }

  void this_mouseEntered(MouseEvent e)
  { //popUp.setEnabled(true);

  //System.out.println("mouseEntered");

   if(this.displayPopup.booleanValue())
   { popUp.setVisible(true);
     popUp.show(this,5,5);
   }



  }

  protected void this_mouseExited(MouseEvent e)
  {

    //System.out.println("mouseExited");
    popUp.setVisible(false);

  }


  void this_mouseClicked(MouseEvent e) {
    //System.out.println("mouseClicked");
    popUp.setVisible(false);
    fireHotSpotClicked(new HotSpotClickedEvent(this));
  }

  public void actionPerformed(ActionEvent e) {
    // occurs when user clicks on popUp menu
    //System.out.println("popup - mouseClicked");
    popUp.setVisible(false);
    fireHotSpotClicked(new HotSpotClickedEvent(this));
    //System.out.println("Dispatching event to "+this.toString());
    //this.dispatchEvent(e);
  }

  public synchronized void removeHotSpotClickedListener(HotSpotClickedListener l)
  {
    if (hotSpotClickedListeners.contains(l))
    {
      hotSpotClickedListeners.removeElement(l);
    }
  }

  public synchronized void addHotSpotClickedListener(HotSpotClickedListener l)
  {
    if (!hotSpotClickedListeners.contains(l))
    {
      hotSpotClickedListeners.addElement(l);
    }
  }

  private void fireHotSpotClicked(HotSpotClickedEvent e) {
    int count = hotSpotClickedListeners.size();
    for (int i = 0; i < count; i++)
    {
      ((HotSpotClickedListener) hotSpotClickedListeners.elementAt(i)).hotSpotClicked(e);
    }
  }
}