
/**
 * CLASS Hotspot: Represents a spot on some image for clicking
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;
import java.awt.*;
import java.io.*;

public class HotSpot implements Serializable
{ protected java.awt.Point location=null;
  protected String tagData=null;
  protected int hotRadius=0;

  public HotSpot(Point location, int hotRadius, String tagData)
  { this.location=location;
    this.hotRadius=hotRadius;
    this.tagData=tagData;

  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException
  {
    ois.defaultReadObject();
  }

  void writeObject(ObjectOutputStream oos) throws IOException
  {
    oos.defaultWriteObject();
  }

  public void setLocation(java.awt.Point newLocation)
  {
    location = newLocation;
  }

  public java.awt.Point getLocation()
  {
    return location;
  }

  public void setHotRadius(int radius)
  { this.hotRadius=radius;
  }

  public int getHotRadius()
  { return this.hotRadius;
  }

  public void setTagData(String tag)
  { this.tagData=tag;
  }

  public String getTagData()
  { return this.tagData;

  }

  public boolean equals(Object obj)
  { if(obj instanceof edu.ucf.cs.dml.mapthing.HotSpot)
    { HotSpot other=(HotSpot) obj;
     return ( this.tagData.equals(other.tagData) &&
              this.location.equals(other.location) && this.hotRadius==other.hotRadius);
    }

    return super.equals(obj) ;
  }

  public String toString()
  { return "edu.ucf.cs.dml.Hotspot location: "+ location.x+","+location.y+ " tag:"+
       this.tagData+ " radius:" + this.hotRadius;

  }

}