
/**
 * Title:        MapAreaPanel
 * Description:  A panel that collects all the graphicHotSpots and related
 *               events.
 * Copyright:    DML <p>
 * Company:      UCF<p>
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.mapthing;

import java.awt.*;
import javax.swing.JPanel;
import java.lang.reflect.*;
import java.util.*;
import java.io.*;
import java.awt.event.*;


public class MapAreaPanel extends JPanel implements Serializable, HotSpotClickedListener
{ protected java.net.URL baseURL=null;
  protected int hotSpotCount=0;
  protected Vector hotSpots=new Vector();
  protected transient Vector mapAreaSelectedListeners;
  protected boolean registered=false;

/*
  protected MouseAdapter mapAdapt=new java.awt.event.MouseAdapter()
  { public void mouseClicked(MouseEvent e)
    { fireMapAreaSelected(new MapAreaSelectedEvent(((GraphicHotSpot)e.getSource()).getDisplayName() ));
    }
  };

*/

  public MapAreaPanel()
  { Class c=this.getClass();
    boolean hasMore=true;
    int fieldNum=1;
    while(hasMore)
    { try
      { //System.out.println("graphicHotSpot"+fieldNum);
        Field f=c.getDeclaredField("graphicHotSpot"+fieldNum);
            //count all the hotSpotFields
        hotSpots.insertElementAt(f,fieldNum-1); //collect them

        fieldNum++;
      }
      catch(java.lang.NoSuchFieldException ex)
      { hasMore=false;
        hotSpotCount=fieldNum-1;
        //System.out.println("Number of HotSpots: " + hotSpotCount);

      }


    }

  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException
  {
    ois.defaultReadObject();
  }

  void writeObject(ObjectOutputStream oos) throws IOException
  {
    oos.defaultWriteObject();
  }

  public synchronized void removeMapAreaSelectedListener(MapAreaSelectedListener l)
  {
    if (mapAreaSelectedListeners != null && mapAreaSelectedListeners.contains(l))
    {
      Vector v = (Vector) mapAreaSelectedListeners.clone();
      v.removeElement(l);
      mapAreaSelectedListeners = v;
      if(mapAreaSelectedListeners.isEmpty())
      { for(int i=0;i<hotSpotCount;i++)
        {  ((GraphicHotSpot)hotSpots.elementAt(i)).removeHotSpotClickedListener(this);
        }

      }
    }

  }

  public synchronized void addMapAreaSelectedListener(MapAreaSelectedListener l)
  { if(!registered) //we have not registered the hotspot sub listeners
    {
      for(int i=0; i<hotSpotCount;i++)
      {GraphicHotSpot hs=null;
        try{
         hs=(GraphicHotSpot) ((Field)hotSpots.elementAt(i)).get(this);
         }
        catch(Exception e)
        { e.printStackTrace();
        }
        if(hs==null)
        {System.out.println("null at "+i);
        }

        hs.addHotSpotClickedListener(this);

        registered=true;

       // hs.addMouseListener(new Mouse);
      }
    }
    Vector v = mapAreaSelectedListeners == null ? new Vector(2) : (Vector) mapAreaSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      mapAreaSelectedListeners = v;
    }

  }


  protected void fireMapAreaSelected(MapAreaSelectedEvent e)
  {
    if (mapAreaSelectedListeners != null)
    {
      Vector listeners = mapAreaSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((MapAreaSelectedListener) listeners.elementAt(i)).mapAreaSelected(e);
      }
    }
  }

  //returns a vector of strings that has all the display names
  public Vector getAreaNames()
  { Vector returnVec=new Vector();
    if(this.hotSpots!=null)
    { Enumeration enum=hotSpots.elements();
      while(enum.hasMoreElements())
      {Field f=(Field)enum.nextElement();
       try{
        GraphicHotSpot gs=(GraphicHotSpot)f.get(this);
        if(!returnVec.contains(gs.getDisplayName()))
         returnVec.addElement(gs.getDisplayName());
        }
       catch(Exception e2)
       {e2.printStackTrace();
       }


      }

    }
    return returnVec;
  }

  public void hotSpotClicked(HotSpotClickedEvent e) {
    fireMapAreaSelected(new MapAreaSelectedEvent(((GraphicHotSpot)e.getSource()).getDisplayName() ));
  }

}