package edu.ucf.cs.dml.simnets.measureme;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

/**
 * Class which contains methods and constants for all of Measure Me.
 */
public class MeasureMeGlobal {

  /**
   * Time for wait statements in milliseconds.
   */
  public static final int WAIT_TIME = 125;

  /**
   * Flag which indicates if client has left the station.
   */
  public static boolean clientLeft;

  /**
   * Indicates if device (true) or user (false) initiates measurement.
   */
  public static boolean deviceActivated;


  public static String stationName = null;

  public static String ipAddress = "132.170.197.33"; // default server

  public static String scanCode = null;

  public static boolean takeTuple = true;

  public static boolean shuttingDown = false;

  /**
   * Static code.  Run once when class is loaded.
   */
  public static void init() {
    String value = System.getProperty("ipAddress");
    if (value == null) {
      System.out.println("Defaulting to IP address = " + ipAddress);
    }
    else {
      ipAddress = value;
      System.out.println("IP address = " + ipAddress);
    }
    value = System.getProperty("scanCode");
    if (value != null) {
      scanCode = value;
      System.out.println("Scan code = " + scanCode);
    }
    value = System.getProperty("takeTuple");
    if (value != null) {
      takeTuple = Boolean.getBoolean(value);
      System.out.println("Take tuple = " + takeTuple);
    }
  }

  /**
   * Static code.  Run once when class is loaded.
   */
//  {
//    String value = System.getProperty("runOption");
//    if (value == null) {
//      System.out.println("No runOption parameter found.  Defaulting to serial device.");
//      // default is to use serial connection if no property found on command line
//      runOption = USE_PHYSICAL_DEVICE;
//    }
//    else {
//      // try to convert from String to int
//      try {
//        runOption = Integer.parseInt(value);
//        System.out.println("Successfully parsed runOption parameter: "+runOption);
//      }
//      catch (NumberFormatException e) {
//        System.out.println("Unrecognized value for runOption parameter on command-line!");
//        // if property not an int then default to serial connection
//        runOption = USE_PHYSICAL_DEVICE;
//      }
//    }
//
//  }




//  public static int runOption;
  public static final int USE_PHYSICAL_DEVICE = 1;
  public static final int USE_DEVICE_SIMULATOR = 2;





} // MeasureMeGlobal