package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import com.borland.jbcl.control.*;
import com.borland.jbcl.layout.*;
import java.util.*;
import java.net.URL;
import java.lang.reflect.*;
import java.awt.font.TextLayout;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */


public class AddCurvePanel extends JPanel implements Runnable{
  xAxisPanel xPanel1=new xAxisPanel(11,45);
  yAxisPanel yPanel1=new yAxisPanel(9,40,380);
  Object[] xLabels={"","3","4","5","6","7","8","9","10","11","12"};
  Object[] yLabels={" 5","10","15","20","25","30","35","40","45"};
  boolean bCurve=false;
  boolean bCalc=false;
  protected int numpoints=6;
  protected double t;
  protected double k=.05;
  TransparentImage caption1=new TransparentImage();
  TransparentImage stick3=new TransparentImage();
  JTextArea instr=new JTextArea();
  protected final int CELL_WIDTH = 16;
  protected final int CELL_HEIGHT = 8;
  protected final int PARTITION_COUNT = 32;
  protected Point[] malePoints = new Point[6];
  protected Point[] fmlePoints=new Point[6];
  protected Point[] control=new Point[6];
  protected boolean bPainting=false;
  protected int CELL_BASE_LINE = 380; //the lowest y coordinate for cell drawing
  protected int y=0;
  protected Integer[] dataSet = null;
  boolean bClear=false;
  protected int x=54;
  boolean introAnim=false;
  Vector buttonData=new Vector();
  boolean bAnim=false;
  Thread myRunThread=null;
  Image grnDollar=null;
  Image redDollar=null;
  protected transient Vector curveDrawingCompletedListeners;
  protected transient Vector AnimCompletedListeners;
  protected transient Vector SleepCompletedListeners;
  XYLayout xYLayout1 = new XYLayout();
  TitledBorder titledBorder1;

  public AddCurvePanel()
  {
    jbInit();
  }

  public void jbInit()
  { titledBorder1 = new TitledBorder("");
    xYLayout1.setWidth(512);
    xYLayout1.setHeight(450);
    this.setBackground(Color.white);
    this.setLayout(xYLayout1);
    caption1.setDrawEdge(false);
    instr.setLineWrap(true);
    instr.disable();
    instr.setDisabledTextColor(Color.white);
    instr.setWrapStyleWord(true);
    instr.setFont(new java.awt.Font("SansSerif",1,20));
    instr.setForeground(Color.white);
    instr.setBackground(Color.blue);
    stick3.setDrawEdge(false);
    try
    {
      caption1.setImageName("c:\\analysisart\\Caption487x240.gif");
      stick3.setImageName("c:\\analysisart\\Stick240x240.gif");
      grnDollar=Toolkit.getDefaultToolkit().getImage("c:\\analysisart\\GreenMoney.gif");
      redDollar=Toolkit.getDefaultToolkit().getImage("c:\\analysisart\\RedMoney.gif");
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    caption1.setVisible(true);
    instr.setText("You own a roller skating rink that holds many different events.  Your job is to order skates for your rental stock in preparation for these events.  I will give you an example.");
    instr.setBackground(new Color(51,102,255));
    instr.setVisible(true);
    stick3.setVisible(false);

    this.add(xPanel1, new XYConstraints(25, 381, 512, 49));
    this.add(yPanel1,new XYConstraints(0,0,25,380));
    this.add(instr, new XYConstraints(75,25,387,190));
    this.add(caption1,new XYConstraints(25,0,-1,-1));
    this.add(stick3,new XYConstraints(295,10,-1,-1));
  }

  public void setDataSet(Integer[] newDataSet,String evnt)
  {
    bCurve=true;
    dataSet = newDataSet;
    computeNewDataSet(evnt);
    repaint();
    fireCurveDone(new CurveDrawingCompletedEvent(this));
  }

  protected void computeNewDataSet(String evnt)
   {
      if(evnt.equals("gala"))
      {
        malePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*19));
        malePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*40));
        malePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*40));
        malePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*19));
        fmlePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*21));
        fmlePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*21));
        fmlePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
      }
      else if(evnt.equals("prom"))
      {
        malePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*7));
        malePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*22));
        malePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        malePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*7));
        fmlePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*7));
        fmlePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*22));
        fmlePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*9));
        fmlePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));

      }
      else if(evnt.equals("NBA"))
      {
        malePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*9));
        malePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
      }
      else
      {
        malePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        malePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*3));
        malePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*18));
        malePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[0]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*42));
        fmlePoints[1]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*18));
        fmlePoints[2]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*3));
        fmlePoints[3]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[4]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
        fmlePoints[5]=new Point(0,CELL_BASE_LINE-(CELL_HEIGHT*0));
      }
  } // computeNewDataSet

  protected void paintAxisLabels(Graphics g)
  {
    // x axis
    g.drawLine(25, CELL_BASE_LINE, PARTITION_COUNT*CELL_WIDTH, CELL_BASE_LINE);
    // y axis
    g.drawLine(25, CELL_BASE_LINE, 25, (int)(CELL_BASE_LINE - (CELL_BASE_LINE-20)));
    xPanel1.setScoreLabels(xLabels,"SIZES");
    yPanel1.setScoreLabels(yLabels);

  } // paintXAxisLabels

  protected void paintComponent(Graphics g)
  { Integer b;
    bPainting=true;

    super.paintComponent(g);
    this.paintAxisLabels(g);

    if(bClear==false && bCalc==false)
    { x=54;
      y=CELL_BASE_LINE-CELL_HEIGHT;
      System.out.println(buttonData.size());
      for(int i=0;i<buttonData.size()/2;i++)
      {
        for(int p=0;p<((Integer)buttonData.elementAt(i)).intValue();p++)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(Color.blue);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y-CELL_HEIGHT;
        }
        x=x+45;
        y=CELL_BASE_LINE-CELL_HEIGHT;
      }
      x=70;
      y=CELL_BASE_LINE-CELL_HEIGHT;
      for(int i=10;i<buttonData.size();i++)
      {
        for(int p=0;p<((Integer)buttonData.elementAt(i)).intValue();p++)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(Color.yellow);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y-CELL_HEIGHT;
        }
        x=x+45;
        y=CELL_BASE_LINE-CELL_HEIGHT;
      }
    }
    if(bCalc==true && bClear==false)
    { x=54;
      int p=0;
      y=CELL_BASE_LINE-CELL_HEIGHT;
      for(int i=0;i<buttonData.size()/2;i++)
      {
        for(p=0;(p<((Integer)buttonData.elementAt(i)).intValue()) && (p< dataSet[i].intValue());p++)
        {
          g.drawImage(grnDollar,x,y,this);
          y=y-CELL_HEIGHT;
        }
        for(;p<((Integer)buttonData.elementAt(i)).intValue();p++)
        { g.drawImage(redDollar,x,y,this);
          y=y-CELL_HEIGHT;
        }

        for(p=((Integer)buttonData.elementAt(i)).intValue();p<dataSet[i].intValue();p++)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          y=y-CELL_HEIGHT;
        }
        x=x+45;
        y=CELL_BASE_LINE-CELL_HEIGHT;
      }

      x=70;
      y=CELL_BASE_LINE-CELL_HEIGHT;
      for(int i=10;i<buttonData.size();i++)
      {
        for(p=0;(p<((Integer)buttonData.elementAt(i)).intValue()) && (p< dataSet[i].intValue());p++)
        {
          g.drawImage(grnDollar,x,y,this);
          y=y-CELL_HEIGHT;
        }
        for(;p<((Integer)buttonData.elementAt(i)).intValue();p++)
        {
          g.drawImage(redDollar,x,y,this);
          y=y-CELL_HEIGHT;
        }
        for(p=((Integer)buttonData.elementAt(i)).intValue();p<dataSet[i].intValue();p++)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          y=y-CELL_HEIGHT;
        }
        x=x+45;
        y=CELL_BASE_LINE-CELL_HEIGHT;
      }
    }
    if(bCurve==true && bClear==false)
    { Point[] points=new Point[6];
      int x1,y1,x2,y2;
      Stroke oldStroke=((Graphics2D)g).getStroke();
      ((Graphics2D)g).setStroke(new BasicStroke(8.0f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));

      //Change interpolating points into control points
      int increment = (int)((PARTITION_COUNT*CELL_WIDTH-25)/(numpoints-1));
      for(int i=0;i<numpoints;i++)
        points[i] = new Point((i*increment)+25,malePoints[i].y);

      g.setColor(Color.blue);
      for(int r=0;r<2;r++)
      { control[0] = new Point(points[0].x,points[0].y);
        control[numpoints-1] = new Point(points[numpoints-1].x,
        points[numpoints-1].y);
        x1=(int)(1.6077*(double)points[1].x-.26794*(double)points[0].x-
          .43062*(double)points[2].x+.11483*(double)points[3].x-
          .028708*(double)points[4].x+.004785*(double)points[5].x);
        y1=points[1].y;
        control[1] = new Point(x1,y1);
        x1=(int)(-.43062*(double)points[1].x+.07177*(double)points[0].x+
          1.7225*(double)points[2].x-.45933*(double)points[3].x+
          .11483*(double)points[4].x-.019139*(double)points[3].x);
        y1=(int)(-.43062*(double)points[1].y+.07177*(double)points[0].y+
          1.7225*(double)points[2].y-.45933*(double)points[3].y+
          .11483*(double)points[4].y-.019139*(double)points[3].y);
        control[2] = new Point(x1,y1);
        x1=(int)(.11483*(double)points[1].x-.019139*(double)points[0].x-
          .45933*(double)points[2].x+1.7225*(double)points[3].x-
          .43062*(double)points[4].x+.07177*(double)points[5].x);
        y1=(int)(.11483*(double)points[1].y-.019139*(double)points[0].y-
          .45933*(double)points[2].y+1.7225*(double)points[3].y-
          .43062*(double)points[4].y+.07177*(double)points[5].y);
        control[3] = new Point(x1,y1);
        x1=(int)(-.028708*(double)points[1].x+.004785*(double)points[0].x+
          .114835*(double)points[2].x-.43062*(double)points[3].x+
          1.6077*(double)points[4].x-.26794*(double)points[5].x);
        y1=(int)(-.028708*(double)points[1].y+.004785*(double)points[0].y+
          .114835*(double)points[2].y-.43062*(double)points[3].y+
          1.6077*(double)points[4].y-.26794*points[5].y);
        control[4] = new Point(x1,y1);

        //draw n bezier curves using Bernstein Polynomials
        x1=points[0].x;
        y1=points[0].y;
        for(int i=1;i<numpoints;i++) {
          for(t=i-1;t<=i;t+=k) {
            x2=(int)((double)points[i-1].x+(t-(i-1))*(-3*(double)points[i-1].x
              + 3*(.6667*(double)control[i-1].x+.3333*(double)control[i].x)+
              (t-(i-1))*(3*(double)points[i-1].x-6*(.6667*(double)control[i-1
              ].x+.3333*(double)control[i].x)+3*(.3333*(double)control[i-1].x+
              .6667*(double)control[i].x)+(-(double)points[i-1].x+
              3*(.6667*(double)control[i-1].x+.3333*(double)control[i].x)-
              3*(.3333*(double)control[i-1].x+.6667*(double)control[i].x)+
              (double)points[i].x)*(t-(i-1)))));
            y2=(int)((double)points[i-1].y+(t-(i-1))*(-3*(double)points[i-1].y
              + 3*(.6667*(double)control[i-1].y+.3333*(double)control[i].y)+
              (t-(i-1))*(3*(double)points[i-1].y-6*(.6667*(double)control[i-1
              ].y+ .3333*(double)control[i].y)+3*(.3333*(double)control[i-1].y+
              .6667*(double)control[i].y)+(-(double)points[i-1].y+
              3*(.6667*(double)control[i-1].y+.3333*(double)control[i].y)-
              3*(.3333*(double)control[i-1].y+.6667*(double)control[i].y)+
              (double)points[i].y)*(t-(i-1)))));

            g.drawLine(x1,y1,x2,y2);
            x1=x2;
            y1=y2;
          }
        }
        for(int i=0;i<numpoints;i++)
          points[i] = new Point((i*increment)+25,fmlePoints[i].y);


        g.setColor(Color.yellow);
      }

      ((Graphics2D)g).setStroke(oldStroke);
      bPainting=false;

    } // drawCurve

  }
  public void clearAllIcons()
  {
    repaint();
  } // clearAllIcons

  public void run()
  {
    buttonData.removeAllElements();
    try
    {
      Thread.sleep(1500);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
    fireSleepDone(new SleepCompletedEvent (this));
    for(int i=1;i<=15 && bAnim==true;i++)
    { for(int p=0;p<20;p++)
        buttonData.addElement(new Integer(i));
      System.out.println(buttonData.elementAt(0));
      repaint();
      try
      {
        Thread.sleep(600);
      }
      catch(Exception e)
      {
        e.printStackTrace();
      }

      buttonData.removeAllElements();
      fireAnimDone(new AnimCompletedEvent (this));
    }
  }

  public void paintRows(Vector v)
  { buttonData=v;
    System.out.println("Before repaint");
    repaint();
  }

  public synchronized void addCurveDrawingCompletedListener(CurveDrawingCompletedListener l)
  {
    Vector v = curveDrawingCompletedListeners == null ? new Vector(2) : (Vector) curveDrawingCompletedListeners.clone();
    if (!v.contains(l))
    { v.addElement(l);
      curveDrawingCompletedListeners = v;
    }
  } // addCurveDrawingCompletedListener

  protected void fireCurveDone(CurveDrawingCompletedEvent e)
  {
    if (curveDrawingCompletedListeners != null)
    {
      Vector listeners = curveDrawingCompletedListeners;
      int count = listeners.size();

      for (int i = 0; i < count; i++)
      {
        ((CurveDrawingCompletedListener) listeners.elementAt(i)).curveDone(e);
      }
    }
  } // fireCurveDone

  public synchronized void removeCurveDrawingCompletedListener(CurveDrawingCompletedListener l)
  { if(curveDrawingCompletedListeners!=null && curveDrawingCompletedListeners.contains(l))
    { Vector v=(Vector)curveDrawingCompletedListeners.clone();
      v.removeElement(l);
      curveDrawingCompletedListeners=v;
    }
  }

  public void start()
  {
    myRunThread=new Thread(this);
    myRunThread.start();
  }
  public void stop()
  { System.out.println("thread stopped");
    myRunThread=null;
  }

  public synchronized void addAnimCompletedListener(AnimCompletedListener l)
  { Vector v = AnimCompletedListeners == null ? new Vector(2) : (Vector) AnimCompletedListeners.clone();
    if (!v.contains(l))
    { v.addElement(l);
      AnimCompletedListeners = v;
    }
  } // addAnimCompletedListener

  public synchronized void addSleepCompletedListener(SleepCompletedListener l)
  {
    Vector v = SleepCompletedListeners == null ? new Vector(2) : (Vector) SleepCompletedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      SleepCompletedListeners = v;
    }
  } // addSleepCompletedListener
  protected void fireAnimDone(AnimCompletedEvent e)
  {
    if (AnimCompletedListeners != null)
    {
      Vector listeners = AnimCompletedListeners;
      int count = listeners.size();
      System.out.println(count);
      for (int i = 0; i < count; i++)
      { ((AnimCompletedListener) listeners.elementAt(i)).animDone(e);
      }
    }
  } // fireAnimDone
  protected void fireSleepDone(SleepCompletedEvent e)
  {
    if (SleepCompletedListeners != null)
    {
      Vector listeners = SleepCompletedListeners;
      int count = listeners.size();
      System.out.println(count);
      for (int i = 0; i < count; i++)
      {
        ((SleepCompletedListener) listeners.elementAt(i)).sleepDone(e);
      }
    }
  } // fireSleepDone
  public synchronized void removeAnimCompletedListener(AnimCompletedListener l)
  { if(AnimCompletedListeners!=null && AnimCompletedListeners.contains(l))
    { Vector v=(Vector)AnimCompletedListeners.clone();
      v.removeElement(l);
      AnimCompletedListeners=v;
    }
  }
  public synchronized void removeSleepCompletedListener(SleepCompletedListener l)
  { if(SleepCompletedListeners!=null && SleepCompletedListeners.contains(l))
    { Vector v=(Vector)SleepCompletedListeners.clone();
      v.removeElement(l);
      SleepCompletedListeners=v;
    }
  }
}
