package edu.ucf.cs.dml.simnets.measureme.analysis;
import java.awt.*;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Image;
import edu.ucf.cs.dml.simnets.measureme.dbase.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */

public class EvaluatorPanel extends JPanel implements Runnable{
  JButton tryAgain=new JButton();
  JButton backToMen=new JButton();
  XYLayout xYLayout1=new XYLayout();
  Integer tNum=null;
  JTextArea eval=new JTextArea();
  TransparentImage caption=new TransparentImage();
  AnalysisServiceInterface asi=null;
  int lastScore;
  int intrval;
  boolean bAnim=false;
  xAxisPanel xPanel1=new xAxisPanel(11,45);
  yAxisPanel yPanel1=new yAxisPanel(9,40,420);
  JTextArea yLabel=new JTextArea();
  Object[] xLabels=null;
  Object[] yLabels={" 5","10","15","20","25","30","35","40","45"};

  Vector scores=new Vector();
  Vector animData=new Vector();
  ImageIcon tryIcon=null;
  ImageIcon menuIcon=null;
  int CELL_BASE_LINE=450;
  int CELL_WIDTH=45;
  String unts=null;
  Image star=null;
  int xPos;
  int yPos;
  boolean bClear=false;
  boolean bStar=false;
  Thread myRunThread;
  String scoreField=null;
  public EvaluatorPanel(Object[] o,String unts,String scoreField, AnalysisServiceInterface asi) {
    this.asi=asi;
    xLabels=o;
    this.scoreField=scoreField;
    this.unts=unts;
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);

    yLabel.setLineWrap(true);
    yLabel.disable();
    yLabel.setDisabledTextColor(Color.black);
    yLabel.setWrapStyleWord(true);
    yLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    yLabel.setText("Number of People With This Score");
    star=Toolkit.getDefaultToolkit().getImage("c:\\analysisart\\lrgstar.gif");


    this.setBackground(Color.white);
    this.setLayout(xYLayout1);
    eval.setBackground(Color.yellow);
    try
    {caption.setImageName("c:\\analysisart\\Hero6capt200x450yellow.gif");
    }
    catch(Exception e)
    {
    }
    caption.setDrawEdge(false);

    this.add(backToMen,new XYConstraints(580,500,150,50));
    this.add(tryAgain,new XYConstraints(410,500,150,50));
    this.add(xPanel1, new XYConstraints(75, 451, 557, 49));
    this.add(yPanel1, new XYConstraints(50,30,25,420));
    this.add(yLabel, new XYConstraints(5,75,45,300));

    eval.setWrapStyleWord(true);
    eval.setFont(new java.awt.Font("SansSerif", 1, 16));
    eval.setForeground(Color.black);
    eval.setLineWrap(true);
    eval.disable();
    eval.setDisabledTextColor(Color.black);


    tryIcon=new ImageIcon("C:\\analysisart\\tryagainorange.gif");
    menuIcon=new ImageIcon("C:\\analysisart\\backmenuorange.gif");
    this.tryAgain.setIcon(tryIcon);
    this.tryAgain.setDisabledIcon(tryIcon);
    tryAgain.setBackground(Color.white);
    tryAgain.setRequestFocusEnabled(false);
    tryAgain.setBorderPainted(false);
    this.backToMen.setIcon(menuIcon);
    this.backToMen.setDisabledIcon(menuIcon);
    backToMen.setBackground(Color.white);
    backToMen.setRequestFocusEnabled(false);
    backToMen.setBorderPainted(false);
    backToMen.setEnabled(false);
    tryAgain.setEnabled(false);
    this.add(eval,new XYConstraints(610,60,140,350));
    this.add(caption,new XYConstraints(580,10,-1,-1));

  }

  protected void paintComponent(Graphics g)
 {  int x;
    super.paintComponent(g);
    this.paintAxisLabels(g);

    if(bClear==false)
    { for(int i=0;i<animData.size();i++)
      {
        x=75+(i*CELL_WIDTH);
        g.setColor(Color.black);

        g.drawRect(x,CELL_BASE_LINE-(((Integer)animData.elementAt(i)).intValue()*8),CELL_WIDTH,(((Integer)animData.elementAt(i)).intValue()*8));
        if(i%2==0)
          g.setColor(Color.red);
        else
          g.setColor(new Color(255,127,0));
        g.fillRect(x+1,CELL_BASE_LINE-(((Integer)animData.elementAt(i)).intValue()*8)+1,CELL_WIDTH-1,(((Integer)animData.elementAt(i)).intValue()*8)-1);

      }

    }
    if(bStar==true)
      g.drawImage(star,xPos,yPos,this);

  }

  protected void paintAxisLabels(Graphics g) {
    // x axis
    g.setColor(Color.black);
    g.drawLine(75, CELL_BASE_LINE, 10*45 + 75, CELL_BASE_LINE);
    // y axis
    g.drawLine(75, CELL_BASE_LINE, 75, (int)(CELL_BASE_LINE-360));
    xPanel1.setScoreLabels(xLabels,unts);
    yPanel1.setScoreLabels(yLabels);

} // paintXAxisLabels


 public void run()
 {

    int i;
    for(int p=0;p<scores.size() && bAnim==true;p++)
    {
      for(int m=1;m<=((Integer)scores.elementAt(p)).intValue();m++)
      {   animData.setElementAt(new Integer(m),p);
            repaint();
            try{
              Thread.sleep(50);
            }
            catch(Exception e)
            {
            }
      }
   }


  boolean bFound=false;

  for(i=0;i<11 && bFound==false;i++)
  { if(lastScore >= new Integer(((String)xLabels[i])).intValue())
      bFound=false;
    else
      bFound=true;
  }
   int x;
   int y;
   if(intrval<=45)
   { intrval=45/intrval;
      x=75+((i-2)*CELL_WIDTH)+ ((lastScore -  new Integer(((String)xLabels[i-2])).intValue())*9);
   }
   else
   {  int seg=(int)(intrval/45);
      x=75+((i-2)*CELL_WIDTH)+ (int)((lastScore -  new Integer(((String)xLabels[i-2])).intValue())/seg);
  }
   if(x==75)
    x=x+9;
  y=CELL_BASE_LINE-(((Integer)scores.elementAt(i-2)).intValue()*8);

  int totalNum=0;
  for(int n=0;n<scores.size();n++)
    totalNum=totalNum + ((Integer)scores.elementAt(n)).intValue();
  int prcnt=0;

  for(int n=i-2;n>=0;n--)
    prcnt=prcnt + ((Integer)scores.elementAt(n)).intValue();

  float q=((float)(prcnt))/((float)(totalNum));
  prcnt=(int)(q *100f);

  eval.setText("Your score is represented by the star." + "\n\n" + "Out of " + new Integer(totalNum).toString() + " people who have visited this exhibit, you are in the lower " + new Integer(prcnt).toString() + " percentile." + "\n\n" + "This means that " + new Integer(prcnt).toString() + " out of 100 people scored lower than you on this activity.");
  bStar=true;
  for(int t=80;t<=(x-20);t+=2)
  {   xPos=t;
      yPos=0;
      repaint();

      try{
              Thread.sleep(20);
            }
            catch(Exception e)
            {
            }
  }

  int r;
  for(r=0;r<=(y-20);r+=2)
  {  xPos=x-20;
     yPos=r;
     repaint();

      try{
              Thread.sleep(20);
            }
            catch(Exception e)
            {
            }
  }
  if(r!=(y-20))
  {  xPos=x-20;
     yPos=y-20;
     repaint();
  }



   backToMen.setEnabled(true);
    tryAgain.setEnabled(true);
 }
 void setScores()
 {  eval.setText("This graph shows the scores of other people who have visited this exhibit." + "\n\n" +  "How does your score on this activity compare to others?");

  bClear=false;
  scores.removeAllElements();
  animData.removeAllElements();
  QueryResults qr=null;
  Integer tNum=null;
  float pcnt=0f;
  qr=this.asi.performQuery(new QueryReplyRequest("select * from " + scoreField ,"Sheeat",true));
  ResultHolder rh=qr.getResults();
  int columnCt =rh.getColumnCount();
  Vector v=rh.getColumn(columnCt);
  System.out.println("Col count" + columnCt);
  Short[] s=((Short[])v.get(0));
  int ttal=0;

  for(int r=0;r<s.length;r++)
  { ttal+=(int)(s[r].shortValue());
  }
  System.out.println("Number of people with score values for " + scoreField + " is " + ttal);
  Integer totNum=new Integer(ttal);
    //use dummy values until we get more than 200 scores into the DB

    if(totNum.intValue()<200)
    {   scores.addElement(new Integer(10));
        scores.addElement(new Integer(14));
        scores.addElement(new Integer(23));
        scores.addElement(new Integer(33));
        scores.addElement(new Integer(45));
        scores.addElement(new Integer(31));
        scores.addElement(new Integer(20));
        scores.addElement(new Integer(16));
        scores.addElement(new Integer(6));
        scores.addElement(new Integer(2));
    }

    else

    //get number of people with scores in each range and divide by the total number of people with scores
    // multipy that percentage by 45 to get the graph value
    {
      for(int p=0;p<s.length;p++)
      {  tNum=new Integer((int)s[p].shortValue());
         pcnt=((float)tNum.intValue()/totNum.intValue());
         scores.addElement(new Integer((int)(pcnt * 45)));
      }
    }


  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));
  animData.addElement(new Integer(0));



 }



 void resetAll()
 {
    this.myRunThread=null;
    while(myRunThread!=null)
    {
    }
    bAnim=false;
     bStar=false;

    backToMen.setEnabled(false);
    tryAgain.setEnabled(false);
    bClear=true;
    repaint();
 }
  public void start()
  {
    myRunThread=new Thread(this);
    myRunThread.start();
  }
  void startAnim(int lastScore,int intrval)
  { this.lastScore=lastScore;
    this.intrval=intrval;
    bAnim=true;
    setScores();
    this.start();
  }

}