package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import com.borland.jbcl.control.*;
import com.borland.jbcl.layout.*;
import java.util.*;
import java.net.URL;
import java.lang.reflect.*;
import java.awt.font.TextLayout;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */



public class HeroGraphPanel extends JPanel implements Runnable{
  xAxisPanel xPanel1=new xAxisPanel(8,48);
  yAxisPanel yPanel1=new yAxisPanel(7,50,370);
  Object[] xLabels={"0","1","2","3","4","5","6",">6"};
  Object[] yLabels={" 12"," 25"," 50","100","150","200",">250"};
  protected boolean bCurve=false;
  protected int CELL_WIDTH = 6;
  protected int CELL_HEIGHT = 4;
  protected Vector realData=new Vector();
  protected int CELL_BASE_LINE = 370; //the lowest y coordinate for cell drawing
  protected int y=0;
  protected Integer[] dataSet = null;
  protected boolean bClear=false;
  protected int[] sizesOrd=null;
  protected int x=54;
  protected Integer[] buttonData=new Integer[7];
  protected Thread myRunThread=null;
  XYLayout xYLayout1 = new XYLayout();

  public HeroGraphPanel() {
    xYLayout1.setWidth(400);
    xYLayout1.setHeight(420);
    this.setBackground(Color.white);
    this.setLayout(xYLayout1);

    this.add(xPanel1, new XYConstraints(40, 371, 500, 49));
    this.add(yPanel1, new XYConstraints(0,0,40,370));
  }

  public void setDataSet(Vector newDataSet, int[] szOrd)
  {
    int p;
    bCurve=true;
    realData = newDataSet;
    sizesOrd=szOrd;
    for(int z=0;z<7;z++)
    { p=sizesOrd[z]-((Vector)realData.elementAt(z)).size();
      if(p<0)
        p=0;
      buttonData[z]=new Integer(p);
    }
    repaint();
  } // setDataSet

  protected void paintAxisLabels(Graphics g)
  {
    // x axis
    g.drawLine(40, CELL_BASE_LINE, 48*7 + 40, CELL_BASE_LINE);
    // y axis
    g.drawLine(40, CELL_BASE_LINE, 40, (int)(CELL_BASE_LINE - (CELL_BASE_LINE-20)));
    xPanel1.setScoreLabels(xLabels,"Height In Feet");
    yPanel1.setScoreLabels(yLabels);
  } // paintXAxisLabels

  protected void paintComponent(Graphics g)
  {

    Color boxColor;
    System.out.println("Paint");
    super.paintComponent(g);
    for(int i=0;i<7;i++)
    { if(i==0)
      { g.drawLine(40,370-(i+1)*50,40+((i+2)*48),370-(i+1)*50);
        g.drawLine(40+((i+2)*48),370-(i+1)*50,40+((i+2)*48),CELL_BASE_LINE);
      }
      else if(i==1)
      { g.drawLine(40,370-(i+1)*50,40+((i+1)*48)+((int)48/2),370-(i+1)*50);
        g.drawLine(40+((i+1)*48)+((int)48/2),370-(i+1)*50,40+((i+1)*48)+((int)48/2),CELL_BASE_LINE);
      }
      else
      { g.drawLine(40,370-(i+1)*50,40+((i+1)*48),370-(i+1)*50);
        g.drawLine(40+((i+1)*48),370-(i+1)*50,40+((i+1)*48),CELL_BASE_LINE);
      }
    }
    this.paintAxisLabels(g);

    if(bClear==false)
    {
      if(bCurve==true)
        boxColor=Color.red;
      else
        boxColor=Color.blue;
      int itr;
      int k;
      for(int i=0;i<4;i++)
      { CELL_HEIGHT=4;
        CELL_WIDTH=6;

        x=40+((6-i+1)*48)-CELL_WIDTH;
        y=370-(6-i+1)*50;
        k=buttonData[i].intValue();
        itr=(int)(k/5);
        int p;
        for(p=0;p<itr;p++)
        { if(p%2==0)
            x=40+((6-i+1)*48)-CELL_WIDTH;
          else
            x=40+((6-i+1)*48)-CELL_WIDTH*5;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x+CELL_WIDTH;
          y=y+CELL_HEIGHT;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y+CELL_HEIGHT;
          x=x+CELL_WIDTH;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          if(p%2!=0)
            y=y+CELL_HEIGHT *2;
          else
            y=y-CELL_HEIGHT*2;
        }
        itr=k%5;
        if((p-1)%2==0)
          x=40+((6-i+1)*48)-CELL_WIDTH*5;
        else
          x=40+((6-i+1)*48)-CELL_WIDTH;
        if(itr!=0)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
        }
        if(itr>1)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x+CELL_WIDTH;
          y=y+CELL_HEIGHT;
        }
        if(itr>2)
        {
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y+CELL_HEIGHT;
          x=x+CELL_WIDTH;
        }
        if(itr>3)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
        }
      }
      int numCols;
      for(int i=4;i<7;i++)
      { if(i==6)
        { CELL_WIDTH=3;
          CELL_HEIGHT=2;
          x=40+((6-i+2)*48)-CELL_WIDTH;
        }
        else if(i==5)
        { CELL_WIDTH=5;
          x=40+(int)((6-i+1.5)*48)-CELL_WIDTH;
          CELL_HEIGHT=2;
        }
        else
        { CELL_HEIGHT=3;
          CELL_WIDTH= 6;
          x=40+((6-i+1)*48)-CELL_WIDTH;
        }
        numCols=(int)((6-i+1)*50)/(CELL_HEIGHT*5);
        if(i==6 && numCols>4)
          numCols=4;
        y=370-(6-i+1)*50;
        k=buttonData[i].intValue();
        itr=(int)(k/5);
        int p;
        for(p=0;p<itr && p<numCols;p++)
        {
          if(i==6)
            x=40+((6-i+2)*48)-CELL_WIDTH;
          else if(i==5)
            x=40+(int)((6-i+1.5)*48)-CELL_WIDTH;
          else
            x=40+((6-i+1)*48)-CELL_WIDTH;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x+CELL_WIDTH;
          y=y+CELL_HEIGHT;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y+CELL_HEIGHT;
          x=x+CELL_WIDTH;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);

          y=y+CELL_HEIGHT *2;

        }
        if(p==numCols && p<itr)
        { y=370-(6-i+1)*50;

        }
        while(p<itr)
        { if(p%2==0)
            x=x-CELL_WIDTH*2;
          else
            x=x+CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x+CELL_WIDTH;
          y=y+CELL_HEIGHT;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y+CELL_HEIGHT;
          x=x+CELL_WIDTH;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);

          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);

          if(p%2==0)
            y=y+CELL_HEIGHT *2;
          else
            y=y-CELL_HEIGHT*6;
          p++;
        }
        if(p%2==0 && p>numCols)
          x=x-CELL_WIDTH*2;
        else if (p!=0)
          x=x+CELL_WIDTH*2;
        itr=k%5;

        if(itr!=0)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
        }
        if(itr>1)
        {
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x+CELL_WIDTH;
          y=y+CELL_HEIGHT;
        }
        if(itr>2)
        {
          g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          y=y+CELL_HEIGHT;
          x=x+CELL_WIDTH;
        }
        if(itr>3)
        { g.setColor(Color.black);
          g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
          g.setColor(boxColor);
          g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          x=x-CELL_WIDTH*2;
        }
      }

      if(bCurve==true)
      {
        CELL_WIDTH=4;
        CELL_HEIGHT=4;
        System.out.println(((Float)((Vector)((Vector)realData.elementAt(0)).elementAt(0)).elementAt(0)).floatValue());
        for(int z=0;z<7;z++)
        { for(int i=0;i<((Vector)realData.elementAt(z)).size();i++)
          {
            Float h=new Float(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(0)).floatValue()/12f);
            Float m=new Float(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(0)).floatValue());
            Float s=new Float(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue());
            x=(40 + (h.intValue()*48))+((m.intValue()%12)*4)-2;

            if(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()>=50f)
            { Float r=new Float(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()/50f);
              y=370-((r.intValue()+2)*50) - (s.intValue()%50)-2;
            }
            else if(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()< 50f &&((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()>=25f)
              y=370-100-((s.intValue()%25)*2)-2;
            else if(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()< 25f)
            { if(((Float)((Vector)((Vector)realData.elementAt(z)).elementAt(i)).elementAt(1)).floatValue()< 12f)
                y=370-((s.intValue()%12)*4)-2;
              else
                y=370-50-((s.intValue()%12)*4)-2;
            }
            g.setColor(Color.black);
            g.drawRect(x,y,CELL_WIDTH,CELL_HEIGHT);
            if(i<sizesOrd[z])
              boxColor=Color.green;
            else
              boxColor=Color.white;

            g.setColor(boxColor);
            g.fillRect(x+1,y+1,CELL_WIDTH-1,CELL_HEIGHT-1);
          }
        }
      }
    }
  }


  public void run()
  {
  }

  public void paintRows(Integer[] v)
  {  bClear=false;
     System.arraycopy(v,0,buttonData,0,7);
     repaint();
  }

  protected void clearAllIcons()
  { bClear=true;
    bCurve=false;
    repaint();
  }
}
