package edu.ucf.cs.dml.simnets.measureme.analysis;

import edu.ucf.cs.dml.simnets.measureme.server.*;
import edu.ucf.cs.dml.simnets.measureme.client.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import com.borland.jbcl.layout.*;
import java.util.*;
import com.borland.jbcl.control.*;
import java.sql.*;

//import java.applet.AudioClip;
//import javax.media.*;
//import com.sun.media.*;

public class NewAnalysisStationFrame extends JFrame {
  //implements ControllerListener
  JPanel contentPane;
  //AudioClip tycSound;
  private transient Vector clientLeavesStationListeners;
  private transient Vector clientEntersStationListeners;
  private transient Vector adminRequestListeners;
  KeyCodeHandler kkh=new KeyCodeHandler(this);
  //Player player=null;
  AnalysisServiceInterface asi=null;
  XYLayout xYLayout1=new XYLayout();
  //AudioClip heroSound;
  JPanel mainPanel = new JPanel();
  DiplomaPanel dip;
  TransparentImage transparentImage1 = new TransparentImage();
  TransparentImage transparentImage2 = new TransparentImage();
  HeroIntroPanel heroInt;
  CardLayout cardLayout1=new CardLayout();
  FriendPanel frnd;
  TycoonPanel tyc;
  HeroPanel hero;
  EvaluatorPanel evalTycoon;
  EvaluatorPanel evalHero;
  UniqueIntroPanel unIntro;
  FriendIntroPanel frndInt;
  TycoonIntroPanel tycInt;
  ImageIcon goIcon;
  JButton goBn=new JButton();
  Exhibitor currentExhibitor;
  AnalysisMenu menu;
  UniquePanel unPan;
  Object[] tycXLabels={"-900","-720","-540","-360","-180","0","180","360","540","720","900"};
  Object[] heroXLabels={"0","5","10","15","20","25","30","35","40","45","50","50"};

  public NewAnalysisStationFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

  }

  public NewAnalysisStationFrame(AnalysisServiceInterface asi)
  { enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.asi=asi;
    try
    {
      menu=new AnalysisMenu();
      unPan=new UniquePanel(asi);
      tyc=new TycoonPanel();
      unIntro=new UniqueIntroPanel();
      hero=new HeroPanel(asi);
      tycInt=new TycoonIntroPanel();
      frndInt=new FriendIntroPanel();
      frnd=new FriendPanel();
      evalTycoon=new EvaluatorPanel(tycXLabels,"Profit ($)","tycoonscores",asi);
      evalHero=new EvaluatorPanel(heroXLabels,"Lives Saved","heroscores",asi);
      heroInt=new HeroIntroPanel();
      dip=new DiplomaPanel();
      jbInit();
    }
    catch(Exception e)
    { e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    kkh.addClientEntersStationListener(new ClientEntersStationListener()
    {
      public void dataChanged(ClientEntersStationEvent e)
      {
        kkh_dataChanged(e);
      }
    });
    kkh.addClientLeavesStationListener(new ClientLeavesStationListener()
    {
      public void dataChanged(ClientLeavesStationEvent e)
      {
        kkh_dataChanged(e);
      }
    });
    kkh.addAdminRequestListener(new AdminRequestListener()
    {
      public void dataChanged(AdminRequestEvent e)
      {
        kkh_dataChanged(e);
      }
     });

    contentPane=(JPanel)this.getContentPane();
    contentPane.setLayout(cardLayout1);
    this.setSize(new Dimension(801,601));
    this.setTitle("Analysis Station");

    // M. Lowery edit 2001-05-14
    this.setResizable(false);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

    this.addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentMoved(ComponentEvent e)
      {
        this_componentMoved(e);
      }
      public void componentResized(ComponentEvent e)
      {
        this_componentResized(e);
      }
      public void componentHidden(ComponentEvent e)
      {
        this_componentHidden(e);
      }
    });

    /*
    java.io.File q = new java.io.File("c:\\analysismusic\\FinalCash.wav");

    try {
      tycSound = java.applet.Applet.newAudioClip(q.toURL());
      } catch (java.net.MalformedURLException e) {
      tycSound = null;
    }
    java.io.File r = new java.io.File("c:\\analysismusic\\BubbleFinal.au");

    try {
      heroSound = java.applet.Applet.newAudioClip(r.toURL());
      } catch (java.net.MalformedURLException e) {
      heroSound = null;
    }
     java.io.File f = new java.io.File("c:\\analysismusic\\KissFinal.wav");
      try {
          player = Manager.createPlayer(f.toURL());
	    } catch (Exception e) {
		System.out.println(e);

	    }
     player.addControllerListener(this);
    */
    mainPanel.setLayout(xYLayout1);
    transparentImage1.setImageName("C:\\analysisart\\NRulerGreen_F.gif");
    transparentImage2.setImageName("C:\\analysisart\\arrow150.gif");
    transparentImage1.setDrawEdge(false);
    transparentImage2.setDrawEdge(false);

    contentPane.add(mainPanel, "jPanel1");
    mainPanel.add(transparentImage1, new XYConstraints(24, 141, -1, -1));
    mainPanel.add(transparentImage2, new XYConstraints(338, 449, -1, -1));
    contentPane.add(unIntro,"Unique Intro");
    contentPane.add(tyc,"Tycoon");
    contentPane.add(heroInt,"Hero Intro");
    contentPane.add(evalTycoon,"Tycoon Evaluator");
    contentPane.add(hero,"Hero");
    contentPane.add(evalHero,"Hero Evaluator");
    contentPane.add(frnd,"Friend");
    contentPane.add(menu,"Menu");
    contentPane.add(unPan,"Unique");
    contentPane.add(dip,"Diploma");
    contentPane.add(frndInt,"Friend Intro");
    contentPane.add(tycInt,"Tycooon Intro");
    this.cardLayout1.addLayoutComponent(mainPanel,"jPanel1");
    this.cardLayout1.addLayoutComponent(tycInt,"Tycoon Intro");
    this.cardLayout1.addLayoutComponent(frndInt,"Friend Intro");
    this.cardLayout1.addLayoutComponent(unIntro,"Unique Intro");
    this.cardLayout1.addLayoutComponent(tyc,"Tycoon");
    this.cardLayout1.addLayoutComponent(heroInt,"Hero Intro");
    this.cardLayout1.addLayoutComponent(evalTycoon,"Tycoon Evaluator");
    this.cardLayout1.addLayoutComponent(hero,"Hero");
    this.cardLayout1.addLayoutComponent(evalHero,"Hero Evaluator");
    this.cardLayout1.addLayoutComponent(frnd,"Friend");
    this.cardLayout1.addLayoutComponent(menu,"Menu");
    this.cardLayout1.addLayoutComponent(unPan,"Unique");
    this.cardLayout1.addLayoutComponent(dip,"Diploma");
    unPan.vwDip.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { dip.setValueLabel(unPan.valString,currentExhibitor.getScanCode());
        uniShowDiploma();
      }
    });;

    heroInt.goBn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showHero();
      }
    });;
    frndInt.goBn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showFriend();
      }
    });;
    tycInt.goBn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showTycoon();
      }
    });;


    unIntro.goBn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showUnique();
      }
    });;
    dip.backToMen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { dipShowMenu();
      }
    });;

    unPan.menuBtn.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { uniShowMenu();
      }
    });

    evalTycoon.tryAgain.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        tycoonReset();
      }
    });
    evalHero.tryAgain.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { heroReset();
      }
    });
    frnd.tryAgain.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { friendReset();
      }
    });
    evalTycoon.backToMen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { tycShowMenu();
      }
    });
    evalHero.backToMen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { heroShowMenu();
      }
    });
    frnd.backToMen.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { frndShowMenu();
      }
    });

    tyc.goBn2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { goTycoon_actionPerformed();
      }
    });
    hero.goBn2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { goHero_actionPerformed();
      }
    });

    menu.frnd.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showFrnd_actionPerformed();
      }
    });
    menu.tycoon.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showTycoon_actionPerformed();
      }
    });
    menu.hero.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showHero_actionPerformed();
      }
    });
    menu.unique.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      { showUnique_actionPerformed();
      }
    });

    this.cardLayout1.show(this.getContentPane(),"jPanel1");
  }

  void tycoonReset()
  { tyc.resetAll();
    evalTycoon.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Tycoon");
    this.tyc.startAnim();
  }

  void heroReset()
  { hero.resetAll();
    evalHero.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Hero");
  }

  void friendReset()
  { frnd.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Friend");
  }

  void goTycoon_actionPerformed()
  { //tycSound.play();
    tyc.setScore();
    evalTycoon.startAnim(tyc.lastScore,280);
    this.cardLayout1.show(this.getContentPane(),"Tycoon Evaluator");
  }

  void goHero_actionPerformed()
  { //heroSound.play();
    hero.setScore();
    evalHero.startAnim(hero.lastScore,5);
    this.cardLayout1.show(this.getContentPane(),"Hero Evaluator");
  }

  void showFrnd_actionPerformed()
  { //menu.player.stop();
    //menu.tycSound.stop();
    //menu.heroSound.stop();
    this.cardLayout1.show(this.getContentPane(),"Friend Intro");
  }

  void showTycoon_actionPerformed()
  {  //menu.tycSound.stop();
     //menu.heroSound.stop();
     //menu.player.stop();
     this.cardLayout1.show(this.getContentPane(),"Tycoon Intro");
  }

  void showHero_actionPerformed()
  {   //menu.heroSound.stop();
      //menu.tycSound.stop();
      //menu.player.stop();
      this.cardLayout1.show(this.getContentPane(),"Hero Intro");
  }

  void showUnique_actionPerformed()
  {  menu.unique.setEnabled(false);
     unPan.intlNumPeople();
     menu.unique.setEnabled(true);
    this.cardLayout1.show(this.getContentPane(),"Unique Intro");

  }

  void tycShowMenu()
  { tyc.resetAll();
    evalTycoon.resetAll();
    evalTycoon.bClear=false;
    this.cardLayout1.show(this.getContentPane(),"Menu");
  }

  void heroShowMenu()
  { hero.resetAll();
    evalHero.resetAll();
    evalHero.bClear=false;
    this.cardLayout1.show(this.getContentPane(),"Menu");
  }

  void uniShowMenu()
  { unPan.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Menu");
  }

  void frndShowMenu()
  { frnd.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Menu");
  }

  public void setExhibitor(Exhibitor currentExhibitor)
  { this.currentExhibitor=currentExhibitor;
    this.cardLayout1.show(this.getContentPane(),"Menu");
    this.unPan.setClientExhibitor(currentExhibitor);
    this.tyc.setClientExhibitor(currentExhibitor);
    this.hero.setClientExhibitor(currentExhibitor);
  }



  /**Overridden so we can make it hard to get past this screen*/
  protected void processWindowEvent(WindowEvent e)
  { if ((e.getID() == WindowEvent.WINDOW_DEACTIVATED) || (e.getID() == WindowEvent.WINDOW_ICONIFIED) )
    { if((e.getID() == WindowEvent.WINDOW_ICONIFIED))
      {
       //super.processWindowEvent(new WindowEvent(this,WindowEvent.WINDOW_DEICONIFIED));
       this.setState(Frame.NORMAL);
       this.setLocation(0,0);
      // this.setSize(new Dimension(801,601));
       //this.setState();
      }

      System.out.println("Good try bozo!");
    }
    else
    { super.processWindowEvent(e);
      System.out.println(e);
    }

    //this.setVisible(true);
   // this.setState(Frame.NORMAL);
  }

  public synchronized void removeClientLeavesStationListener(ClientLeavesStationListener l)
  {
    if (clientLeavesStationListeners != null && clientLeavesStationListeners.contains(l))
    {
      Vector v = (Vector) clientLeavesStationListeners.clone();
      v.removeElement(l);
      clientLeavesStationListeners = v;
    }
  }

  public synchronized void addClientLeavesStationListener(ClientLeavesStationListener l)
  {
    Vector v = clientLeavesStationListeners == null ? new Vector(2) : (Vector) clientLeavesStationListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      clientLeavesStationListeners = v;
    }
  }

  protected void fireDataChanged(ClientLeavesStationEvent e)
  {
    if (clientLeavesStationListeners != null)
    {
      Vector listeners = clientLeavesStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientLeavesStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  public synchronized void removeClientEntersStationListener(ClientEntersStationListener l)
  {
    if (clientEntersStationListeners != null && clientEntersStationListeners.contains(l))
    {
      Vector v = (Vector) clientEntersStationListeners.clone();
      v.removeElement(l);
      clientEntersStationListeners = v;
    }
  }

  public synchronized void addClientEntersStationListener(ClientEntersStationListener l)
  {
    Vector v = clientEntersStationListeners == null ? new Vector(2) : (Vector) clientEntersStationListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      clientEntersStationListeners = v;
    }
  }

  protected void fireDataChanged(ClientEntersStationEvent e)
  {
    if (clientEntersStationListeners != null)
    {
      Vector listeners = clientEntersStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientEntersStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  public synchronized void removeAdminRequestListener(AdminRequestListener l)
  {
    if (adminRequestListeners != null && adminRequestListeners.contains(l))
    {
      Vector v = (Vector) adminRequestListeners.clone();
      v.removeElement(l);
      adminRequestListeners = v;
    }
  }

  public synchronized void addAdminRequestListener(AdminRequestListener l)
  {
    Vector v = adminRequestListeners == null ? new Vector(2) : (Vector) adminRequestListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      adminRequestListeners = v;
    }
  }

  protected void fireDataChanged(AdminRequestEvent e)
  {
    if (adminRequestListeners != null)
    {
      Vector listeners = adminRequestListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((AdminRequestListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  void kkh_dataChanged(AdminRequestEvent e)
  { System.out.println("Admin request "+ e.getSource());
    this.fireDataChanged(e);

  }

  void kkh_dataChanged(ClientLeavesStationEvent e)
  { System.out.println("Client Left "+ e.getSource());
    this.cardLayout1.show(this.getContentPane(),"jPanel1");
    this.fireDataChanged(e);

  }

  void kkh_dataChanged(ClientEntersStationEvent e)
  { System.out.println("Client Entered "+ e.getSource());
    this.fireDataChanged(e);
  }

  void uniShowDiploma()
  { dip.setDateLabel();
    this.cardLayout1.show(this.getContentPane(),"Diploma");
  }

  void dipShowMenu()
  { unPan.resetAll();
    this.cardLayout1.show(this.getContentPane(),"Menu");
  }

  public void resetAll()
  {   /*
      if(player!=null)
      player.stop();
     if(tycSound!=null)
      tycSound.stop();
     if(heroSound!=null)
      heroSound.stop();
      */
     tyc.resetAll();
     unPan.resetAll();
     hero.resetAll();
     frnd.resetAll();
     menu.menuReset();
     evalTycoon.resetAll();
     evalHero.resetAll();
  }

  void this_componentMoved(ComponentEvent e)
  { if((this.getLocation().x!=0) || (this.getLocation().y!=0))
     this.setLocation(0,0);
  }

  void this_componentResized(ComponentEvent e)
  { System.out.println("Resized");
    this.setSize(new Dimension(801,601));
  }

  void this_componentHidden(ComponentEvent e)
  { System.out.println("Hidden");
    this.setVisible(true);
  }

  void showHero()
  {   //heroSound.play();
      this.cardLayout1.show(this.getContentPane(),"Hero");
  }

  void showUnique()
  {  this.cardLayout1.show(this.getContentPane(),"Unique");
  }

  void showTycoon()
  {
     //tycSound.play();
     this.cardLayout1.show(this.getContentPane(),"Tycoon");
     this.tyc.startAnim();
  }

  void showFriend()
  {  //player.start();
     this.cardLayout1.show(this.getContentPane(),"Friend");
  }
  /*
  public synchronized void controllerUpdate(ControllerEvent event) {

        if (event instanceof EndOfMediaEvent)
            player.setMediaTime(new javax.media.Time(0));



  }
  */
}
