package edu.ucf.cs.dml.simnets.measureme.analysis;
import java.awt.*;
import javax.swing.JPanel;
import java.text.NumberFormat;
import java.util.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */


public class PieChartPanel extends JPanel {
  boolean bIntro=false;
  int MARGIN=25;
  int TOP_MARGIN=7;
  int CIRCLE_DIAMETER=110;
  int CIRCLE_LEGEND_GAP=8;
  int LEGEND_OFFSET=TOP_MARGIN+CIRCLE_DIAMETER+CIRCLE_LEGEND_GAP;
  int LEGEND_BOX_SIZE=10;
  int LEGEND_LABEL_GAP=5;

  private String[] mySliceLabel;
  private double[] mySliceValue;
  private double[] mySlicePct;
  private Color[] mySliceColor={Color.green,Color.blue,Color.red};

  private int mySlices;
  private NumberFormat myFormatter;


  public PieChartPanel()
  {
    myFormatter=NumberFormat.getPercentInstance();
    setSize(MARGIN+CIRCLE_DIAMETER+MARGIN,LEGEND_OFFSET+2* LEGEND_BOX_SIZE);
    setBackground(Color.white);
  }
  public void drawThePie(Vector sliceLabels,Vector sliceValues)
  {
    mySlices=sliceValues.size();
    mySliceLabel=new String[mySlices];
    mySliceValue=new double[mySlices];
    for(int i=0;i<mySlices;i++)
    { mySliceLabel[i]=((String)sliceLabels.elementAt(i));
      mySliceValue[i]=((Float)sliceValues.elementAt(i)).doubleValue();
    }
    mySlicePct=new double[mySlices];
    computePercentages();
    repaint();
  }

  private void computePercentages()
  { double valuesSum=0.0;
    valuesSum=100;
    for(int i=0;i<mySlices;i++)
      mySlicePct[i]=mySliceValue[i]/valuesSum;
  }

  public void paintComponent(Graphics g)
  { super.paintComponent(g);
    int startAngle=0;
    int arcAngle=0;
    for(int i=0;i<mySlices;i++)
    { startAngle+=arcAngle;
      arcAngle=round(mySlicePct[i]*360);
      System.out.println(arcAngle);
      drawSlice(i,startAngle,arcAngle,g);
    }
    g.setColor(Color.black);
    if(bIntro==true)
    { //draw dial marks
      g.drawLine(80,0,80,7);
      g.drawLine(80,117,80,124);
      g.drawLine(18,62,25,62);
      g.drawLine(135,62,142,62);
      g.drawLine(33,16,40,23);
      g.drawLine(115,104,122,111);
      g.drawLine(120,23,127,16);
      g.drawLine(42,102,35,109);
    }
  }

  private void drawSlice(int sliceNumber,int startAngle,int arcAngle,Graphics g)
  { g.setColor(mySliceColor[sliceNumber]);
    g.fillArc(MARGIN,TOP_MARGIN,CIRCLE_DIAMETER,CIRCLE_DIAMETER,startAngle,arcAngle);
    if(sliceNumber==0)
    { g.fillRect(MARGIN,LEGEND_OFFSET+sliceNumber*LEGEND_BOX_SIZE,LEGEND_BOX_SIZE,LEGEND_BOX_SIZE);
      g.setColor(Color.black);
      Stroke oldStroke=((Graphics2D)g).getStroke();
      ((Graphics2D)g).setStroke(new BasicStroke(8.0f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
      g.drawString("(" + myFormatter.format(mySlicePct[sliceNumber]) + ")" + mySliceLabel[sliceNumber],MARGIN+LEGEND_BOX_SIZE+LEGEND_LABEL_GAP,LEGEND_OFFSET+(sliceNumber+1)*LEGEND_BOX_SIZE);
      ((Graphics2D)g).setStroke(oldStroke);
    }
  }

  public void setSliceColor(int sliceNumber,Color newColor)
  { mySliceColor[sliceNumber]=newColor;
    repaint();
  }

  public void setSliceValue(int sliceNumber,double newValue)
  { mySliceValue[sliceNumber]=newValue;
    computePercentages();
    repaint();
  }

  private int round(double value)
  { return (int) (value+0.5);
  }

  public void setPopColor(Color c)
  { mySliceColor[1]=c;
    repaint();
  }

  public void doIntro()
  { bIntro=true;
  }

  public void notIntro()
  { bIntro=false;
  }

}