

package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import java.util.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;

public class xAxisPanel extends JPanel {
  int majorScoreLineCount;
  int scoreLineWidth;
  int majorLineHeight=7;
  protected Vector scoreLabels=new Vector();
  XYLayout xYLayout1 = new XYLayout();
  JLabel unitsLabel = new JLabel();
  Font labelFont=new java.awt.Font("SansSerif", 1, 16);

  public xAxisPanel(int count,int lineWidth) {
    try {
      this.scoreLineWidth=lineWidth;
      this.majorScoreLineCount=count;
      jbInit();
      this.setUpLabels();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } // constructor

  void jbInit() throws Exception {
    this.setBackground(Color.white);
    this.setLayout(xYLayout1);
    this.unitsLabel.setFont(this.labelFont);
    this.add(unitsLabel, new XYConstraints((((int)((majorScoreLineCount-1)*scoreLineWidth))/2)-(unitsLabel.getText().length()/2),23, -1, -1));
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    paintScoreLines((Graphics2D) g);
  } // paintComponent

  protected void paintScoreLines(Graphics2D g2)
  { g2.setColor(Color.black);
    for(int i=0; i<this.majorScoreLineCount-1;i++)
    { g2.drawLine((i+1)*this.scoreLineWidth,0,(i+1)*this.scoreLineWidth,this.majorLineHeight);

    }
  }

  protected void setUpLabels()
  { JLabel tempLabel=null;
    for(int i=0;i<this.majorScoreLineCount;i++)
    { tempLabel=new JLabel();
      tempLabel.setBackground(Color.white);
      tempLabel.setFont(this.labelFont);
      tempLabel.setForeground(Color.black);
      this.scoreLabels.add(i,tempLabel);
    }
  }

  public void setScoreLabels(Object[] scoreSet)
  { JLabel tempLabel=null;
    int offst=0;
    for(int i=0;i<this.majorScoreLineCount;i++)
    { tempLabel=(JLabel)this.scoreLabels.elementAt(i);
      if(((String)scoreSet[i]).length()>2)
        offst=5;
      else
        offst=0;
      if(i==0)
        this.add(tempLabel, new XYConstraints(i*this.scoreLineWidth-offst+3,10 , -1, -1));
      else
        this.add(tempLabel, new XYConstraints(i*this.scoreLineWidth-5-offst,10 , -1, -1));
      String tempString=""+scoreSet[i];
      if(tempString.length()>5)
        tempString=tempString.substring(0,4);
      if(i<scoreSet.length)
        tempLabel.setText(tempString);
    }
  }

  public void setScoreLabels(Object[] scoreSet, String units)
  {
    this.setScoreLabels(scoreSet);
    unitsLabel.setForeground(Color.black);
    if(units.equals("s"))
      unitsLabel.setText("seconds");
    else
    { this.unitsLabel.setText(units);
      this.unitsLabel.setFont(new java.awt.Font("SansSerif", 1, 14));
    }
  }
}