package edu.ucf.cs.dml.simnets.measureme.analysis;

import java.awt.*;
import java.util.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
/**
 * Title: MeasureMe Analysis Station
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author: Jennifer Farris
 * @version 2.0
 */

public class yAxisPanel extends JPanel {
  int majorScoreLineCount;
  int scoreLineWidth;
  int majorLineHeight=7;
  int axisHeight;
  protected Vector scoreLabels=new Vector();
  XYLayout xYLayout1 = new XYLayout();
  JLabel unitsLabel = new JLabel();
  Font labelFont=new java.awt.Font("SansSerif", 1, 16);

  public yAxisPanel(int count, int lineWidth, int hght) {
    try {
      this.scoreLineWidth=lineWidth;
      this.majorScoreLineCount=count;
      this.axisHeight=hght;
      jbInit();
      this.setUpLabels();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } // constructor

  void jbInit() throws Exception {
    this.setBackground(Color.white);
    this.setLayout(xYLayout1);
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    paintScoreLines((Graphics2D) g);
  } // paintComponent

  protected void paintScoreLines(Graphics2D g2)
  { g2.setColor(Color.black);
    for(int i=0; i<this.majorScoreLineCount;i++)
    { g2.drawLine(this.getWidth()-majorLineHeight,this.getHeight()-(i+1)*this.scoreLineWidth,this.getWidth(),this.getHeight()-(i+1)*this.scoreLineWidth);
    }
  }

  protected void setUpLabels()
  { JLabel tempLabel=null;
    for(int i=0;i<this.majorScoreLineCount;i++)
    { tempLabel=new JLabel();
      tempLabel.setBackground(Color.white);
      tempLabel.setFont(this.labelFont);
      tempLabel.setForeground(Color.black);
      this.scoreLabels.add(i,tempLabel);
      this.add(tempLabel, new XYConstraints(0,axisHeight-(i+1)*this.scoreLineWidth-7,-1, -1));
    }
  }

  public void setScoreLabels(Object[] scoreSet)
  { JLabel tempLabel=null;
    for(int i=0;i<this.majorScoreLineCount;i++)
    { tempLabel=(JLabel)this.scoreLabels.elementAt(i);
      String tempString=""+scoreSet[i];
      if(tempString.length()>5)
        tempString=tempString.substring(0,4);
      if(i<scoreSet.length)
        tempLabel.setText(tempString);
    }
  }
}