package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 *               A task for administrative purposes. First the ClientAdministration
 *               object will set the JFrame property of this Administration task and then
 *               a thread will start on the run method;
 *
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */
import javax.swing.*;

public abstract class AdministrationTask implements Runnable
{
  protected String scanCode="";
  protected javax.swing.JFrame gui=null;

  public AdministrationTask()
  {
  }

  public AdministrationTask(String scanCode)
  { this.scanCode=scanCode;
  }

  public String getScanCode()
  { return this.scanCode;
  }

  public void setScanCode(String newScanCode)
  { this.scanCode=newScanCode;
  }


  public abstract void run();


  public void setGui(javax.swing.JFrame newGui)
  {
    gui = newGui;
  }
  public javax.swing.JFrame getGui()
  {
    return gui;
  }

}