package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 *              A class that can convert any 0-255 internal value into an approximate
 *              score, and an aproximate score into a 0 - 255 internal value
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */
public class ConversionUtility
{  StationInfo si=new StationInfo();


  public ConversionUtility()
  {
  }

  public Short getInternalValue(String stationName, Object actual)
  { ValueMap vMap=this.getValueMap(stationName);

    if(vMap!=null)
     return vMap.getInternalValue(actual);
    return null;
  }

  public Short getInternalValeu(int stationID, Object actual)
  { ValueMap vMap=this.getValueMap(stationID);

    if(vMap!=null)
     return vMap.getInternalValue(actual);
    return null;
  }

  public Object getActualValue(String stationName, Short internalValue)
  { System.out.println("getActual: "+stationName + " internal: "+ internalValue);
    ValueMap vMap=this.getValueMap(stationName);
    if(vMap!=null)
     return vMap.getActualValue(internalValue);
    return null;
  }

  public Object getActualValue(int stationID, Short internalValue)
  { ValueMap vMap=this.getValueMap(stationID);
    if(vMap!=null)
    {
      return vMap.getActualValue(internalValue);
    }

    return null;

  }


  protected ValueMap getValueMap(int stationID)
  { System.out.println("getValueMap: "+stationID);
    if(stationID > this.si.getStationNames().length)
     return null;
    String[] names=si.getStationNames();
    String stationName=this.ripSpaces(names[stationID]);
    String vMapClassName="edu.ucf.cs.dml.simnets.measureme.client." + stationName+ "ValueMap";
    try{
     Class mapClass = Class.forName(vMapClassName);
     System.out.println("returning a valid map: " + mapClass);
     return (ValueMap) mapClass.newInstance();
    }
    catch(Exception e)
    { e.printStackTrace();
    }

    System.out.println("returning a invalid map" );
    return null;
  }

  protected ValueMap getValueMap(String stationName)
  { return  this.getValueMap(si.getID(stationName));

  }

  public String ripSpaces(String stringToRip)
  { String localStr=new String(stringToRip);
    if(localStr.indexOf(" ")>-1)
    {
      return ripSpaces(localStr.substring(0,localStr.indexOf(" "))+localStr.substring(localStr.indexOf(" ")+1)) ;
    }
    else
     return localStr;
  }






}