
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.net.URL;
import com.borland.jbcl.control.*;

public class DataCollectionPanel extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel collectionTextLabel = new JLabel();
  JLabel collectingAnimationLabel = new JLabel();
  JLabel collectingAvatarAnimationLabel = new JLabel();
  ImageIcon avatarIcon=null;
  ImageIcon collectingImageIcon=null;
  DigitalTimePanel digitalTimePanel1 = new DigitalTimePanel();
  boolean wantsDigitalDisplay=false;
  TransparentImage transparentCurveImage = new TransparentImage();
  URL baseURL;

  public DataCollectionPanel(GuiParameters gp)
  {
    this.baseURL=(URL)gp.getParameter("baseURL");
    try
    { if(gp.getParameter("collectionAnimation")!=null)
      { this.collectingImageIcon=new ImageIcon(new java.net.URL((URL)gp.getParameter("baseURL"),"collectingData/HangTime/"+(String)gp.getParameter("collectionAnimation")));

        System.out.println(new java.net.URL((URL)gp.getParameter("baseURL"),(String)gp.getParameter("collectionAnimation")));
        this.collectingAnimationLabel.setIcon(this.collectingImageIcon);
      }
      if(gp.getParameter("collectingLabel")!=null)
       this.collectionTextLabel.setText((String)gp.getParameter("collectingLabel"));

      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public DataCollectionPanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout(xYLayout1);
    collectionTextLabel.setFont(new java.awt.Font("SansSerif", 1, 25));
    collectionTextLabel.setRequestFocusEnabled(false);
    collectingAnimationLabel.setBorder(BorderFactory.createRaisedBevelBorder());
    collectingAnimationLabel.setRequestFocusEnabled(false);
    collectingAvatarAnimationLabel.setBorder(BorderFactory.createLoweredBevelBorder());
    collectingAvatarAnimationLabel.setRequestFocusEnabled(false);
    this.setRequestFocusEnabled(false);
    transparentCurveImage.setDrawEdge(false);
    if(this.baseURL==null)
    { System.out.println("Baseurl is null:?");
      this.baseURL=new URL("http://localhost");
    }

    System.out.println("Mat says baseURL in DataCollectionPanel is: "+baseURL);
    transparentCurveImage.setImageURL(new URL(this.baseURL,"var/side_wave.gif"));
   //transparentCurveImage.setImageName("C:\\mmanim\\newoct\\side_wave.gif");
    this.add(collectionTextLabel, new XYConstraints(150, 53, -1, -1));
    this.add(collectingAnimationLabel, new XYConstraints(356, 116, -1, -1));
    this.add(collectingAvatarAnimationLabel, new XYConstraints(44, 116, -1, -1));
    this.add(digitalTimePanel1, new XYConstraints(356, 300, -1, -1));
    this.add(transparentCurveImage, new XYConstraints(0, 0, -1, -1));

  }

  public void setAvatarIcon(ImageIcon avatarImage)
  { this.avatarIcon=avatarImage;
    this.collectingAvatarAnimationLabel.setIcon(this.avatarIcon);
  }

  public void redisplay()
  { this.digitalTimePanel1.setVisible(this.wantsDigitalDisplay);
    this.avatarIcon.getImage().flush();
    if(this.collectingImageIcon!=null)
     if(this.collectingImageIcon.getImage()!=null)
      this.collectingImageIcon.getImage().flush();
    this.collectingAvatarAnimationLabel.setIcon(this.avatarIcon);
    this.collectingAnimationLabel.setIcon(this.collectingImageIcon);
     if(this.wantsDigitalDisplay)
     this.digitalTimePanel1.startRunning();
  }

  public void stopDisplay()
  { if(this.wantsDigitalDisplay)
     this.digitalTimePanel1.stopRunning();

  }

  public void setWantsDigitalDisplay(boolean b)
  { this.wantsDigitalDisplay=b;

  }
}