
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 2000<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;
import edu.ucf.cs.dml.simnets.measureme.server.Exhibitor;
import java.util.*;
import edu.ucf.cs.dml.simnets.measureme.*;

/**
 * CLASS DemographicDecisions.. Controls the flow of demographic collecting on
 *  a per client basis.
 */
public class DemographicDecisions implements AvatarSelectedListener,  AgeSelectedListener, IntermediateLocationChosenListener, FinalAreaSelectedListener, GenderSelectedListener
{ MeasureMeFrame gui=null;
  protected boolean goodCollect=true;    //was the collection good?
  protected boolean returnSignal=false;  //block until collection complete
  Exhibitor currentExhibitor=null;
  AvatarInformation avatarInf=null;
  Hashtable countyCode=null;
  Hashtable countryCode=null;

  //protected boolean clientLeftEarly=false;  //sinal that the client has left
                                            //if anytime during collection, possible error

  public DemographicDecisions(MeasureMeFrame gui,AvatarInformation avatarInf,Hashtable countryCode,Hashtable countyCode)
  {this.avatarInf=avatarInf;
   this.gui=gui;
   this.countryCode=countryCode;
   this.countyCode=countyCode;
  }

  /**
   * PURPOSE: anaylyzes the exhibitor, and sets the screen up for collection
   */
  public boolean getDemographics(Exhibitor ex)
  { goodCollect=true;
    returnSignal=false;
    currentExhibitor=ex;
    //gui.addClientLeavesStationListener(this);

    if(ex.getGuideCharacterID()==-1) //time to collect the guide character and the
    { gui.flipToCollectGuide();
      System.out.println("switching to guide");
      gui.addAvatarSelectedListener(this);
      try{
          while(!returnSignal && !MeasureMeGlobal.clientLeft)
          { System.out.println("waiting avatar");
            synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
           }
            if (MeasureMeGlobal.clientLeft) {
              System.out.println("DemographicsDecisions: client left early");
              return false;
            }
         if(this.currentExhibitor.getGuideCharacterID()!=-1)
         { this.gui.setAvatar(this.currentExhibitor.getGuideCharacterID());

         }
        gui.removeAvatarSelectedListener(this);
      }
      catch(Exception e1)
      { e1.printStackTrace();
        gui.removeAgeSelectedListener(this);
        gui.removeAvatarSelectedListener(this);
        //gui.removeCountrySelectedListener(this);
        goodCollect=false;
        return goodCollect;
      }
    }
    else
    { this.gui.setAvatar(this.currentExhibitor.getGuideCharacterID());

    }
    if(ex.getAge()==-1)  //time to collect age value
    { gui.flipToCollectAge();
      gui.addAgeSelectedListener(this);
      this.returnSignal=false;
      try{  //wait for age selection
         while(!returnSignal && !MeasureMeGlobal.clientLeft)
         {
           System.out.println("waiting age");
           synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
         }
         if (MeasureMeGlobal.clientLeft) {
           System.out.println("DemographicsDecisions: client left early");
           return false;
         }
       }
      catch(Exception e7)
      { e7.printStackTrace();
        gui.removeAgeSelectedListener(this);
        gui.removeAvatarSelectedListener(this);
        //gui.removeCountrySelectedListener(this);
        goodCollect=false;
        return goodCollect;
      }

    }
    else  //already have ag
     if(ex.getCountryCode()==-1)
     { gui.flipToCollectLocation();
       gui.addFinalAreaSelectedListener(this);
       gui.addIntermediateLocationChosenListener(this);
       System.out.println("country was null");
      // gui.addCountrySelectedListener(this);
     }
     else
      if(ex.getGender()=='N')  //time to get gender
      { gui.flipToCollectGender();
        gui.addGenderSelectedListener(this);
      }
      else
        return goodCollect; //client done already has all demographics

     try{ //
      while(!returnSignal && !MeasureMeGlobal.clientLeft)
      { System.out.println("waiting for return signal");
        synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
      }
        if (MeasureMeGlobal.clientLeft) {
          System.out.println("DemographicsDecisions: client left early");
          return false;
        }
      this.gui.removeAgeSelectedListener(this);
      this.gui.removeAvatarSelectedListener(this);
      this.gui.removeFinalAreaSelectedListener(this);
      this.gui.removeGenderSelectedListener(this);
      if(this.currentExhibitor.getGuideCharacterID()!=-1)
      { this.gui.setAvatar(this.currentExhibitor.getGuideCharacterID());
      }
     }
     catch(Exception e)
     { e.printStackTrace();
       gui.removeAgeSelectedListener(this);
       gui.removeAvatarSelectedListener(this);
       //gui.removeCountrySelectedListener(this);
       goodCollect=false;
     }
    System.out.println("done waiting");
//    gui.removeClientLeavesStationListener(this);
    return goodCollect;
  }
/*
  public synchronized void dataChanged(ClientLeavesStationEvent e)
  { goodCollect=false;
    returnSignal=true;
    this.notify();
    gui.removeAgeSelectedListener(this);
    gui.removeAvatarSelectedListener(this);
    //gui.removeCountrySelectedListener(this);
  }
*/
  public void avatarSelection(AvatarSelectedEvent e)
  {  //need to add the avatar code to the user
     short id=-1;
     this.currentExhibitor.setGuideCharacterID(id=(short)avatarInf.getCode((String)e.getSource().toString() ) );
     System.out.println("Avatar: "+e.getSource() + " :"+id);
     gui.removeAvatarSelectedListener(this);
     returnSignal=true;
     //this.notifyAll();
  }


  public void ageSelected(AgeSelectedEvent e)
  {
    this.currentExhibitor.setAge(((Short)e.getSource()).shortValue());
    System.out.println("age is:" +currentExhibitor.getAge());
    gui.removeAgeSelectedListener(this);
    returnSignal=true;
   // this.notifyAll();

  }


  public void intermediateLocationSelected(IntermediateLocationChosenEvent e)
  { addArea((String)e.getSource());

  }

  public void finalAreaSelected(FinalAreaSelectedEvent e)
  { addArea((String)e.getSource());
    gui.removeFinalAreaSelectedListener(this);
    gui.removeIntermediateLocationChosenListener(this);
    returnSignal=true;
    System.out.println("Area final=" + this.currentExhibitor.getCountryCode()+", "
    + this.currentExhibitor.getState()+", "+this.currentExhibitor.getCountyCode());
    //this.notifyAll();
  }

  protected void addArea(String area)
  { //have to cover for double mouse events
    System.out.println(area);
    if(this.currentExhibitor.getCountryCode()!=-1)
      if( getCountryName(this.currentExhibitor.getCountryCode()).equals(area))
        return;
    if(this.currentExhibitor.getState()!=null)
     if(this.currentExhibitor.getState().equals(area))
      return;
    if(this.currentExhibitor.getCountyCode()!=-1)
     if(getCountyName(this.currentExhibitor.getCountyCode()).equals(area))
       return;


    if(this.currentExhibitor.getCountryCode()==-1)
    { if(this.countryCode.get(area)==null) //ignore
      { System.out.println("ignore " +area + " as a country");
        return;
      }
       this.currentExhibitor.setCountryCode((short)(((Integer)this.countryCode.get(area)).intValue()) );
    }
    else
     if(this.currentExhibitor.getState().equals("NO"))
      this.currentExhibitor.setState(area);
     else
      this.currentExhibitor.setCountyCode((short)(((Integer)this.countyCode.get(area)).intValue()));
  }

  protected String getCountryName(short countryCode)
  { Enumeration enum= this.countryCode.keys(); //all the names
    String countryName=null;
    while(enum.hasMoreElements())
    { countryName = (String) enum.nextElement();
      if(this.countryCode.get(countryName).equals(new Integer(countryCode)))
       return countryName;
    }
    return "";
  }

  protected String getCountyName(short countyCode)
  { Enumeration enum= this.countyCode.keys(); //all the names
    String countyName=null;
    while(enum.hasMoreElements())
    { countyName = (String) enum.nextElement();
      if(this.countyCode.get(countyName).equals(new Integer(countyCode)))
       return countyName;
    }
    return "";
  }

  public void dataChanged(GenderSelectedEvent e)
  { this.currentExhibitor.setGender(((String)e.getSource()).charAt(0));
    System.out.println("Set gender to: "+((String)e.getSource()).charAt(0));
    this.returnSignal=true;
    //this.notifyAll();
    //TODO: Implement this edu.ucf.cs.dml.simnets.measureme.client.GenderSelectedListener method
  }
}