
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import edu.ucf.cs.dml.simnets.measureme.server.*;
import java.util.*;
import java.net.URL;

public class EndPanel extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  protected String[] stationNames=null;/*{"Balance","Eye Span","Flexibility","Grip Strength",
                                "Hand Span","Finger Length","Fingertip to Elbow",
                                "Foot Length","Arm Length","Hang Time","Height",
                                "Jump","Musical Scale","Pheripheral Vision","Reaction Time"};
                                */
  protected String[] iconNames= {"icon1.gif", "icon2.gif", "icon3.gif", "icon4.gif", "icon5.gif","icon6.gif",
                                 "icon7.gif","icon8.gif", "icon9.gif", "icon10.gif", "icon11.gif", "icon12.gif",
                                 "icon13.gif", "icon14.gif","icon15.gif"};
  protected String[] checkedIconNames= {"icon1checked.gif", "icon2checked.gif", "icon3checked.gif", "icon4checked.gif", "icon5checked.gif","icon6checked.gif",
                                 "icon7checked.gif","icon8checked.gif", "icon9checked.gif", "icon10checked.gif", "icon11checked.gif", "icon12checked.gif",
                                 "icon13checked.gif", "icon14checked.gif","icon15checked.gif"};

  Vector iconLabels=new Vector();
  Vector currentStations=new Vector();
  JLabel goodbyeAnimLabel = new JLabel();

  protected ImageIcon goodByeIcon=null;
  GuiParameters gp;

  public EndPanel(GuiParameters gp)
  {
    this.gp = gp;
    try
    { this.stationNames=StationInfo.getStationNames();
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 36));
    jLabel1.setText("Pick up your ruler and let's try");
    this.setRequestFocusEnabled(false);
    this.setLayout(xYLayout1);
    jLabel2.setText("some more!");
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 36));
    this.add(jLabel1, new XYConstraints(150, 99, -1, -1));
    this.add(jLabel2, new XYConstraints(298, 160, -1, -1));
    this.add(goodbyeAnimLabel, new XYConstraints(2, 348, -1, -1));
  }
  /**
   * PURPOSE: Set up the icons for to display to the user.
   */
  public void setClientExhibitor(Exhibitor exhibitor)
  { //this.add(jl,new XYConstraints(p.x,p.y,this.cellWidth,this.cellHeight));
    this.removeAllIcons();

    JLabel theLabel=null;
    ImageIcon ic=null;
    int actuallyAdded = 0; //the number of icons added to the bar


    try{
      for(int i=0; i<15;i++)
      { theLabel=new JLabel();
        if(exhibitor.getScoreInfo((short)(i+1))!=null)
         ic=new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"icons2/"+ripSpaces(this.stationNames[i])+"2.gif" ));
        else
         ic=new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"icons2/"+ripSpaces(this.stationNames[i])+"1.gif" ));
        theLabel.setIcon(ic);
        //theLabel.setDisabledIcon(ic);
        if(!this.stationAvailable(this.stationNames[i]))
        { theLabel.setEnabled(false);
          System.out.println("Setenable: "+stationNames[i]+ " " + "not added");

        }
        else
        {
          this.iconLabels.add(theLabel);
          if(exhibitor.getScoreInfo((short)(i+1))==null)
          { theLabel.setEnabled(false);
            System.out.println("Setenable: "+stationNames[i]+ " " + "false");
          }
          this.add(theLabel,new XYConstraints(52*actuallyAdded,500,52,-1));
          actuallyAdded++;

        }
        //detemine which icon is which

        //Here is where we will do shifting


      }
     }
     catch(Exception e)
     { e.printStackTrace();
     }
     try{
     System.out.println(new URL((URL)gp.getParameter("baseURL"),"avatars/goodbye"+exhibitor.getGuideCharacterID()+".gif"));
     goodByeIcon= new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"avatars/goodbye"+exhibitor.getGuideCharacterID()+".gif"));
     }catch(Exception e){}
     this.goodbyeAnimLabel.setIcon(goodByeIcon);


    this.updateUI();

  }

  protected void removeAllIcons()
  { JLabel l=null;
    for(int i=0;i<this.iconLabels.size(); i++)
    { l=(JLabel) this.iconLabels.elementAt(i);
      this.remove(l);
    }
    this.iconLabels.removeAllElements();
    this.updateUI();
  }

  public void setStationsAvailable(Vector stationsAvailable)
  { this.currentStations=stationsAvailable;

  }

  protected boolean stationAvailable(String stationName)
  { int i=0;
    ExhibitAvailableInfo inf=null;
    while(i<this.currentStations.size())
    { inf=(ExhibitAvailableInfo)this.currentStations.elementAt(i);
      if(inf.getStationName().equals(stationName))
       return inf.isAvalable();
      i++;
    }
    return false;
  }

  String ripSpaces(String stringToRip)
  { String localStr=new String(stringToRip);
    if(localStr.indexOf(" ")>-1)
    {
      return ripSpaces(localStr.substring(0,localStr.indexOf(" "))+localStr.substring(localStr.indexOf(" ")+1)) ;
    }
    else
     return localStr;
  }

}