package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class FingerLengthValueMap extends ValueMap {
 /* Estimated range is 1.5 - 6 inches */
  /* total inches is 4.5 in range */
  public static final float LOWEST_MEASUREMENT = 1.5F;
  public static final float HIGHEST_MEASUREMENT = 6.0F;
  public static final float INCHES_PER_BIT = 0.017578125F;

  public FingerLengthValueMap()
  {
  }

  public String getMetricUnits()
  { return "in";

  }
  public Object getActualValue(Short deviceValue)
  { System.out.println("device value in finger value map: "+deviceValue);

    return new Float(LOWEST_MEASUREMENT + (INCHES_PER_BIT * deviceValue.shortValue()) );
    //return deviceValue;

  }


  public Short getInternalValue(Object actualValue) {
    float bitsPerInch = 1 / INCHES_PER_BIT;
    System.out.println("Actual inches value passed to fingervaluemap: "+actualValue);
    Float f = null;
    if(actualValue instanceof java.lang.Float)
     f=(Float) actualValue;
    else
     f=new Float(((Float) this.getActualValue((Short)actualValue)).floatValue() );

    if(f.floatValue()<=LOWEST_MEASUREMENT)
     return new Short((short)0);
    if(f.floatValue() > HIGHEST_MEASUREMENT)
     return new Short((short)255);
    f=new Float(f.floatValue()-LOWEST_MEASUREMENT); //constant offset
    Short s=new Short(((short)Math.round(f.floatValue()*bitsPerInch)));
    if(s.shortValue()<256)
     return s;
    return new Short((short)255);



  }
}