package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class FootLengthValueMap extends ValueMap
{/** range is 6 to 18 inches */
  public static final float LOWEST_MEASUREMENT = 6.0F;
  public static final float HIGHEST_MEASUREMENT = 18.0F;
  public static final float INCHES_PER_BIT = 0.046875F;


  public FootLengthValueMap()
  {
  }
  public String getMetricUnits()
  {return "in";

  }

  /**
   *
   * @param deviceValue
   * @return
   */
  public Object getActualValue(Short deviceValue)
  {System.out.println("device value in foot value map: "+deviceValue);

    return new Float(this.LOWEST_MEASUREMENT + (this.INCHES_PER_BIT * deviceValue.shortValue()) );


  }


  public Short getInternalValue(Object actualValue) {
    float bitsPerInch = 1 / INCHES_PER_BIT;
    System.out.println("Actual inches value passed to footvaluemap: "+actualValue);
    Float f = null;
    if(actualValue instanceof java.lang.Float)
     f=(Float) actualValue;
    else
     f=new Float(((Float) this.getActualValue((Short)actualValue)).floatValue() );

    if(f.floatValue()<=this.LOWEST_MEASUREMENT)
     return new Short((short)0);
    if(f.floatValue() > this.HIGHEST_MEASUREMENT)
     return new Short((short)255);

    // next two lines undo calculation in getActualValue
    //    multiplying by 21.333 is same as dividing by .046875
    f=new Float(f.floatValue()-this.LOWEST_MEASUREMENT); //constant offset
    Short s=new Short(((short)Math.round(f.floatValue()*bitsPerInch)));
    if(s.shortValue()<256)
     return s;
    return new Short((short)255);

  }
}