
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.net.*;
import java.awt.*;
import edu.ucf.cs.dml.mapthing.MapAreaPanel;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;

public class GenderPanel extends MapAreaPanel
{
  XYLayout xYLayout1 = new XYLayout();
  TransparentImage transparentImage1 = new TransparentImage();
  TransparentImage transparentImage2 = new TransparentImage();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  private transient Vector genderSelectedListeners;

  GuiParameters gp;
  public GenderPanel(GuiParameters gp)
  {
    this.gp = gp;
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    xYLayout1.setWidth(800);
    xYLayout1.setHeight(600);
    this.setLayout(xYLayout1);
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel1.setText("Are you a male or a female? Let us know and check out the");
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 26));
    jLabel2.setText("analysis station after you have gathered all your data!");
    transparentImage1.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mousePressed(MouseEvent e)
      {
        transparentImage1_mousePressed(e);
      }
    });
    transparentImage2.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mousePressed(MouseEvent e)
      {
        transparentImage2_mousePressed(e);
      }
    });
    transparentImage1.setDrawEdge(false);
    transparentImage2.setDrawEdge(false);
    this.add(jLabel1, new XYConstraints(36, 386, -1, -1));
    this.add(transparentImage1, new XYConstraints(50, 85, -1, -1));
    this.add(transparentImage2, new XYConstraints(468, 85, -1, -1));
    this.add(jLabel2, new XYConstraints(68, 427, -1, -1));
    transparentImage1.setImageURL(new java.net.URL((URL)gp.getParameter("baseURL"),"var/man.gif"));
    transparentImage2.setImageURL(new java.net.URL((URL)gp.getParameter("baseURL"),"var/woman.gif"));
  }

  public synchronized void removeGenderSelectedListener(GenderSelectedListener l)
  {
    if (genderSelectedListeners != null && genderSelectedListeners.contains(l))
    {
      Vector v = (Vector) genderSelectedListeners.clone();
      v.removeElement(l);
      genderSelectedListeners = v;
    }
  }

  public synchronized void addGenderSelectedListener(GenderSelectedListener l)
  {
    Vector v = genderSelectedListeners == null ? new Vector(2) : (Vector) genderSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      genderSelectedListeners = v;
    }
  }

  protected void fireDataChanged(GenderSelectedEvent e)
  {
    if (genderSelectedListeners != null)
    {
      Vector listeners = genderSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((GenderSelectedListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  void transparentImage1_mousePressed(MouseEvent e)
  { this.fireDataChanged(new GenderSelectedEvent("M"));

  }

  void transparentImage2_mousePressed(MouseEvent e)
  {  this.fireDataChanged(new GenderSelectedEvent("F"));

  }

  public void redisplay()
  {
  }
}