package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */
import edu.ucf.cs.dml.simnets.measureme.devices.*;

public class GreyCodeDeviceCalibration extends AdministrationTask implements CalibrationStateOptionListener
{ DeviceProxy myProxy=null;
  GreyCodeDeviceCalibrationFrame frame=null;
  public GreyCodeDeviceCalibration()
  { super("100");
  }

  public GreyCodeDeviceCalibration(DeviceProxy dp)
  { this();
    this.myProxy=dp;
  }

  public void setGreyScaleDeviceProxy(DeviceProxy dp)
  { this.myProxy=dp;
  }

  public void run()
  {
  //display the gui
    if(this.frame==null)
    { this.frame=new GreyCodeDeviceCalibrationFrame(this.gui, "Calibration" , true);
      this.frame.addCalibrationStateOptionListener(this);
    }
    this.frame.initialState();
    this.frame.setVisible(true);






  }

  public void dataChanged(CalibrationStateOptionEvent e)
  {

    if(((String)e.getSource()).equals("Low"))
    { try{
         if(this.myProxy instanceof edu.ucf.cs.dml.simnets.measureme.devices.GrayCodeDeviceProxy)
          this.frame.setLowValue( ((Short)  ((GrayCodeDeviceProxy)this.myProxy).measureRaw()).shortValue());
         else
          this.frame.setLowValue( ((Short) this.myProxy.measure()).shortValue());
       }
      catch(Exception e2)
      { e2.printStackTrace();
      }
    }
  }
}