package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class HandSpanValueMap extends ValueMap
{ /** Range is 4 to 12 */
  public static final float LOWEST_MEASUREMENT = 4.0F;
  public static final float HIGHEST_MEASUREMENT = 12.0F;
  public static final float INCHES_PER_BIT = 0.03125F;

  public HandSpanValueMap()
  {
  }

  public String getMetricUnits()
  {return "in";

  }

  public Object getActualValue(Short deviceValue)
  { System.out.println("device value in hand value map: "+deviceValue);
    // Edit M. Lowery 2002-06-02 changed to match setup of other value maps
    return new Float(LOWEST_MEASUREMENT + (INCHES_PER_BIT * deviceValue.shortValue()));

    // old code is below
    //return new Float( 4.0 + (0.3125 * deviceValue.shortValue()/10) )
  }

  public Short getInternalValue(Object actualValue) {
    float bitsPerInch = 1 / INCHES_PER_BIT;
    System.out.println("Actual inches value passed to handspanmap: "+actualValue);
    Float f = null;
    if(actualValue instanceof java.lang.Float)
     f=(Float) actualValue;
    else
     f=new Float(((Float) this.getActualValue((Short)actualValue)).floatValue() );

    if(f.floatValue()<=LOWEST_MEASUREMENT)
     return new Short((short)0);
    if(f.floatValue() > HIGHEST_MEASUREMENT)
     return new Short((short)255);
    f=new Float(f.floatValue()-LOWEST_MEASUREMENT); //constant offset
    Short s=new Short(((short)Math.round(f.floatValue()*bitsPerInch)));
    if(s.shortValue()<256)
     return s;
    return new Short((short)255);



    /**@todo: implement this edu.ucf.cs.dml.simnets.measureme.client.ValueMap abstract method*/
  }
}