
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

public class HangTimeWeightPopup extends JDialog implements CurveDrawingCompletedListener, KeyListener
{
  JPanel panel1 = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JLabel questionLabel1 = new JLabel();
  JLabel questionLabel2 = new JLabel();
  JButton yesBn = new JButton();
  JButton noBn = new JButton();
  JLabel kgsUnitsLabel = new JLabel();
  JLabel lbsUnitsLabel = new JLabel();
  JLabel youWeighLabel = new JLabel();
  JLabel kgsValueLabel = new JLabel();
  JLabel lbsValueLabel = new JLabel();
  float weight=0.0f;
  JButton finishedBn = new JButton();
  boolean displayPopup = true;
  DisplayDataPanel panel = null;
  //public class AutoTimer
  Frame frame= null;


  public HangTimeWeightPopup(Frame frame, String title, boolean modal)
  {
    super(frame, title, modal);
    this.frame = frame;
    try
    {
      jbInit();
      pack();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public HangTimeWeightPopup(Frame frame, String title, boolean modal,DisplayDataPanel panel)
  { this(frame,title,modal);
    this.panel = panel;
    panel.addCurveDrawingCompletedListener(this);
  }

  public HangTimeWeightPopup()
  {
    this(null, "", false);
  }

  void jbInit() throws Exception
  { this.disableEvents(AWTEvent.WINDOW_EVENT_MASK);
    //this.disableEvents(AWTEvent.ADJUSTMENT_EVENT_MASK);
    //this.enableEvents(AWTEvent);
    panel1.setLayout(xYLayout1);
    this.setResizable(false);
    this.setTitle("Orlando Science Center");
    this.setModal(true);
    questionLabel1.setFont(new java.awt.Font("SansSerif", 0, 30));
    questionLabel1.setText("By the way, your weight was measured also");
    questionLabel2.setFont(new java.awt.Font("SansSerif", 0, 30));
    questionLabel2.setText("do you want to see it?");
    yesBn.setFont(new java.awt.Font("SansSerif", 0, 20));
    yesBn.setForeground(Color.blue);
    yesBn.setText("YES");
    yesBn.setFocusPainted(false);
    yesBn.setRequestFocusEnabled(false);
    yesBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        yesBn_actionPerformed(e);
      }
    });
    noBn.setFont(new java.awt.Font("SansSerif", 0, 20));
    noBn.setText("NO");
    noBn.setRequestFocusEnabled(false);
    noBn.setFocusPainted(false);
    noBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        noBn_actionPerformed(e);
      }
    });
    panel1.setRequestFocusEnabled(false);
    kgsUnitsLabel.setFont(new java.awt.Font("SansSerif", 1, 22));
    kgsUnitsLabel.setToolTipText("");
    kgsUnitsLabel.setText("kgs.");
    lbsUnitsLabel.setFont(new java.awt.Font("SansSerif", 1, 22));
    lbsUnitsLabel.setText("lbs.");
    youWeighLabel.setFont(new java.awt.Font("SansSerif", 0, 30));
    youWeighLabel.setText("You weigh:");
    lbsValueLabel.setFont(new java.awt.Font("SansSerif", 1, 22));
    lbsValueLabel.setText("       ");
    kgsValueLabel.setFont(new java.awt.Font("SansSerif", 1, 22));
    kgsValueLabel.setText("     ");
    finishedBn.setFont(new java.awt.Font("SansSerif", 0, 20));
    finishedBn.setForeground(Color.red);
    finishedBn.setText("Click Here when finished...");
    finishedBn.setRequestFocusEnabled(false);
    finishedBn.setFocusPainted(false);
    finishedBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        finishedBn_actionPerformed(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(questionLabel1, new XYConstraints(8, 11, -1, -1));
    panel1.add(questionLabel2, new XYConstraints(158, 53, -1, -1));
    panel1.add(yesBn, new XYConstraints(190, 227, -1, -1));
    panel1.add(noBn, new XYConstraints(384, 227, -1, -1));
    panel1.add(finishedBn, new XYConstraints(189, 226, -1, -1));
    panel1.add(youWeighLabel, new XYConstraints(207, 36, -1, -1));
    panel1.add(kgsUnitsLabel, new XYConstraints(216, 122, -1, -1));
    panel1.add(kgsValueLabel, new XYConstraints(161, 122, -1, -1));
    panel1.add(lbsValueLabel, new XYConstraints(321, 122, -1, -1));
    panel1.add(lbsUnitsLabel, new XYConstraints(375, 122, -1, -1));
    this.youWeighLabel.setVisible(false);
    this.kgsUnitsLabel.setVisible(false);
    this.kgsValueLabel.setVisible(false);
    this.lbsValueLabel.setVisible(false);
    this.lbsUnitsLabel.setVisible(false);
    this.finishedBn.setVisible(false);

    this.addKeyListener(this);

  }

  void noBn_actionPerformed(ActionEvent e)
  { this.setVisible(false);

  }

  void yesBn_actionPerformed(ActionEvent e)
  { this.showWeight();
    this.yesBn.setVisible(false);
    this.noBn.setVisible(false);
    this.finishedBn.setVisible(true);

  }

  protected void showWeight()
  { this.questionLabel1.setVisible(false);
    this.questionLabel2.setVisible(false);
    this.youWeighLabel.setVisible(true);
    this.kgsUnitsLabel.setVisible(true);
    this.kgsValueLabel.setVisible(true);
    this.lbsValueLabel.setVisible(true);
    this.lbsUnitsLabel.setVisible(true);

  }

  protected void hideWeight()
  { this.questionLabel1.setVisible(true);
    this.questionLabel2.setVisible(true);
    this.youWeighLabel.setVisible(false);
    this.kgsUnitsLabel.setVisible(false);
    this.kgsValueLabel.setVisible(false);
    this.lbsValueLabel.setVisible(false);
    this.lbsUnitsLabel.setVisible(false);

  }


  /**
   * PURPOSE: set the weight value as lbs
   */
  public void setWeight(float weight)
  { this.weight=weight;
    this.lbsValueLabel.setText(rip(Float.toString(this.weight)));
    this.kgsValueLabel.setText(rip(Float.toString((float)(weight*0.453592)))); //kgs conv
  }

  void finishedBn_actionPerformed(ActionEvent e)
  { this.finishedBn.setVisible(false);
    this.yesBn.setVisible(true);
    this.noBn.setVisible(true);
    this.hideWeight();
    this.setVisible(false);

  }

  /**
   * Event is generated when curve drawing is completed
   */
  public void curveDone(CurveDrawingCompletedEvent e)
  {
    if (displayPopup) {
      this.setBounds(100,100,596,364);
      this.setVisible(true);
    }
    // reset for next time
    displayPopup = true;
    //this.htPopup.setWeight();
  }

  protected String rip(String s)
  { if(s.length()>5)
     return s.substring(0,4);
    return s;

  }

  public void preventDisplay(boolean prevent) {
    if (prevent) {
      panel.removeCurveDrawingCompletedListener(this);
    }
    else {
      panel.addCurveDrawingCompletedListener(this);
    }
  }

  /**
   * These key events are passed to the frame which is watched by KeyCodeHandler.
   */
  public void keyTyped(KeyEvent e) {
    this.frame.dispatchEvent(e);
  }

  /**
   * Close the window if visitor logging out.
   */
  public void keyPressed(KeyEvent e) {
    this.setVisible(false);
    this.frame.dispatchEvent(e);
  }

  public void keyReleased(KeyEvent e) {
    this.frame.dispatchEvent(e);
  }

}