
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import com.borland.jbcl.control.*;
import edu.ucf.cs.dml.simnets.measureme.devices.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import edu.ucf.cs.dml.simnets.measureme.*;

public class InstructionsPanel extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  //JLabel instructionsLabel1 = new JLabel();
  //JLabel instructionsLabel2 = new JLabel();
  //JLabel instructionsLabel3 = new JLabel();
  // edit M. Lowery changed from 3 labels to one text area
  JTextArea instructionTextArea = new JTextArea();
  JLabel instructionsImageLabel = new JLabel();
  ImageIcon instructionsImageIcon =null;
  ImageIcon instructionsImageIcon2 =null;
  String ImageIconURL=null;
  String ImageIconURL2=null;
  //JButton tryItBn = new JButton();
  //JLabel tryItLabel = new JLabel();
  Device myDevice=null;
  JLabel instructionsImageLabel1 = new JLabel();
  TransparentImage transparentCurveImage = new TransparentImage();
  URL baseURL=null;
  Vector clientStartsMeasurementListeners;

  public InstructionsPanel(GuiParameters gp)
  {
    try
    { baseURL=(URL)gp.getParameter("baseURL");
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public InstructionsPanel(URL baseURL)
  {
    try
    { this.baseURL=baseURL;
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {

    instructionTextArea.setFont(new java.awt.Font("SansSerif", 1, 30));
    instructionTextArea.setMaximumSize(new Dimension(644, 200));
    instructionTextArea.setEditable(false);
    instructionTextArea.setRequestFocusEnabled(false);
    instructionTextArea.setMinimumSize(new Dimension(644, 200));
    instructionTextArea.setPreferredSize(new Dimension(644, 200));
    instructionTextArea.setWrapStyleWord(true);
    instructionTextArea.setLineWrap(true);
    instructionTextArea.setBackground(SystemColor.control);
    instructionTextArea.setOpaque(false);

    //instructionsLabel1.setFont(new java.awt.Font("SansSerif", 1, 30));
    this.setLayout(xYLayout1);
    //instructionsLabel2.setFont(new java.awt.Font("SansSerif", 1, 30));
    //instructionsLabel3.setFont(new java.awt.Font("SansSerif", 1, 30));
    //tryItBn.setFont(new java.awt.Font("SansSerif", 1, 20));
    //tryItBn.setRequestFocusEnabled(false);
    //tryItBn.setFocusPainted(false);
    //tryItBn.setText("Try It!");

    //tryItLabel.setFont(new java.awt.Font("SansSerif", 1, 20));
    //tryItLabel.setText("Try it!");
    //this.setRequestFocusEnabled(false);
    this.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        this_mouseClicked(e);
      }
    });
    instructionTextArea.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        this_mouseClicked(e);
      }
    });

    transparentCurveImage.setDrawEdge(false);
    transparentCurveImage.setImageURL(new URL(this.baseURL,"var/side_wave2.gif"));
    //transparentCurveImage.setImageName("C:\\mmanim\\newoct\\side_wave2.gif");
    //this.add(instructionsLabel1, new XYConstraints(78, 10, -1, -1));
    //this.add(instructionsLabel2, new XYConstraints(78, 48, -1, -1));
    //this.add(instructionsLabel3, new XYConstraints(78, 85, -1, -1));
    this.add(instructionTextArea, new XYConstraints(78, 10, -1, 198));

    //this.add(tryItBn, new XYConstraints(364, 520, -1, -1));
    //this.add(tryItLabel, new XYConstraints(382, 520, -1, -1));
    this.add(instructionsImageLabel1, new XYConstraints(559, 239, -1, -1));
    this.add(instructionsImageLabel, new XYConstraints(247, 239, -1, -1));
    this.add(transparentCurveImage, new XYConstraints(0, 0, -1, -1));
    //this.tryItLabel.setVisible(false);
  }
  /**
   * Purpose: set up the image on the instructions area
   */
  public void setInstructionsImage(ImageIcon imageI)
  {  this.instructionsImageIcon=imageI;
     this.instructionsImageLabel.setIcon(this.instructionsImageIcon);
     this.updateUI();
  }

  /**
   * Purpose: set up the second image on the instructions area
   */
  public void setInstructionsImage2(ImageIcon imageI)
  {  this.instructionsImageIcon2=imageI;
     this.instructionsImageLabel1.setIcon(this.instructionsImageIcon2);
     this.updateUI();
  }

  public void setInstructionText(String text) {
    this.instructionTextArea.setText(text);
  }

  /*
  public void setInstructionsText1(String text)
  { this.instructionsLabel1.setText(text);
  }

  public void setInstructionsText2(String text)
  { this.instructionsLabel2.setText(text);
  }

  public void setInstructionsText3(String text)
  { this.instructionsLabel3.setText(text);
  }
*/

  /**
   *  Tells this frame if the device signals the start of collection, or
   *  it is signaled by a user click.
   */
/*  public void setDeviceActivated(boolean deviceActivated)
  {
    this.tryItBn.setEnabled(!deviceActivated);
    this.tryItLabel.setEnabled(deviceActivated);
    this.tryItBn.setVisible(!deviceActivated);
    this.tryItLabel.setVisible(deviceActivated);
  }
*/
/*  public void setTryItButtonEnabled(boolean b) {
    this.tryItBn.setEnabled(b);
  }
*/
/*  public void addTryItButtonListener(java.awt.event.ActionListener al)
  { this.tryItBn.addActionListener(al);

  }

  public void removeTryItButtonListener(java.awt.event.ActionListener al)
  { this.tryItBn.removeActionListener(al);

  }
*/
  public void redisplay()
  { this.instructionsImageIcon.getImage().flush();
    this.instructionsImageLabel.setIcon(this.instructionsImageIcon);
    //this.instructionsImage.

  }

  void this_mouseClicked(MouseEvent e) {
    if (!MeasureMeGlobal.deviceActivated) {
      fireDataChanged(new ClientStartsMeasurementEvent(this));
    }
  }

  public synchronized void removeClientStartsMeasurementListener(ClientStartsMeasurementListener l) {
    if(clientStartsMeasurementListeners != null && clientStartsMeasurementListeners.contains(l)) {
      Vector v = (Vector) clientStartsMeasurementListeners.clone();
      v.removeElement(l);
      clientStartsMeasurementListeners = v;
    }
  }

  public synchronized void addClientStartsMeasurementListener(ClientStartsMeasurementListener l) {
    Vector v = clientStartsMeasurementListeners == null ? new Vector(2) : (Vector) clientStartsMeasurementListeners.clone();
    if(!v.contains(l)) {
      v.addElement(l);
      clientStartsMeasurementListeners = v;
    }
  }

  protected void fireDataChanged(ClientStartsMeasurementEvent e) {
    if(clientStartsMeasurementListeners != null) {
      Vector listeners = clientStartsMeasurementListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++) {
        ((ClientStartsMeasurementListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

}