package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.net.URL;
import com.borland.jbcl.control.*;

public class JumpCountdownPanel extends DataCollectionPanel{

  JLabel countdownOneLabel = new JLabel();
  JLabel countdownTwoLabel = new JLabel();
  JLabel countdownThreeLabel = new JLabel();
  JLabel countdownJumpLabel = new JLabel();

  JLabel instr1 = new JLabel();
  JLabel instr2 = new JLabel();
  JLabel instr3 = new JLabel();
  JLabel instr4 = new JLabel();
  JLabel instr5 = new JLabel();

  public JumpCountdownPanel(){
    super();
    try{
      jbinit();
    }catch(Exception e){e.printStackTrace();}

  }//end constructor

  public JumpCountdownPanel(GuiParameters gp){
    super(gp);
    try{
      jbinit();
    }catch(Exception e){e.printStackTrace();}

  }//end constructor

  void jbinit() throws Exception{
    super.jbInit();

    super.collectingAnimationLabel.setVisible(false);

    //set fonts and color on labels to 25 San Serif
    this.instr1.setForeground(Color.black);
    this.instr1.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr1.setText("O.k., here's the countdown...");
    this.instr2.setForeground(Color.black);
    this.instr2.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr2.setText("when the screen says \"JUMP\",");
    this.instr3.setForeground(Color.black);
    this.instr3.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr3.setText("jump as high as you can and");
    this.instr4.setForeground(Color.black);
    this.instr4.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr4.setText("slap the highest light you can");
    this.instr5.setForeground(Color.black);
    this.instr5.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr4.setText("reach!");

    /*super.collectionTextLabel.add(instr1, 0);
    super.collectionTextLabel.add(instr2, 1);
    super.collectionTextLabel.add(instr3, 2);
    super.collectionTextLabel.add(instr4, 3);
    super.collectionTextLabel.add(instr5, 4);*/

    //**HACK directly place instructions on panel instead of in collectionTextLabel
    this.add(instr1, new XYConstraints(330, 83, -1, -1));
    this.add(instr2, new XYConstraints(330, 113, -1, -1));
    this.add(instr3, new XYConstraints(330, 143, -1, -1));
    this.add(instr4, new XYConstraints(330, 173, -1, -1));
    this.add(instr5, new XYConstraints(330, 203, -1, -1));


    this.countdownOneLabel.setFont(new java.awt.Font("SansSerif", 1, 80));
    this.countdownTwoLabel.setFont(new java.awt.Font("SansSerif", 1, 80));
    this.countdownThreeLabel.setFont(new java.awt.Font("SansSerif", 1, 80));
    this.countdownJumpLabel.setFont(new java.awt.Font("SansSerif", 1, 80));

    //set contents of labels
    this.countdownOneLabel.setText(new String("1.."));
    this.countdownTwoLabel.setText(new String("2.."));
    this.countdownThreeLabel.setText(new String("3.."));
    this.countdownJumpLabel.setText(new String("JUMP!"));

    //set placement of coordinate plane
    this.countdownOneLabel.setForeground(Color.black);
    this.countdownOneLabel.setVisible(false);
    super.add(countdownOneLabel, new XYConstraints(320, 300, -1, -1));
    this.countdownTwoLabel.setForeground(Color.black);
    this.countdownTwoLabel.setVisible(false);
    super.add(countdownTwoLabel, new XYConstraints(410, 300, -1, -1));
    this.countdownThreeLabel.setForeground(Color.black);
    this.countdownThreeLabel.setVisible(false);
    super.add(countdownThreeLabel, new XYConstraints(500, 300, -1, -1));
    this.countdownJumpLabel.setForeground(Color.black);
    this.countdownJumpLabel.setVisible(false);
    super.add(countdownJumpLabel, new XYConstraints(320, 390, -1, -1));
  }

  public void startJumpCount(){
    //clear from last use (i.e. - if rerouted to this card)
    System.out.println("Reseting labels...");
    countdownOneLabel.setVisible(false);
    countdownTwoLabel.setVisible(false);
    countdownThreeLabel.setVisible(false);
    countdownJumpLabel.setVisible(false);

    System.out.println("Starting countdown thread...");
    new Thread() {
      public void run() {
        //show in 1 second intervals
        synchronized (this) {
          try {
            System.out.println("Waiting for user to read instructions...");
            wait(5000);
            countdownOneLabel.setVisible(true);
            System.out.println("1...");
            wait(1000);
            countdownTwoLabel.setVisible(true);
            System.out.println("2...");
            wait(1000);
            countdownThreeLabel.setVisible(true);
            System.out.println("3...");
            wait(1000);
            countdownJumpLabel.setVisible(true);
            System.out.println("Jump!");
          }
          catch (InterruptedException e) {
            return;
          }
        }
      }
    }.start();
    System.out.println("startJumpCount returning...");
  }
}