package edu.ucf.cs.dml.simnets.measureme.client;
import edu.ucf.cs.dml.simnets.measureme.devices.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.net.*;
import java.util.*;
import java.beans.*;
import edu.ucf.cs.dml.mapthing.*;

/**
 * Important parameters
 *   AvatarCount
 */

public class MeasureMeFrame extends JFrame implements GuiInterface, WorldMapCallbackInterface
{
  CardLayout cardLayout1 = new CardLayout();
  JPanel introPanel = new JPanel();
  XYLayout xYLayout1 = new XYLayout();
  JButton introAnimBn = new JButton();
  //JPanel teachPanel = new JPanel();
  String introAnimURL=null;
  ImageIcon introAnimImage=null;
  ImageIcon teachAnimImage=null;
  ImageIcon dnArrowImage=null;
  JLabel warningLabel = new JLabel();
  XYLayout xYLayout2 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  PickColorDialog pickColorDialog=null;
  KeyCodeHandler kHandler=new KeyCodeHandler(this); //set up the scanning events
  ReactionTimeInstructionPanel rtip=null;

  //private transient Vector clientEntersStationListeners;
  //private transient Vector clientLeavesStationListeners;
  private transient Vector clientStartsMeasurementListeners;
  private transient Vector clientStopsMeasurementListeners;
  private transient Vector ageSelectedListeners;
  private transient Vector avatarSelectedListeners;
  private transient Vector clientEnteredDemographicsListeners;
  GuiParameters gp=null;
  protected String idString="";
  protected String lastID="";
  public static int TERMINAL_CODE=10;
  public static String NULL_STRING="0000";
  protected URL instructionsURL=null;
  DeviceInterface device=null;
 // JButton goMeasurementsBn = new JButton();


  int avatarCount=0;
  String stationName=null;
  public static URL baseURL=null;
  Color pickedColor=null;
  OSCWorldPanel oSCWorldPanel1 = null;
  ChooseAvatarPanel chooseAvatarPanel1;
  AvatarInformation avatarInf=null;
  NewAgePanel ageGridPanel1;
  private transient Vector intermediateLocationChosenListeners;
  private transient Vector finalAreaSelectedListeners;
  JLabel stationNameLabel = new JLabel();
  //JLabel tryItLabel = new JLabel();
  protected boolean deviceActivated =false;  //tells whether device activates the collection
                                             //or is a button click
  ImageIcon instructionsIcon=null;
  //JLabel instrLabel = new JLabel();
  InstructionsPanel instructionsPanel1;
  DataCollectionPanel dataCollectionPanel1 = null;
  short currentAvatarCode=0;
  DisplayDataPanel displayDataPanel1;
  private transient Vector genderSelectedListeners;
  GenderPanel genderPanel1;
  private transient Vector clientEndsStationListeners;
  private transient Vector clientRestartsStationListeners;
  EndPanel endPanel1;
  JLabel dnArrowLabel = new JLabel();

  HangTimeWeightPopup htPopup=null;  //only used in the hangtime station
  JumpCountdownPanel jumpCountdownPanel = new JumpCountdownPanel();
  RunningJumpPanel runningJumpPanel = null;


//the introductory image

  protected class AnimInf
  { String name=null;
    ImageIcon imageIcon=null;
    public AnimInf(String name, ImageIcon image)
    { this.name=name;
      this.imageIcon=image;
    }

    public ImageIcon getImageIcon()
    { return imageIcon;
    }
    public String getName()
    { return name;
    }
  }


  //Construct the frame
  public MeasureMeFrame() {
    disableEvents(AWTEvent.WINDOW_EVENT_MASK);

    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public MeasureMeFrame(StationParameters params,AvatarInformation avatarInf)
  {
    this.avatarInf=avatarInf;
    gp=params.getGuiParameters();
    chooseAvatarPanel1 = new ChooseAvatarPanel(gp);
    instructionsPanel1 = new InstructionsPanel(gp);
    endPanel1 = new EndPanel(gp);
    genderPanel1 = new GenderPanel(gp);
    ageGridPanel1 = new NewAgePanel(gp);


    try  {

     stationName=params.getStationName();
     this.baseURL=(URL)gp.getParameter("baseURL");
     System.out.println("BaseURL **** "+gp.getParameter("baseURL"));
     introAnimImage=new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"intro/"+(String) gp.getParameter("introURL")));
     this.dnArrowImage=new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"intro/arrow150.gif" ));
     this.dnArrowLabel.setIcon(this.dnArrowImage);
     System.out.println(new URL((URL)gp.getParameter("baseURL"),"intro/"+stationName+"/intro.gif" ));
     System.out.println(new URL((URL)gp.getParameter("baseURL"),"maps/"));
     this.dataCollectionPanel1=new DataCollectionPanel(gp);

     displayDataPanel1 = new DisplayDataPanel(stationName, gp);
     runningJumpPanel = new RunningJumpPanel(this, gp);


     //teachAnimImage=new ImageIcon(new URL((URL)gp.getParameter("baseURL"),(String)gp.getParameter("teachURL")));
     this.oSCWorldPanel1= new OSCWorldPanel(this,new URL((URL)gp.getParameter("baseURL"),"maps/"));
     System.out.println(new URL((URL)gp.getParameter("baseURL"),"/maps"));

     Class valueMapClass = Class.forName(params.getValueMapName());
     ValueMap vm = (ValueMap) valueMapClass.newInstance();
     this.displayDataPanel1.setValueMap(vm);

/*     if(gp.getParameter("instructionsLabel1")!=null)
      this.instructionsPanel1.setInstructionsText1((String)gp.getParameter("instructionsLabel1"));
     if(gp.getParameter("instructionsLabel2")!=null)
      this.instructionsPanel1.setInstructionsText2((String)gp.getParameter("instructionsLabel2"));
     if(gp.getParameter("instructionsLabel3")!=null)
      this.instructionsPanel1.setInstructionsText3((String)gp.getParameter("instructionsLabel3"));
*/
     if (gp.getParameter("instructionText") != null) {
       this.instructionsPanel1.setInstructionText((String)gp.getParameter("instructionText"));
     }

     Integer pdeviceActivated=(Integer)gp.getParameter("deviceActivated");

     if(pdeviceActivated!=null)
     { this.deviceActivated=(pdeviceActivated.intValue()==1);
       System.out.println("DeviceActivated: " + this.deviceActivated);
     }
     else
       System.out.println("DeviceActivated: null");


     this.introAnimBn.setIcon(introAnimImage);
     //this.instructiionsBn.setIcon(teachAnimImage);
     jbInit();
     if(params.getStationName().equals("Hang Time"))
     { this.dataCollectionPanel1.setWantsDigitalDisplay(true);
       //this.htPopup=new HangTimeWeightPopup(this,"",true,this.displayDataPanel1); // CEH changed on 9/13/2002

     }


     this.instructionsPanel1.addClientStartsMeasurementListener(new ClientStartsMeasurementListener() {
       public void dataChanged(ClientStartsMeasurementEvent e) {
        fireDataChanged(e);
       }
     });

     //this.instructionsPanel1.setDeviceActivated(this.deviceActivated);
     /*if(!this.deviceActivated)
     {  this.instructionsPanel1.addTryItButtonListener(new java.awt.event.ActionListener()
        { public void actionPerformed(ActionEvent e)
          { fireDataChanged(new ClientStartsMeasurementEvent(this));

          }


         }
        );
        this.instructionsPanel1.addMouseListener(    new java.awt.event.MouseAdapter()
        {
          public void mouseClicked(MouseEvent e)
          { fireDataChanged(new ClientStartsMeasurementEvent(this));

          }
         }
         );

       //add a listener ***************************************************

     }
*/
     if(this.stationName.equals("Reaction Time"))
     { this.rtip=new ReactionTimeInstructionPanel();
       this.getContentPane().add(rtip, "ReactionTimePanel");
       this.cardLayout1.addLayoutComponent(rtip,"ReactionTimePanel");
     }


     flipToMainIntro();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

  }
  public MeasureMeFrame(String introAnimURL,String teachAnimURL)
  { this.introAnimURL=introAnimURL;
    try  {
     introAnimImage=new ImageIcon(new URL(this.introAnimURL));
     //teachAnimImage=new ImageIcon(new URL(teachAnimURL));
     this.introAnimBn.setIcon(introAnimImage);
     //this.instructiionsBn.setIcon(teachAnimImage);
     jbInit();
     flipToMainIntro();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    //this.disableEvents(AWTEvent.WINDOW_EVENT_MASK);

    this.pickColorDialog=new PickColorDialog(this,"Choose Color",true);

    this.getContentPane().setLayout(cardLayout1);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    this.setResizable(false);
    this.setSize(new Dimension(800, 600));
    this.setTitle("OSC - MeasureMe");

    this.addComponentListener(new java.awt.event.ComponentAdapter()
    {

      public void componentMoved(ComponentEvent e)
      {
        this_componentMoved(e);
      }
      public void componentResized(ComponentEvent e)
      {
        //this_componentResized(e);
      }
    });
//    this.addKeyListener(new java.awt.event.KeyAdapter() {
//
//      public void keyPressed(KeyEvent e) {
//        this_keyPressed(e);
//      }
//    });

    introPanel.setLayout(xYLayout1);
    introAnimBn.setRequestFocusEnabled(false);
    introAnimBn.setBorderPainted(false);
    introAnimBn.setFocusPainted(false);
    introAnimBn.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        introAnimBn_actionPerformed(e);
      }
    });
    //teachPanel.setLayout(xYLayout2);
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 20));
    jLabel1.setText("Instructions for this Station.");
    //this.cardLayout1.addLayoutComponent("introPanel",introPanel);
    //goMeasurementsBn.setFont(new java.awt.Font("Dialog", 2, 14));
    //goMeasurementsBn.setText("Try it!!");
    //goMeasurementsBn.addActionListener(new java.awt.event.ActionListener()
    //{

     // public void actionPerformed(ActionEvent e)
     // {
     //   goMeasurementsBn_actionPerformed(e);
    //  }
   // });
    this.stationNameLabel.setText(this.stationName);
    this.stationNameLabel.setVisible(false);



/*    ageGridPanel1.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        ageGridPanel1_mapAreaSelected(e);
      }
    });
*/
    ageGridPanel1.addAgeSelectedListener(new edu.ucf.cs.dml.simnets.measureme.client.AgeSelectedListener()
    {

      public void ageSelected(AgeSelectedEvent e)
      {
        ageGridPanel1_ageSelected(e);
      }
    });
    stationNameLabel.setFont(new java.awt.Font("Serif", 0, 20));


    //this.getContentPane().add(teachPanel, "teachPanel");
    //teachPanel.add(goMeasurementsBn, new XYConstraints(363, 539, -1, -1));
    //teachPanel.add(jLabel1, new XYConstraints(262, 14, 248, -1));
    //teachPanel.add(tryItLabel, new XYConstraints(375, 539, -1, -1));
    //teachPanel.add(instrLabel, new XYConstraints(241, 91, -1, -1));

    this.cardLayout1.addLayoutComponent(introPanel,"introPanel");
    this.cardLayout1.addLayoutComponent(dataCollectionPanel1,"dataCollectionPanel1");
    //this.cardLayout1.addLayoutComponent(teachPanel,"teachPanel");
    this.cardLayout1.addLayoutComponent(this.instructionsPanel1,"instructionsPanel");
    this.cardLayout1.addLayoutComponent(this.displayDataPanel1,"displayDataPanel1");
    this.cardLayout1.addLayoutComponent(this.genderPanel1,"genderPanel1");
    this.cardLayout1.addLayoutComponent(this.endPanel1,"endPanel1");

    // added jump specific panels here
    this.cardLayout1.addLayoutComponent(this.jumpCountdownPanel, "jumpCountdownPanel");
    this.cardLayout1.addLayoutComponent(this.runningJumpPanel,"runningJumpPanel");


    genderPanel1.addGenderSelectedListener(new edu.ucf.cs.dml.simnets.measureme.client.GenderSelectedListener()
    {

      public void dataChanged(GenderSelectedEvent e)
      {
        genderPanel1_dataChanged(e);
      }
    });
    displayDataPanel1.addClientRestartsStationListener(new edu.ucf.cs.dml.simnets.measureme.client.ClientRestartsStationListener()
    {

      public void dataChanged(ClientRestartsStationEvent e)
      {
        displayDataPanel1_dataChanged(e);
      }
    });
    displayDataPanel1.addClientEndsStationListener(new edu.ucf.cs.dml.simnets.measureme.client.ClientEndsStationListener()
    {

      public void dataChanged(ClientEndsStationEvent e)
      {
        displayDataPanel1_dataChanged(e);
      }
    });


    //System.out.println(baseURL);
    //System.out.println(new URL(baseURL,"/maps"));


    this.getContentPane().add(instructionsPanel1, "instructionsPanel");
    this.getContentPane().add(oSCWorldPanel1, "locationPanel");
    this.getContentPane().add(chooseAvatarPanel1, "chooseAvatarPanel");
    this.getContentPane().add(ageGridPanel1, "agePanel");
    this.getContentPane().add(introPanel, "introPanel");
    this.getContentPane().add(dataCollectionPanel1, "dataCollectionPanel1");
    this.getContentPane().add(displayDataPanel1, "displayDataPanel1");
    this.getContentPane().add(genderPanel1, "genderPanel1");
    this.getContentPane().add(endPanel1, "endPanel1");
    this.getContentPane().add(jumpCountdownPanel, "jumpCountdownPanel");
    this.getContentPane().add(runningJumpPanel, "runningJumpPanel");


    introPanel.add(warningLabel, new XYConstraints(160, 461, 480, 23));
    introPanel.add(stationNameLabel, new XYConstraints(307, 72, -1, -1));
    introPanel.add(dnArrowLabel, new XYConstraints(343, 438, -1, -1));
    introPanel.add(introAnimBn, new XYConstraints(7, 116, -1, -1));


/*   this.chooseAvatarPanel1.addMapAreaSelectedListener(new MapAreaSelectedListener()
                  { public void mapAreaSelected(MapAreaSelectedEvent e)
                    { System.out.println("firing selected: "+e);
                      fireAvatarSelection(new AvatarSelectedEvent(e));

                    }
                  }
                  );
*/
    chooseAvatarPanel1.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
                    { System.out.println("firing selected: "+e);
                      fireAvatarSelection(new AvatarSelectedEvent(e.getSource()));

                    }
    });

  /*   chooseAvatarPanel1.addMapAreaSelectedListener(new edu.ucf.cs.dml.mapthing.MapAreaSelectedListener()
    {

      public void mapAreaSelected(MapAreaSelectedEvent e)
      {
        chooseAvatarPanel1_mapAreaSelected(e);
      }
    }); */
  }

  //Overridden so we block on System Close
  protected void processWindowEvent(WindowEvent e) {



    if(((e.getID() == WindowEvent.WINDOW_ICONIFIED)) || ((e.getID() == WindowEvent.WINDOW_DEACTIVATED )))
    { if((e.getID() == WindowEvent.WINDOW_ICONIFIED))
      {
       //super.processWindowEvent(new WindowEvent(this,WindowEvent.WINDOW_DEICONIFIED));
       this.setState(Frame.NORMAL);
       this.setLocation(0,0);
       //this.setState();
      }
      System.out.println("Good try bozo!");
    }
    else
    { super.processWindowEvent(e);
      System.out.println(e);
    }

     //this.setVisible(true);
  }


  public void setLocation(int x, int y)
  { System.out.println(x+" " +y);
    super.setLocation(x,y);
  }
  public void setIntroAnim(String urlString)
  {

  }

/*  void this_keyPressed(KeyEvent e)
  {  if(e.getKeyCode()==TERMINAL_CODE)  //end of char
     { System.out.println("idString:"+this.idString);
       if(!this.idString.equals(NULL_STRING))
       {  System.out.println("firing enters evt" );
          this.fireDataChanged(new ClientEntersStationEvent(new String(this.idString )));
          this.lastID=this.idString;
          this.idString="";
       }
       else
       { System.out.println("firing left evt" );
         this.fireDataChanged(new ClientLeavesStationEvent(new String(this.lastID )));
         this.idString=lastID="";
       }
     }
     else
     { this.idString+=e.getKeyChar();
       System.out.print("key: " +e.getKeyChar());
       System.out.println(" keyCode: "+ e.getKeyCode());
     }
    // System.out.print("key: " +e.getKeyChar());
    //  System.out.println(" keyCode: "+ e.getKeyCode());
  }
*/

  void introAnimBn_actionPerformed(ActionEvent e) {

  }

  public synchronized void removeclientEntersStationListener(ClientEntersStationListener l) {
    this.kHandler.removeClientEntersStationListener(l);
  //  if(clientEntersStationListeners != null && clientEntersStationListeners.contains(l)) {
  //    Vector v = (Vector) clientEntersStationListeners.clone();
  //    v.removeElement(l);
  //    clientEntersStationListeners = v;
  //  }
  }

  public synchronized void addclientEntersStationListener(ClientEntersStationListener l) {
   // Vector v = clientEntersStationListeners == null ? new Vector(2) : (Vector) clientEntersStationListeners.clone();
   // if(!v.contains(l)) {
   //   v.addElement(l);
   //   clientEntersStationListeners = v;
   // }
    this.kHandler.addClientEntersStationListener(l);
  }

  public synchronized void removeClientLeavesStationListener(ClientLeavesStationListener l) {
   this.kHandler.removeClientLeavesStationListener(l);
 /*   if(clientLeavesStationListeners != null && clientLeavesStationListeners.contains(l)) {
      Vector v = (Vector) clientLeavesStationListeners.clone();
      v.removeElement(l);
      clientLeavesStationListeners = v;
    } */
  }

  public synchronized void addClientLeavesStationListener(ClientLeavesStationListener l) {
    this.kHandler.addClientLeavesStationListener(l);
  /*  Vector v = clientLeavesStationListeners == null ? new Vector(2) : (Vector) clientLeavesStationListeners.clone();
    if(!v.contains(l)) {
      v.addElement(l);
      clientLeavesStationListeners = v;
    }
   */
  }

/**  protected void fireDataChanged(ClientLeavesStationEvent e) {
    if(clientLeavesStationListeners != null) {
      Vector listeners = clientLeavesStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++) {
        ((ClientLeavesStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }**/

  public synchronized void removeClientEntersStationListener(ClientEntersStationListener l) {
    this.kHandler.removeClientEntersStationListener(l);
 /*   if(clientEntersStationListeners != null && clientEntersStationListeners.contains(l)) {
      Vector v = (Vector) clientEntersStationListeners.clone();
      v.removeElement(l);
      clientEntersStationListeners = v;
    }*/
  }

  public synchronized void addClientEntersStationListener(ClientEntersStationListener l) {
   System.out.println("Adding client enters station listener");
   this.kHandler.addClientEntersStationListener(l);
   /* Vector v = clientEntersStationListeners == null ? new Vector(2) : (Vector) clientEntersStationListeners.clone();
    if(!v.contains(l)) {
      v.addElement(l);
      clientEntersStationListeners = v;
    } */
  }


  public synchronized void removeClientStartsMeasurementListener(ClientStartsMeasurementListener l) {
    if(clientStartsMeasurementListeners != null && clientStartsMeasurementListeners.contains(l)) {
      Vector v = (Vector) clientStartsMeasurementListeners.clone();
      v.removeElement(l);
      clientStartsMeasurementListeners = v;
    }
  }

  public synchronized void addClientStartsMeasurementListener(ClientStartsMeasurementListener l) {
    Vector v = clientStartsMeasurementListeners == null ? new Vector(2) : (Vector) clientStartsMeasurementListeners.clone();
    if(!v.contains(l)) {
      v.addElement(l);
      clientStartsMeasurementListeners = v;
    }
  }

  protected void fireDataChanged(ClientStartsMeasurementEvent e) {
    if(clientStartsMeasurementListeners != null) {
      Vector listeners = clientStartsMeasurementListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++) {
        ((ClientStartsMeasurementListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  public synchronized void removeClientStopsMeasurementListener(ClientStopsMeasurementListener l) {
    if(clientStopsMeasurementListeners != null && clientStopsMeasurementListeners.contains(l)) {
      Vector v = (Vector) clientStopsMeasurementListeners.clone();
      v.removeElement(l);
      clientStopsMeasurementListeners = v;
    }
  }

  public synchronized void addClientStopsMeasurementListener(ClientStopsMeasurementListener l) {
    Vector v = clientStopsMeasurementListeners == null ? new Vector(2) : (Vector) clientStopsMeasurementListeners.clone();
    if(!v.contains(l)) {
      v.addElement(l);
      clientStopsMeasurementListeners = v;
    }
  }

  protected void fireDataChanged(ClientStopsMeasurementEvent e) {
    if(clientStopsMeasurementListeners != null) {
      Vector listeners = clientStopsMeasurementListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++) {
        ((ClientStopsMeasurementListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  public void flipToMainIntro()
  { this.cardLayout1.show(this.getContentPane(),"introPanel");
    //TODO: implement this edu.ucf.cs.dml.simnets.measureme.client.GuiInterface method;
  }

  public void flipToDemographicsCollection()
  {
   this.cardLayout1.show(this.getContentPane(),"getDemographicsPanel");

  }

  public void flipToTeaching()
  {  if(this.instructionsURL==null)
      System.out.println("instructions url was null");
     this.instructionsIcon=new ImageIcon(this.instructionsURL);
     this.instructionsIcon.getImage();
     if(this.instructionsIcon.getImage()==null)
     { System.out.println("image icon image null");
     }
     System.out.println(this.instructionsURL);
     //teachPanel.add(instructiionsBn, new XYConstraints(187, 85, 426, 310));
     this.instructionsPanel1.setInstructionsImage(this.instructionsIcon);
     this.instructionsPanel1.redisplay();


     if(!this.stationName.equals("Reaction Time"))
     { this.cardLayout1.show(this.getContentPane(),"instructionsPanel");
     }
     else
     {
        this.rtip.setInstructionsImage(this.instructionsIcon);
        this.rtip.redisplay();
        this.cardLayout1.show(this.getContentPane(),"ReactionTimePanel");
     }
  }



  public void flipToCollectData()
  {
    System.out.println("flip");
    String testStationName=this.ripSpaces(this.stationName);
    try{
     URL newIconURL=new URL((URL)gp.getParameter("baseURL"),"collectingData/"+this.ripSpaces(this.stationName)+"/"+avatarInf.getAvatarName(this.currentAvatarCode)+".gif");
     System.out.println(newIconURL);
     this.dataCollectionPanel1.setAvatarIcon(new ImageIcon(newIconURL));
       }
    catch(Exception e)
    { e.printStackTrace();
    }
    this.dataCollectionPanel1.redisplay();
    this.cardLayout1.show(this.getContentPane(),"dataCollectionPanel1");

  }

  public void flipToShowResults()
  { this.cardLayout1.show(this.getContentPane(),"displayDataPanel1");

  }

  public void flipToCollectGuide()
  { System.out.println("flipped to guide:");
    this.cardLayout1.show(this.getContentPane(),"chooseAvatarPanel");

  }

  public void flipToCollectGender()
  { System.out.println("flipped to gender:");
    this.cardLayout1.show(this.getContentPane(),"genderPanel1");
  }

  public void flipToCollectAge()
  { this.cardLayout1.show(this.getContentPane(),"agePanel");
    System.out.println("flipped to age:");
  }

  public void flipToCollectLocation()
  { this.cardLayout1.show(this.getContentPane(),"locationPanel");

  }

  public void flipToEndPanel(edu.ucf.cs.dml.simnets.measureme.server.Exhibitor currentExhibitor, Vector exhibitAvailableinfo )
  {this.endPanel1.setStationsAvailable(exhibitAvailableinfo);
   this.endPanel1.setClientExhibitor(currentExhibitor);
   this.cardLayout1.show(this.getContentPane(),"endPanel1");

  }


  public synchronized void removeClientEnteredDemographicsListener(ClientEnteredDemographicsListener l)
  {
    if(clientEnteredDemographicsListeners != null && clientEnteredDemographicsListeners.contains(l))
    {
      Vector v = (Vector) clientEnteredDemographicsListeners.clone();
      v.removeElement(l);
      clientEnteredDemographicsListeners = v;
    }
  }

  public synchronized void addClientEnteredDemographicsListener(ClientEnteredDemographicsListener l)
  {
    Vector v = clientEnteredDemographicsListeners == null ? new Vector(2) : (Vector) clientEnteredDemographicsListeners.clone();
    if(!v.contains(l))
    {
      v.addElement(l);
      clientEnteredDemographicsListeners = v;
    }
  }

  protected void fireDataChanged(ClientEnteredDemographicsEvent e)
  {
    if(clientEnteredDemographicsListeners != null)
    {
      Vector listeners = clientEnteredDemographicsListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientEnteredDemographicsListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

/*  protected void fireDataChanged(ClientEntersStationEvent e)
  {
    if(clientEnteredDemographicsListeners != null)
    {
      Vector listeners = clientEntersStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientEntersStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }
*/


  void goMeasurementsBn_actionPerformed(ActionEvent e)
  {
    fireDataChanged(new ClientStartsMeasurementEvent(this));

  }

  public void showResults(Short[] dataSet,short score,short age)
  {  String testStationName=this.ripSpaces(this.stationName);
    try{
     URL newIconURL=new URL((URL)gp.getParameter("baseURL"),"displayingData/"+this.ripSpaces(this.stationName)+"/"+avatarInf.getAvatarName(this.currentAvatarCode)+".gif");
     System.out.println(newIconURL);
     System.out.println(newIconURL);
     this.displayDataPanel1.setAvatarIcon(new ImageIcon(newIconURL));

       }
    catch(Exception e)
    { e.printStackTrace();
    }
    this.dataCollectionPanel1.stopDisplay();

    this.displayDataPanel1.displayNewDataSet(dataSet,score,age);
    this.flipToShowResults();
  // this.stationResultsLabel.setText("Station Results: " +resObject.toString());


  }

/*  void backImageBn_actionPerformed(ActionEvent e)
  { avatarSelection=new Integer(avatarSelection.intValue()-1);
    if(avatarSelection.intValue() <=0)
    { backImageBn.setEnabled(false);
    }
    avatarStillBn.setIcon( ((AnimInf)avatarImages.get(avatarSelection)).getImageIcon( ) );
    forwardImageBn.setEnabled(true);

  }
*/
 /* void forwardImageBn_actionPerformed(ActionEvent e)
  { avatarSelection=new Integer(avatarSelection.intValue()+1);
    if(avatarSelection.intValue() >= avatarCount-1)
    { forwardImageBn.setEnabled(false);

    }
    avatarStillBn.setIcon( ((AnimInf)avatarImages.get(avatarSelection)).getImageIcon( ) );
    backImageBn.setEnabled(true);
  }*/

/*  void pickColorBn_actionPerformed(ActionEvent e)
  { //jColorChooser1.setVisible(true);
    pickColorBn.setEnabled(false);
    pickColorDialog.setEnabled(true);
    pickColorDialog.setVisible(true);
    this.avatarStillBn.setBackground(pickColorDialog.getColor());
    this.instructiionsBn.setBackground(pickColorDialog.getColor());
    pickColorBn.setEnabled(true);

    //okPickBn.setEnabled(true);
  }
*/
  void jColorChooser1_propertyChange(PropertyChangeEvent e)
  { //avatarStillBn.setForeground(jColorChooser1.getColor());
    System.out.println(e.getNewValue());
  }

  public synchronized void removeAgeSelectedListener(AgeSelectedListener l)
  {
    if (ageSelectedListeners != null && ageSelectedListeners.contains(l))
    {
      Vector v = (Vector) ageSelectedListeners.clone();
      v.removeElement(l);
      ageSelectedListeners = v;
    }
  }

  public synchronized void addAgeSelectedListener(AgeSelectedListener l)
  {
    Vector v = ageSelectedListeners == null ? new Vector(2) : (Vector) ageSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      ageSelectedListeners = v;
    }
  }

  protected void fireAgeSelected(AgeSelectedEvent e)
  {
    if (ageSelectedListeners != null)
    {
      Vector listeners = ageSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((AgeSelectedListener) listeners.elementAt(i)).ageSelected(e);
      }
    }
  }

  public synchronized void removeAvatarSelectedListener(AvatarSelectedListener l)
  {
    if (avatarSelectedListeners != null && avatarSelectedListeners.contains(l))
    {
      Vector v = (Vector) avatarSelectedListeners.clone();
      v.removeElement(l);
      avatarSelectedListeners = v;
    }
  }

  public synchronized void addAvatarSelectedListener(AvatarSelectedListener l)
  {
    Vector v = avatarSelectedListeners == null ? new Vector(2) : (Vector) avatarSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      avatarSelectedListeners = v;
    }
  }

  protected void fireAvatarSelection(AvatarSelectedEvent e)
  {
    if (avatarSelectedListeners != null)
    {
      Vector listeners = avatarSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((AvatarSelectedListener) listeners.elementAt(i)).avatarSelection(e);
      }
    }
  }





  public void areaSelected(String area)
  { System.out.println("Firing area "+area);
    this.fireIntermediateLocationSelected(new IntermediateLocationChosenEvent(area));

  }

  public void finalAreaSelected(String area)
  { System.out.println("Final Firing area "+area );
    this.fireFinalAreaSelected(new FinalAreaSelectedEvent(area));

  }

/*  void chooseAvatarPanel1_mapAreaSelected(MapAreaSelectedEvent e)
  { this.fireAvatarSelection(new AvatarSelectedEvent(e.getSource()));

  }
*/
 /** void ageGridPanel1_mapAreaSelected(MapAreaSelectedEvent e)
  {
    this.fireAgeSelected(new AgeSelectedEvent(e.getSource()));

  }**/

  public synchronized void removeIntermediateLocationChosenListener(IntermediateLocationChosenListener l)
  {
    if (intermediateLocationChosenListeners != null && intermediateLocationChosenListeners.contains(l))
    {
      Vector v = (Vector) intermediateLocationChosenListeners.clone();
      v.removeElement(l);
      intermediateLocationChosenListeners = v;
    }
  }

  public synchronized void addIntermediateLocationChosenListener(IntermediateLocationChosenListener l)
  { this.oSCWorldPanel1.reset();
    Vector v = intermediateLocationChosenListeners == null ? new Vector(2) : (Vector) intermediateLocationChosenListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      intermediateLocationChosenListeners = v;
    }
  }

  protected void fireIntermediateLocationSelected(IntermediateLocationChosenEvent e)
  {
    if (intermediateLocationChosenListeners != null)
    {
      Vector listeners = intermediateLocationChosenListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((IntermediateLocationChosenListener) listeners.elementAt(i)).intermediateLocationSelected(e);
      }
    }
  }

  public synchronized void removeFinalAreaSelectedListener(FinalAreaSelectedListener l)
  {
    if (finalAreaSelectedListeners != null && finalAreaSelectedListeners.contains(l))
    {
      Vector v = (Vector) finalAreaSelectedListeners.clone();
      v.removeElement(l);
      finalAreaSelectedListeners = v;
    }
  }

  public synchronized void addFinalAreaSelectedListener(FinalAreaSelectedListener l)
  { this.oSCWorldPanel1.reset();
    Vector v = finalAreaSelectedListeners == null ? new Vector(2) : (Vector) finalAreaSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      finalAreaSelectedListeners = v;
    }
  }

  protected void fireFinalAreaSelected(FinalAreaSelectedEvent e)
  {
    if (finalAreaSelectedListeners != null)
    {
      Vector listeners = finalAreaSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((FinalAreaSelectedListener) listeners.elementAt(i)).finalAreaSelected(e);
      }
    }
  }

  public void setAvatar(short avatarCode)
  { try
    { //this.teachPanel.remove(this.instructiionsBn);
      this.currentAvatarCode=avatarCode;
      String testStationName=this.ripSpaces(this.stationName);
      this.instructionsURL=new URL((URL)gp.getParameter("baseURL"),"teachAnim/"+testStationName+"/"+avatarInf.getAvatarName(avatarCode)+".gif");
      this.displayDataPanel1.setGraphingIcon(new ImageIcon(new URL((URL)gp.getParameter("baseURL"),"var/"+avatarInf.getAvatarName(avatarCode)+"16.gif")));
      System.out.println(new URL((URL)gp.getParameter("baseURL"),"var/"+avatarInf.getAvatarName(avatarCode)+"16.gif"));
    }
    catch(Exception e)
    { e.printStackTrace();
    }

  }

  void ageGridPanel1_ageSelected(AgeSelectedEvent e)
  { this.fireAgeSelected(new AgeSelectedEvent(e.getSource()));

  }


  String ripSpaces(String stringToRip)
  { String localStr=new String(stringToRip);
    if(localStr.indexOf(" ")>-1)
    {
      return ripSpaces(localStr.substring(0,localStr.indexOf(" "))+localStr.substring(localStr.indexOf(" ")+1)) ;
    }
    else
     return localStr;
  }

  public synchronized void removeGenderSelectedListener(GenderSelectedListener l)
  {
    if (genderSelectedListeners != null && genderSelectedListeners.contains(l))
    {
      Vector v = (Vector) genderSelectedListeners.clone();
      v.removeElement(l);
      genderSelectedListeners = v;
    }
  }

  public synchronized void addGenderSelectedListener(GenderSelectedListener l)
  {
    Vector v = genderSelectedListeners == null ? new Vector(2) : (Vector) genderSelectedListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      genderSelectedListeners = v;
    }
  }

  protected void fireDataChanged(GenderSelectedEvent e)
  {
    if (genderSelectedListeners != null)
    {
      Vector listeners = genderSelectedListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((GenderSelectedListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  void genderPanel1_dataChanged(GenderSelectedEvent e)
  { this.fireDataChanged(e);

  }

  public synchronized void removeClientEndsStationListener(ClientEndsStationListener l)
  {
    if (clientEndsStationListeners != null && clientEndsStationListeners.contains(l))
    {
      Vector v = (Vector) clientEndsStationListeners.clone();
      v.removeElement(l);
      clientEndsStationListeners = v;
    }
  }

  public synchronized void addClientEndsStationListener(ClientEndsStationListener l)
  {
    Vector v = clientEndsStationListeners == null ? new Vector(2) : (Vector) clientEndsStationListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      clientEndsStationListeners = v;
    }
  }

  protected void fireDataChanged(ClientEndsStationEvent e)
  {
    if (clientEndsStationListeners != null)
    {
      Vector listeners = clientEndsStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientEndsStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  public synchronized void removeClientRestartsStationListener(ClientRestartsStationListener l)
  {
    if (clientRestartsStationListeners != null && clientRestartsStationListeners.contains(l))
    {
      Vector v = (Vector) clientRestartsStationListeners.clone();
      v.removeElement(l);
      clientRestartsStationListeners = v;
    }
  }

  public synchronized void addClientRestartsStationListener(ClientRestartsStationListener l)
  {
    Vector v = clientRestartsStationListeners == null ? new Vector(2) : (Vector) clientRestartsStationListeners.clone();
    if (!v.contains(l))
    {
      v.addElement(l);
      clientRestartsStationListeners = v;
    }
  }

  void fireDataChanged(ClientRestartsStationEvent e)
  {
    if (clientRestartsStationListeners != null)
    {
      Vector listeners = clientRestartsStationListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
      {
        ((ClientRestartsStationListener) listeners.elementAt(i)).dataChanged(e);
      }
    }
  }

  void displayDataPanel1_dataChanged(ClientRestartsStationEvent e)
  { this.fireDataChanged(e);

  }

  void displayDataPanel1_dataChanged(ClientEndsStationEvent e)
  { this.fireDataChanged(e);

  }

  void this_componentMoved(ComponentEvent e)
  { //System.out.println(e);
    if((this.getLocation().x!=0) || (this.getLocation().y!=0))
     this.setLocation(0,0);

  }


  public void setWeight(float weight)
  { if(this.htPopup!=null)
     this.htPopup.setWeight(weight);

  }

  public void addAdminRequestListener(AdminRequestListener l)
  { this.kHandler.addAdminRequestListener(l);
  }

  public void setDeviceProxy(DeviceProxy dp)
  { if(this.rtip!=null)
     rtip.setDeviceProxy(dp);

  }



  void this_componentResized(ComponentEvent e)
  { this.setSize(new Dimension(801,601));

  }

  public void flipToJumpCountdown() {
    try {
      URL newIconURL=new URL((URL)gp.getParameter("baseURL"),"collectingData/"+ripSpaces(this.stationName)+"/"+avatarInf.getAvatarName(this.currentAvatarCode)+".gif");
      System.out.println(newIconURL);
      System.out.println("Setting new avatar...");
      jumpCountdownPanel.setAvatarIcon(new ImageIcon(newIconURL));
      System.out.println("Calling redisplay...");
      jumpCountdownPanel.redisplay();
      System.out.println("Showing card...");
      cardLayout1.show(getContentPane(),"jumpCountdownPanel");
      System.out.println("Calling startJumpCount...");
      jumpCountdownPanel.startJumpCount();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void flipToRunningJump() {
    try {
      URL newIconURL=new URL((URL)gp.getParameter("baseURL"),"collectingData/"+ripSpaces(this.stationName)+"/"+avatarInf.getAvatarName(this.currentAvatarCode)+".gif");
      //System.out.println(newIconURL);
      runningJumpPanel.setAvatarIcon(new ImageIcon(newIconURL));
      cardLayout1.show(getContentPane(),"runningJumpPanel");
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

}
