package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import edu.ucf.cs.dml.simnets.measureme.devices.*;
import java.awt.event.*;


/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class ReactionTimeInstructionPanel extends JPanel
{ ReactionTimeDeviceProxy dp=null;
  ButtonGroup bnGroup=new ButtonGroup();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JRadioButton visualRadioButton = new JRadioButton();
  JRadioButton auditoryRadioButton = new JRadioButton();
  JRadioButton tactileRadioButton = new JRadioButton();
  JTextArea jTextArea1 = new JTextArea();
  ImageIcon instructionsImageIcon=null;

  String visString="You've chosen the visible test! Hold the black button down; "+
           " when the green lights start climbing, push the red button quickly!";
  String audString= "You've chosen the auditory test! Hold the black button down; when the "+
          "tone sounds, push the red button quickly!";
  String tacString= "You've chosen the tactile test! Hold the black button down; when the "
                  + "button starts vibrating, push the red button quickly!";
  JLabel instructionsImageLabel = new JLabel();


  public ReactionTimeInstructionPanel()
  {
    try
    {
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  public ReactionTimeInstructionPanel(DeviceProxy dp)
  {
    try
    {
      jbInit();
      this.dp=(ReactionTimeDeviceProxy)dp;
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }


  void jbInit() throws Exception
  {
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 28));
    jLabel1.setText("What\'s your reaction time?");
    jLabel1.setRequestFocusEnabled(false);
    this.setLayout(xYLayout1);
    jLabel2.setText("Choose one of these three test environments:");
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 28));
    jLabel2.setRequestFocusEnabled(false);
    visualRadioButton.setSelected(true);
    visualRadioButton.setText("Visual");
    visualRadioButton.setFont(new java.awt.Font("SansSerif", 1, 28));
    visualRadioButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        visualRadioButton_actionPerformed(e);
      }
    });
    auditoryRadioButton.setFont(new java.awt.Font("SansSerif", 1, 28));
    auditoryRadioButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        auditoryRadioButton_actionPerformed(e);
      }
    });
    auditoryRadioButton.setText("Sound");
    tactileRadioButton.setFont(new java.awt.Font("SansSerif", 1, 28));
    tactileRadioButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        tactileRadioButton_actionPerformed(e);
      }
    });
    tactileRadioButton.setText("Touch");
    jTextArea1.setText("jTextArea1");
    jTextArea1.setWrapStyleWord(true);
    jTextArea1.setLineWrap(true);
    jTextArea1.setBackground(SystemColor.control);
    jTextArea1.setEditable(false);
    jTextArea1.setRequestFocusEnabled(false);
    jTextArea1.setFont(new java.awt.Font("SansSerif", 1, 20));

    this.setRequestFocusEnabled(false);

    this.add(jLabel1, new XYConstraints(223, 10, -1, -1));
    this.add(jLabel2, new XYConstraints(98, 86, -1, -1));
    this.add(visualRadioButton, new XYConstraints(133, 133, -1, -1));
    this.add(auditoryRadioButton, new XYConstraints(354, 133, -1, -1));
    this.add(tactileRadioButton, new XYConstraints(579, 133, -1, -1));
    this.add(instructionsImageLabel, new XYConstraints(391, 355, -1, -1));
    this.add(jTextArea1, new XYConstraints(98, 196, 618, 133));
    this.jTextArea1.setText(visString);
    bnGroup.add(visualRadioButton);
    bnGroup.add(auditoryRadioButton);
    bnGroup.add(tactileRadioButton);

  }

  void visualRadioButton_actionPerformed(ActionEvent e)
  { this.jTextArea1.setText(this.visString);
    if(this.dp!=null)
    {
      new Thread() {
        public void run() {
          dp.setMode("Sight");
        }
      }.start();
    }
    else
     System.err.println("Error: device proxy null in ReactionTimePanel");
  }

  void auditoryRadioButton_actionPerformed(ActionEvent e)
  { this.jTextArea1.setText(this.audString);
    if(this.dp!=null)
    {
      new Thread() {
        public void run() {
          dp.setMode("Sound");
        }
      }.start();
    }
    else
     System.err.println("Error: device proxy null in ReactionTimePanel");

  }

  void tactileRadioButton_actionPerformed(ActionEvent e)
  { this.jTextArea1.setText(this.tacString);
    if(this.dp!=null)
    {
      new Thread() {
        public void run() {
          dp.setMode("Touch");
        }
      }.start();
    }
    else
     System.err.println("Error: device proxy null in ReactionTimePanel");

  }

  public void redisplay()
  { this.jTextArea1.setText(this.visString);
    this.visualRadioButton.setSelected(true);
    if(this.dp!=null)
    {
      new Thread() {
        public void run() {
          dp.setMode("Sight");
        }
      }.start();
    }
    else
     System.err.println("Error: device proxy null in ReactionTimePanel");

  }

  public void setDeviceProxy(DeviceProxy devProxy)
  { this.dp=(ReactionTimeDeviceProxy)devProxy;
    // this.redisplay();
    System.out.println("Setting device proxy");
    if(dp!=null)
    { //((ReactionTimeDeviceProxy)dp).setMode("Chase");
      new Thread() {
        public void run() {
          ((ReactionTimeDeviceProxy)dp).setMode("Chase");
        }
      }.start();
    }

  }

  public void setInstructionsImage(ImageIcon imageI)
  {
     this.instructionsImageIcon=imageI;
     this.instructionsImageLabel.setIcon(this.instructionsImageIcon);
     this.updateUI();
  }

}