package edu.ucf.cs.dml.simnets.measureme.client;

/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class ReactionTimeValueMap extends ValueMap
{
  //the device returns values of 0.. 255 ms
  //actual value range is 0.. 1275 ms

  public ReactionTimeValueMap()
  {
  }
  public String getMetricUnits()
  {
    return "ms";
  }

  /**
   *  Purpose: return an actual value based on the the device value
   *
   */
  public Object getActualValue(Short deviceValue)
  {

    // device has 5 milliseconds per clock tick
    return new Short ((short) (deviceValue.shortValue()*5));
  }

  /**
   * PURPOSE: return a short value in the range of 0..255
   *  based on an actual value
   */
  public Short getInternalValue(Object actualValue)
  {
    return new Short ((short)(((Short) actualValue).shortValue()/5));
  }
}