
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import java.util.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;

public class RulerPanel extends JPanel {
  int majorScoreLineCount=4;
  int minorScoreLineCount=4;
  int scoreLineWidth=64;
  int minorLineHeight=7;
  int majorLineHeight=14;
  protected int scoreLabelLines[]=null;
  protected Vector scoreLabels=new Vector();
  XYLayout xYLayout1 = new XYLayout();
  JLabel unitsLabel = new JLabel();
  Font labelFont=new java.awt.Font("SansSerif", 1, 16);

  public RulerPanel() {
    try {
      jbInit();
      this.setUpLabels();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } // constructor

  void jbInit() throws Exception {
    this.setBackground(Color.yellow);
    this.setBorder(BorderFactory.createLineBorder(Color.black));
    this.setLayout(xYLayout1);
    this.unitsLabel.setFont(this.labelFont);
    this.add(unitsLabel, new XYConstraints(235, 29, -1, -1));
  }




  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    paintScoreLines((Graphics2D) g);
  } // paintComponent

  protected void paintScoreLines(Graphics2D g2)
  { for(int i=0; i<this.minorScoreLineCount;i++)
    { g2.drawLine((2*i+1)*this.scoreLineWidth,0,(2*i+1)*this.scoreLineWidth,this.minorLineHeight);
      g2.drawLine((2*i+2)*this.scoreLineWidth,0,(2*i+2)*this.scoreLineWidth,this.majorLineHeight);
    }
  }

  protected void setUpLabels()
  { JLabel tempLabel=null;
    for(int i=0;i<(this.majorScoreLineCount+this.minorScoreLineCount);i++)
    { tempLabel=new JLabel();
      tempLabel.setBackground(Color.yellow);
      tempLabel.setFont(this.labelFont);
      this.scoreLabels.add(i,tempLabel);
      this.add(tempLabel, new XYConstraints(i*this.scoreLineWidth-9,15 , -1, -1));
      //this.scoreLabels.add(i,

    }
  }

  public void setScoreLabels(Object[] scoreSet)
  { JLabel tempLabel=null;
    // System.out.println("Set scores "+scoreSet.length+" long");
     for(int i=0;i<(this.majorScoreLineCount+this.minorScoreLineCount);i++)
     { tempLabel=(JLabel)this.scoreLabels.elementAt(i);

       String tempString=""+scoreSet[i];
       if(tempString.length()>5)
        tempString=tempString.substring(0,4);
       if(i<scoreSet.length)
        tempLabel.setText(tempString);

     }
     //this.updateUI();
  }

  public void setScoreLabels(Object[] scoreSet, String units)
  { this.setScoreLabels(scoreSet);
    if(units.equals("s"))
     unitsLabel.setText("seconds");
    else
     this.unitsLabel.setText(units);
  }
}