package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.net.URL;
import com.borland.jbcl.control.*;
import java.awt.event.*;

public class RunningJumpPanel extends JPanel {

  JLabel instr1 = new JLabel();
  JLabel instr2 = new JLabel();
  JButton tryAgain = new JButton("Try Again!");
  MeasureMeFrame mainGui;
  XYLayout xYLayout1 = new XYLayout();
  ImageIcon avatarIcon=null;
  JLabel collectingAvatarAnimationLabel = new JLabel();
  TransparentImage transparentCurveImage = new TransparentImage();
  URL baseURL=null;


  /*
  public RunningJumpPanel(){
    super();
    try{
      this.jbInit();
    }catch(Exception e){}
  }//end constructor

  public RunningJumpPanel(GuiParameters gp){
    super(gp);
    try{
      this.jbInit();
    }catch(Exception e){}
  }//end constructor
*/

  public RunningJumpPanel(MeasureMeFrame mainGui, GuiParameters gp) {
    this.mainGui = mainGui;
    this.baseURL = (URL) gp.getParameter("baseURL");
    try {
      this.jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  } //end constructor

  public void jbInit() throws Exception{
    this.setLayout(xYLayout1);
    collectingAvatarAnimationLabel.setBorder(BorderFactory.createLoweredBevelBorder());
    collectingAvatarAnimationLabel.setRequestFocusEnabled(false);
    this.setRequestFocusEnabled(false);
    transparentCurveImage.setDrawEdge(false);
    transparentCurveImage.setImageURL(new URL(this.baseURL,"var/side_wave.gif"));

    this.add(collectingAvatarAnimationLabel, new XYConstraints(44, 116, -1, -1));

    this.instr1.setForeground(Color.black);
    this.instr1.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr1.setText("You cannot make");
    this.instr2.setForeground(Color.black);
    this.instr2.setFont(new java.awt.Font("SansSerif", 1, 25));
    this.instr2.setText("this a running jump!");

    this.tryAgain.setRequestFocusEnabled(false);
    this.tryAgain.setVisible(true);
    this.tryAgain.setFont(new java.awt.Font("SansSerif", 1, 20));
    this.tryAgain.setBorder(BorderFactory.createRaisedBevelBorder());
    this.tryAgain.setPreferredSize(new Dimension(170, 50));
    this.tryAgain.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        tryAgain_actionPerformed(e);
      }
    });

    //**HACK directly place instructions on panel instead of in collectionTextLabel, 1 doesn't work
    this.add(instr1, new XYConstraints(330, 83, -1, -1));
    this.add(instr2, new XYConstraints(330, 113, -1, -1));
    this.add(tryAgain, new XYConstraints(450, 400, -1, -1));
    this.add(transparentCurveImage, new XYConstraints(0, 0, -1, -1));
  }

  void tryAgain_actionPerformed(ActionEvent e) {
    mainGui.fireDataChanged(new ClientRestartsStationEvent(this));
    System.out.println("Try again button clicked...");
  }//end jbInit()

  public void setAvatarIcon(ImageIcon avatarImage) {
    this.avatarIcon=avatarImage;
    this.collectingAvatarAnimationLabel.setIcon(this.avatarIcon);
  }
}