package edu.ucf.cs.dml.simnets.measureme.client;

import net.jini.core.entry.Entry;
import java.io.*;
/**
 * Contains all the parameters for a particular station.
 * This class can be written to a JavaSpace.
 * @author Dean Reed
 */

public class StationParameters implements Entry, Serializable {
  // these must be public to be an Entry; also must have a public,
  // no-arg constructor and all members must be objects, not primitives
  public String stationName = null;
  public String deviceName = null;
  public String deviceProxyName = null;
  public String valueMapName = null;
  public GuiParameters guiParameters = null;

  public StationParameters() {}

  public String getStationName() {
    return stationName;
  } // getStationName

  public void setStationName(String newStationName) {
    stationName = newStationName;
  } // setStationName

  public String getDeviceName() {
    return deviceName;
  } // getDevice

  public void setDeviceName(String newDeviceName) {
    deviceName = newDeviceName;
  } // setDevice

  public String getDeviceProxyName() {
    return deviceProxyName;
  } // getDeviceProxyName

  public void setDeviceProxyName(String newDeviceProxyName) {
    deviceProxyName = newDeviceProxyName;
  } // setDeviceProxyName

  public String getValueMapName() {
    return valueMapName;
  } // getValueMap

  public void setValueMapName(String newValueMapName) {
    this.valueMapName = newValueMapName;
  } // setValueMap

  public GuiParameters getGuiParameters() {
    return guiParameters;
  } // getGuiParameters

  public void setGuiParameters(GuiParameters newGuiParameters) {
    guiParameters = newGuiParameters;
  } // setGuiParameters

  public String toString() {
    return "station parameters for " + stationName;
  } // toString
} // StationParameters