package edu.ucf.cs.dml.simnets.measureme.client;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;


/**
 * Title:        Measure Me client side classes/source
 * Description:  The source code for the measure me orlando science center project.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class StatusDialog extends JDialog implements Runnable {
  JProgressBar jProgressBar1 = new JProgressBar();
  JButton shutdownBn = new JButton();
  XYLayout xYLayout1 = new XYLayout();
  boolean run = true;
  JTextArea statusText = new JTextArea();

  public StatusDialog() {
    super();
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) throws Exception {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
      return;
    }
    StatusDialog statusDialog1 = new StatusDialog();
    statusDialog1.start();
    Thread.sleep(10000);
    statusDialog1.stop();
  }

  private void jbInit() throws Exception {
    this.setTitle("Status");
    this.setModal(false);
    this.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
    jProgressBar1.setValue(100);
    jProgressBar1.setForeground(Color.blue);
    jProgressBar1.setRequestFocusEnabled(false);
    this.setResizable(false);
    this.getContentPane().setLayout(xYLayout1);
    shutdownBn.setText("Shut Down");
    shutdownBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        shutdownBn_actionPerformed(e);
      }
    });
    xYLayout1.setWidth(358);
    xYLayout1.setHeight(209);

    statusText.setWrapStyleWord(true);
    statusText.setLineWrap(true);
    statusText.setRequestFocusEnabled(false);
    statusText.setBackground(SystemColor.control);
    statusText.setEditable(false);
    statusText.setFont(new java.awt.Font("Dialog", 1, 22));
    this.getContentPane().add(shutdownBn, new XYConstraints(130, 164, -1, -1));
    this.getContentPane().add(jProgressBar1, new XYConstraints(40, 128, 278, -1));
    this.getContentPane().add(statusText, new XYConstraints(40, 27, 277, 90));
    this.pack();
  }

  public void run() {
    int i=0;
    while (run) {
      i %= 100;
      jProgressBar1.setValue(i);
      i += 5;
      try{
        Thread.sleep(100);
      }
      catch(Exception e) {
        return;
      }
    }
  }

  public void start() {
    this.setVisible(true);
    run = true;
    new Thread(this).start();
  }

  public void stop() {
    run = false;
    this.setVisible(false);
  }

  void shutdownBn_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  public void setText(String text) {
    this.statusText.setText(text);
  }

} // StatusDialog