
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.net.URL;
import java.awt.event.*;
import javax.sound.sampled.*;
import javax.sound.midi.*;

public class TrombonePanel extends JPanel
{
  ImageIcon tromboneIcon=null;
  XYLayout xYLayout1 = new XYLayout();
  JLabel trombonePicLabel = new JLabel();
  protected int trHandlePos =215;  //the handle position
  protected int trHeight = 28;     //the height of the slide handle
  protected int trLen = 100;       //basic handle length
  protected int rightMax =571;     //rightmost area on screen to draw
  protected int trTopBar=91;
  protected int trBotBar=119;
  protected int lastCursorPos=trHandlePos+10;
  BasicStroke bSt=new BasicStroke(6);

  Sequencer sequencer=null;      // a sequencer drives a synthesizer
  Transmitter seqTrans=null;     // an object that propegates midi events
  Synthesizer synthesizer=null;  // a synthesizer produces audio data
  Receiver synthReceiver=null;   // a listener for midi events
  MidiChannel[] mc=null;
  //midi state values
  boolean pitchMode=true;
  int standardPitchBend=16000;
  int currentPitchBend=16000;
  int currnentNote=64;
  int standardNote=64;
  ShortMessage currentMessage=new ShortMessage();
  int bendRange=32767/((this.rightMax-this.trLen)-this.trHandlePos); //range jumps for pitch
  float noteRange=(float)(128.0/(float)((this.rightMax-this.trLen)-this.trHandlePos));

  public TrombonePanel() throws Exception
  {
    try
    { //URL u=new URL("file:///C|/mmanim/var/halftrombone.gif");

      //System.out.println(u);
      //this.tromboneIcon=new ImageIcon(u);

      this.tromboneIcon=new ImageIcon("C:\\mmanim\\var\\halftrombone.gif");
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }

  try{
    this.sequencer=MidiSystem.getSequencer();
    this.sequencer.open();
    }
   catch(MidiUnavailableException muex1)
   { muex1.printStackTrace();
     System.out.println("Unable to obtain sequencer");
     throw new Exception("Unable to obtain sequencer");
   }
   seqTrans=this.sequencer.getTransmitter(); //set up the basic objects for midi events
   this.synthesizer=MidiSystem.getSynthesizer();
   this.synthReceiver =this.synthesizer.getReceiver();
   seqTrans.setReceiver(this.synthReceiver);
   try{
    this.synthesizer.open();
    }
   catch(MidiUnavailableException muex2)
   { muex2.printStackTrace();
     System.out.println("Unable to obtain synth");
     throw new Exception("Unable to obtain synth");
   }
   this.setUpMidi();

  }

  public TrombonePanel(ImageIcon tromboneIcon) throws Exception
  {
    try
    {

      this.tromboneIcon=tromboneIcon;
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }

  try{
    this.sequencer=MidiSystem.getSequencer();
    this.sequencer.open();
    }
   catch(MidiUnavailableException muex1)
   { muex1.printStackTrace();
     System.out.println("Unable to obtain sequencer");
     throw new Exception("Unable to obtain sequencer");
   }
   seqTrans=this.sequencer.getTransmitter(); //set up the basic objects for midi events
   this.synthesizer=MidiSystem.getSynthesizer();
   this.synthReceiver =this.synthesizer.getReceiver();
   seqTrans.setReceiver(this.synthReceiver);
   try{
    this.synthesizer.open();
    }
   catch(MidiUnavailableException muex2)
   { muex2.printStackTrace();
     System.out.println("Unable to obtain synth");
     throw new Exception("Unable to obtain synth");
   }
   this.setUpMidi();

  }

  void jbInit() throws Exception
  {
    this.setLayout(xYLayout1);
    trombonePicLabel.setIcon(tromboneIcon);
    tromboneIcon.setImageObserver(this);
    xYLayout1.setWidth(471);
    xYLayout1.setHeight(130);
    this.setBackground(Color.white);
    this.setMinimumSize(new Dimension(571, 130));
    this.setPreferredSize(new Dimension(571, 130));
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
    {

      public void mouseMoved(MouseEvent e)
      {
        this_mouseMoved(e);
      }
    });
    this.addMouseListener(new java.awt.event.MouseAdapter()
    {

      public void mouseEntered(MouseEvent e)
      {
        this_mouseEntered(e);
      }

      public void mouseExited(MouseEvent e)
      {
        this_mouseExited(e);
      }
    });
    this.add(trombonePicLabel, new XYConstraints(1, 1, -1, -1));

  }

  public void paintComponent(Graphics g)
  { super.paintComponent(g);
    this.repaintHandle((Graphics2D)g,this.lastCursorPos);

  }

  protected void repaintHandle(Graphics2D g2,int x)
  { //draw the lines for the begining of the handle
    g2.setStroke(bSt);
    g2.drawLine(this.trHandlePos-3,this.trTopBar,x,this.trTopBar);
    g2.drawLine(this.trHandlePos-3,this.trBotBar,x,this.trBotBar);
    g2.drawLine(x,this.trBotBar,x,this.trTopBar);
    //draw the oval type end
    g2.drawRoundRect(x,this.trTopBar,this.trLen,this.trHeight,9,9);

  }

  void this_mouseEntered(MouseEvent e)
  {  try{
     this.currentMessage.setMessage(ShortMessage.NOTE_ON,0,this.currnentNote,83);
       }
    catch(Exception e2)
    { e2.printStackTrace();
    }
    this.synthReceiver.send(this.currentMessage,-1);
    this.setCursor(new Cursor(Cursor.HAND_CURSOR));
  }

  void this_mouseMoved(MouseEvent e)
  { if( (e.getX() >=this.trHandlePos) && (e.getX()<=(this.rightMax-this.trLen)))
    { this.lastCursorPos=e.getX();
      this.repaint();
      if(this.pitchMode)
       this.pitchChange(this.lastCursorPos);
      else
       this.noteChange(this.lastCursorPos);
    }
    else
     if ( (e.getX()>(this.rightMax-this.trLen)))
     { this.lastCursorPos=(this.rightMax-this.trLen);
        this.repaint();
       if(this.pitchMode)
        this.pitchChange(this.lastCursorPos);
       else
        this.noteChange(this.lastCursorPos);

     }
     else
     { this.lastCursorPos=this.trHandlePos;
       this.repaint();
       if(this.pitchMode)
        this.pitchChange(this.lastCursorPos);
       else
        this.noteChange(this.lastCursorPos);
     }
  }

  /**
   * Set up the midi environment
   */
  protected void setUpMidi()
  {
    Instrument[] instruments=synthesizer.getAvailableInstruments();
    mc=this.synthesizer.getChannels();
   // mc[0].programChange(57);
   //  System.out.println("Hi");
   // return;
    //MidiChannel[] mc=null;
    if(instruments!=null)
     for(int i=0;i<instruments.length;i++)
     {
       if(instruments[i].getName().equals("Trombone"))
       { System.out.println(instruments[i]);
         System.out.println( instruments[i].getPatch().getProgram());

         System.out.println( this.synthesizer.loadInstrument(instruments[i]));
         mc=this.synthesizer.getChannels();
         System.out.println(mc[0].getProgram());
    //     mc[0].setPitchBend(100);
         mc[0].programChange(instruments[i].getPatch().getProgram());
        // mc[0].programChange(instruments[i].get);
         //this.sequencer.
         //this.synthesizer.
       }
     }

  }

  /**
   *  PURPOSE: change the note 0..128 . Some of these values cannot be heard by the
   *   human ear.
   */
  void noteChange(int xVal)
  { ShortMessage msg=new ShortMessage();
    try{
     msg.setMessage(ShortMessage.NOTE_OFF,0,this.currentMessage.getData1(),this.currentMessage.getData2());
     this.synthReceiver.send(msg,-1);
     Thread.sleep(30);
    // System.out.println(Math.round((xVal-this.trHandlePos)*this.noteRange));
     this.currentMessage.setMessage(ShortMessage.NOTE_ON, this.currentMessage.getChannel(),Math.round((xVal-this.trHandlePos)*this.noteRange),this.currentMessage.getData2() );
     this.synthReceiver.send(currentMessage,-1);
     }
     catch(Exception e)
     { e.printStackTrace();
     }

  }
  /**
   * Purpose: change the pitch bend 0..3276x
   */
  void pitchChange(int xVal)
  {
    int pitchBend= (xVal+1-this.trHandlePos) * this.bendRange;
    //System.out.println(pitchBend);
    if(xVal!=0)
     mc[0].setPitchBend(pitchBend/*(xVal*100)*/);
  }

  void this_mouseExited(MouseEvent e)
  {  ShortMessage msg=new ShortMessage();
    try{
     msg.setMessage(ShortMessage.NOTE_OFF, 0,this.currentMessage.getData1(), this.currentMessage.getData2());
     this.synthReceiver.send(msg,-1);
     }
     catch(Exception e2)
     { e2.printStackTrace();
     }
    this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));


  }

  public void setPitchBendMode(boolean b)
  { this.pitchMode=b;
  }

}