
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.client;
/**
 * PURPOSE: Converts a device value into the actual value. For example,
 *  the height value map might return 9.5 (meters)  for value of 255
 *  Addendum: OSC changed base to english standard measure.. very scientific.
 */
public abstract class ValueMap implements java.io.Serializable
{ protected String metricUnits=""; //the units value

  public ValueMap()
  {
  }

  /**
   *  Purpose: return an actual value based on the the device value
   *
   */
  public abstract Object getActualValue(Short deviceValue);

  /**
   * PURPOSE: return a short value in the range of 0..255
   *  based on an actual value
   */
  public abstract Short getInternalValue(Object actualValue);

  /**
   * PURPPOSE: get the metric units for this object
   *  I.E. centimeters = "cm"
   *  Addendum: OSC wants english units as standard.
   */
  public abstract String getMetricUnits();



}