package edu.ucf.cs.dml.simnets.measureme.dbase;

import java.sql.*;

/**
 * Attempts to make a connection via JDBC to a PostgreSQL database.  The JDBC
 * jar file must be in the classpath.  Change the database name, username, and
 * password to match your setup.
 */
public class DBConnectionTest {
  private final String HOST = "192.168.0.1";
  private final String DBNAME = "measureme";
  private final String USER = "postgres";
  private final String PASSWD = "measureme";

  public DBConnectionTest() {
    System.out.println("Connecting to DB...if no error messages then all is OK");

    // load the JDBC driver
    try {
      Class.forName("org.postgresql.Driver");
    }
    catch (ClassNotFoundException e) {
      System.out.println("You might want to check that driver is in classpath.\n");
      e.printStackTrace();
    }

    // create the connection string
    String url = "jdbc:postgresql://"+HOST+"/"+DBNAME;

    // get a connection
    try {
      Connection con = DriverManager.getConnection(url, USER, PASSWD);
    }
    catch (SQLException e) {
      System.out.println("Error connecting to database.\n");
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    new DBConnectionTest();
  }
}