
/**
 * Title:        Analysis Station<p>
 * Description:  Analysis Station Code<p>
 * Copyright:    Copyright (c) Dean Reed<p>
 * Company:      IST/DML<p>
 * @author Dean Reed
 * @version 1.0
 */
package edu.ucf.cs.dml.simnets.measureme.dbase;
import edu.ucf.cs.dml.simnets.measureme.MeasureMeGlobal;
import java.sql.*;
import java.net.*;
import java.beans.*;

/**
 * Class DatabaseQueryEngine: performs database query services
 */
public class DatabaseQueryEngine
{ protected String urlConnectionStr="jdbc:postgresql://"+MeasureMeGlobal.ipAddress+"/measureme"; // CEH -- changed 9/15/2002  //the network info i.e jdbc:postgresql://132.170.xxx.xxx/testdb
  protected String userName=null;           //user name and password for connection
  protected String pwd=null;
  protected Connection con=null;
  private Integer numQueriesProcessed=new Integer(0);
  private transient PropertyChangeSupport propertyChangeListeners = new PropertyChangeSupport(this);//the remote db connection
  Statement stmt=null;

  public DatabaseQueryEngine(String driverName, String urlConnectionStr, String userName, String pwd)throws ClassNotFoundException, SQLException
  {  Class.forName(driverName);
     this.urlConnectionStr=urlConnectionStr;
     this.userName=userName;
     this.pwd=pwd;
     con = DriverManager.getConnection(urlConnectionStr,
                             userName, pwd);
     stmt = con.createStatement();
  }

  /**
   * PURPOSE: Handle a query to the database and return results. The QueryResults can
   *  be an error on a sql error
   */
  public QueryResults handleDbQuery(QueryReplyRequest query)
  { //java.sql.Statement stmt=null;
    QueryResults qr=null;
    System.out.println("handling query: "+query.getQueryString());
//    try{
//       stmt = con.createStatement();
//       }
//     catch(SQLException sqlEx1)
//     {
//      sqlEx1.printStackTrace();
//       qr=new QueryResults(sqlEx1.getMessage());
//        qr.setReplyToID(query.getReplyToID());
//        return qr;
//     }

     if(query.expectResults())   //a result generating query
     { try{  System.out.println("expect results");

         ResultSet rs=stmt.executeQuery(query.getQueryString());
         qr=new QueryResults(rs);

          }
        catch(SQLException sqlEx2)
        { qr=new QueryResults(sqlEx2.getMessage());
          qr.setReplyToID(query.getReplyToID());
          sqlEx2.printStackTrace();
          return qr;
        }


     }
     else
     { try{
         stmt.executeUpdate(query.getQueryString());
         qr=new QueryResults();
          }
        catch(SQLException sqlEx3)
        {
         sqlEx3.printStackTrace();
         qr=new QueryResults(sqlEx3.getMessage());
          qr.setReplyToID(query.getReplyToID());
          return qr;
        }


     }
     qr.setReplyToID(query.getReplyToID());
     this.setNumQueriesProcessed(new Integer(this.numQueriesProcessed.intValue()+1));
     return qr;
  }

  public void setNumQueriesProcessed(Integer newNumQueriesProcessed)
  {
    Integer  oldNumQueriesProcessed = numQueriesProcessed;
    numQueriesProcessed = newNumQueriesProcessed;
    propertyChangeListeners.firePropertyChange("numQueriesProcessed", oldNumQueriesProcessed, newNumQueriesProcessed);
  }

  public Integer getNumQueriesProcessed()
  {
    return numQueriesProcessed;
  }

  public synchronized void removePropertyChangeListener(PropertyChangeListener l)
  {
    propertyChangeListeners.removePropertyChangeListener(l);
  }

  public synchronized void addPropertyChangeListener(PropertyChangeListener l)
  {
    propertyChangeListeners.addPropertyChangeListener(l);
  }



}