
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.dbase;

import java.awt.*;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.awt.event.*;
import com.borland.jbcl.control.*;
import edu.ucf.cs.dml.simnets.measureme.server.*;
/**
 *  A gui component that sits on a query observer
 */
public class MeasureMeDBQueryFrame extends JFrame implements PropertyChangeListener, NightTimeUpdateFailedListener, NightTimeUpdateSuccessListener
{ private MeasureMeSQLQueryObserver observer=null;
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JButton killBn = new JButton();
  JLabel jLabel2 = new JLabel();
  JLabel numQueriesProcessedLabel = new JLabel();
  JLabel errorLabel = new JLabel();
  JavaSpace space=null;
  JButton runUpdatesBn = new JButton();
  JLabel jLabel3 = new JLabel();
  JLabel nightTimeRunsLabel = new JLabel();
  JLabel nightTimeStatusLabel = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  NightTimeExhibitorUpdates updates=null;
  JLabel jLabel6 = new JLabel();
  JLabel numManualLabel = new JLabel();
  BevelPanel bevelPanel1 = new BevelPanel();
  StationsAvailablePanel stationsAvailablePanel1 = null;
  //new StationsAvailablePanel();
  StationAvailableServer sas=null;
  public MeasureMeDBQueryFrame()
  {
    try
    { sas=new StationAvailableServer();
      stationsAvailablePanel1=new StationsAvailablePanel(sas);
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();

    }


  }

  public static void main(String[] args)
  {    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    MeasureMeDBQueryFrame measureMeDBQueryFrame = new MeasureMeDBQueryFrame();

    measureMeDBQueryFrame.validate();
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = measureMeDBQueryFrame.getSize();
    if (frameSize.height > screenSize.height)
      frameSize.height = screenSize.height;
    if (frameSize.width > screenSize.width)
      frameSize.width = screenSize.width;
    measureMeDBQueryFrame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    measureMeDBQueryFrame.setVisible(true);
    measureMeDBQueryFrame.connectUp();
  }

  private void jbInit() throws Exception
  { this.setTitle("Database Proxy");
    jLabel1.setText("Database Query ");
    this.getContentPane().setLayout(xYLayout1);
    xYLayout1.setWidth(519);
    xYLayout1.setHeight(332);
    this.setSize(520,332);
    killBn.setText("Exit");
    killBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        killBn_actionPerformed(e);
      }
    });
    jLabel2.setForeground(Color.blue);
    jLabel2.setText("#Queries processed");
    numQueriesProcessedLabel.setForeground(Color.blue);
    numQueriesProcessedLabel.setText("0");
    errorLabel.setForeground(Color.blue);
    errorLabel.setText("running");
    runUpdatesBn.setText("run updates");
    runUpdatesBn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        runUpdatesBn_actionPerformed(e);
      }
    });
    jLabel3.setText("#Nightime updates ran");
    nightTimeRunsLabel.setText("0");
    nightTimeStatusLabel.setText("running");
    jLabel4.setText("QueryEngine:");
    jLabel5.setText("UpdateEngine:");
    jLabel6.setText("#Manual updates ran:");
    numManualLabel.setText("0");
    this.getContentPane().add(numQueriesProcessedLabel, new XYConstraints(266, 35, -1, -1));
    this.getContentPane().add(killBn, new XYConstraints(31, 186, -1, -1));
    this.getContentPane().add(nightTimeRunsLabel, new XYConstraints(266, 57, -1, -1));
    this.getContentPane().add(jLabel5, new XYConstraints(23, 139, -1, -1));
    this.getContentPane().add(nightTimeStatusLabel, new XYConstraints(115, 139, -1, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(137, 35, -1, -1));
    this.getContentPane().add(jLabel1, new XYConstraints(178, 6, 97, -1));
    this.getContentPane().add(jLabel3, new XYConstraints(118, 57, 136, -1));
    this.getContentPane().add(jLabel6, new XYConstraints(120, 77, -1, -1));
    this.getContentPane().add(jLabel4, new XYConstraints(23, 115, -1, -1));
    this.getContentPane().add(errorLabel, new XYConstraints(107, 115, -1, -1));
    this.getContentPane().add(numManualLabel, new XYConstraints(266, 77, -1, -1));
    this.getContentPane().add(runUpdatesBn, new XYConstraints(302, 27, -1, -1));
    this.getContentPane().add(bevelPanel1, new XYConstraints(0, 105, 516, 4));
    this.getContentPane().add(stationsAvailablePanel1, new XYConstraints(200, 120, -1, -1));
  }

  public void propertyChange(PropertyChangeEvent evt)
  { if(evt.getPropertyName().equals("numQueriesProcessed"))
    { this.numQueriesProcessedLabel.setText(evt.getNewValue().toString());

    }
    //TODO: Implement this java.beans.PropertyChangeListener method
  }

  public void connectUp()
  {     try
    { this.errorLabel.setText("Looking for javaSpace..");
      space=MMSpaceAccessor.getSpace();
      this.errorLabel.setText("found javaSpace..");

    }
    catch(Exception e)
    { this.errorLabel.setText(e.getMessage());
    }
    try
    { this.errorLabel.setText("making db connection");
      this.observer=new MeasureMeSQLQueryObserver(space);
      observer.addPropertyChangeListener(this);
      this.errorLabel.setText("running");

    }
    catch(ClassNotFoundException ex1)
    { this.errorLabel.setText("Invalid jdbc driver, check postgress driver");
    }
    catch(java.sql.SQLException ex2)
    { this.errorLabel.setText("Error on db connect: " + ex2.getMessage());
      ex2.printStackTrace();
    }
    catch(java.rmi.RemoteException ex3)
    { this.errorLabel.setText("Error on javaspace linkage: " + ex3.getMessage());
    }

    this.updates=new NightTimeExhibitorUpdates(space,20);
    this.updates.addNightTimeUpdateFailedListener(this);
    this.updates.addNightTimeUpdateSuccessListener(this);
  }

  void killBn_actionPerformed(ActionEvent e)
  { this.observer.stop();
    System.exit(0);
  }

  public void dataChanged(NightTimeUpdateFailedEvent e)
  { this.nightTimeStatusLabel.setText("Warning: update failure!");
    //TODO: Implement this edu.ucf.cs.dml.simnets.measureme.dbase.NightTimeUpdateFailedListener method
  }

  public void dataChanged(NightTimeUpdateSuccessEvent e)
  {
    this.nightTimeRunsLabel.setText(Integer.toString( (new Integer(this.nightTimeRunsLabel.getText()).intValue()) +1));

  }

  void runUpdatesBn_actionPerformed(ActionEvent e)
  { if(this.updates.runUpdates())
     this.numManualLabel.setText(Integer.toString( (new Integer(this.numManualLabel.getText()).intValue()) +1));
    else
     this.nightTimeStatusLabel.setText("manual update failed");
  }
}