
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */

package edu.ucf.cs.dml.simnets.measureme.dbase;
import edu.ucf.cs.dml.simnets.measureme.MeasureMeGlobal;
import java.sql.*;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;

public class MeasureMeSQLQueryObserver extends SQLQueryObserver
{

  public MeasureMeSQLQueryObserver( JavaSpace space ) throws ClassNotFoundException, SQLException, java.rmi.RemoteException
  { super("org.postgresql.Driver","jdbc:postgresql://"+MeasureMeGlobal.ipAddress+"/measureme","postgres","measureme",space);
    loadExhibitNums();
    this.loadCountryCodes();
    this.loadCountyCodes();
  }
  /**
   * PURPOSE: preload the javaspace with latest station id codes
   */
  protected void loadExhibitNums() throws java.rmi.RemoteException
  {
     QueryResults template= new QueryResults();
     template.setReplyToID("StationIDs");
     try{
      QueryResults oldResults=(QueryResults)space.takeIfExists(template,null,2000);
     //get rid of old id's and create a newer version

     QueryReplyRequest req=new QueryReplyRequest(
         "SELECT * FROM exhibitnames","StationIDs",true);
        //load a query into the space that this object will process
     space.write(req,null,Lease.FOREVER);
          }
     catch(Exception e)
     { e.printStackTrace();
     }
  }

  protected void loadCountryCodes() throws java.rmi.RemoteException
  {  QueryResults template= new QueryResults();
     template.setReplyToID("CountryCodes");
     try{
      QueryResults oldResults=(QueryResults)space.takeIfExists(template,null,2000);
     //get rid of old id's and create a newer version

     QueryReplyRequest req=new QueryReplyRequest(
         "select * from countrytable;","CountryCodes",true);
        //load a query into the space that this object will process
     space.write(req,null,Lease.FOREVER);
          }
     catch(Exception e)
     { e.printStackTrace();
     }

  }

  protected void loadCountyCodes() throws java.rmi.RemoteException
  {  QueryResults template= new QueryResults();
     template.setReplyToID("CountyCodes");
     try{
      QueryResults oldResults=(QueryResults)space.takeIfExists(template,null,2000);
     //get rid of old id's and create a newer version

     QueryReplyRequest req=new QueryReplyRequest(
         "select * from countytable;","CountyCodes",true);
        //load a query into the space that this object will process
     space.write(req,null,Lease.FOREVER);
          }
     catch(Exception e)
     { e.printStackTrace();
     }

  }


}