package edu.ucf.cs.dml.simnets.measureme.dbase;
import net.jini.core.entry.Entry;
/**
 * CLASS QueryReplyRequest: a space object that represents a query to some database,
 *   the assumption is that a proxy will execute the query, and respond to this
 *   query by using the supplied respondto field.
 * @author Dean Reed 6/12/00
 */
public class QueryReplyRequest implements Entry
{ public String replyToID=null;
  public Boolean expectResults=null;
  public String queryString=null;

  public QueryReplyRequest()
  {}

  public QueryReplyRequest(String queryString, String replyToID, boolean expectResults)
  { this.queryString=queryString;
    this.replyToID=replyToID;
    this.expectResults=new Boolean(expectResults);
  }


  public boolean expectResults()
  { if(expectResults!=null)
     return this.expectResults.booleanValue();
    else
     return false;

  }

  public void setReplyToID(String newReplyToID)
  {
    replyToID = newReplyToID;
  }

  public String getReplyToID()
  {
    return replyToID;
  }

  public String getQueryString()
  {
    return queryString;
  }

  public void setQueryString(String newQueryString)
  {
    queryString = newQueryString;
  }

  public String toString() {
    return "QueryReplyRequest from "+replyToID;
  }

}