
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.dbase;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;
import java.util.*;

/**
 * CLASS RequestStationData: This class is resonsible for retrieving station
 * related data via the javaspaces, and indirectly from the jbcl proxy that
 * is listening.
 *
 */
import java.util.Hashtable;
public class RequestStationData
{
  protected String stationName=null;
  protected  JavaSpace space=null;
  public RequestStationData(String stationName, JavaSpace space)
  { this.stationName=stationName;
    this.space=space;

  }
  /**
   * PURPOSE: get the station data
   * @throws some exception when java.lang.InterruptedException has been reached and no reply
   * @returns null on error
   * @returns Hashtable of this stations age data on a valid query key: age value: Short
   */
  public Hashtable getStationData(long timeout) throws java.lang.InterruptedException
  {
 // select * from exhibitagescores where exhibitnames.exhibitname='Hang Time' and exhibitnames.exhibitcode=exhibitagescores.exhibitcode;
     //create a new query for this stations age data
     try{

     QueryReplyRequest qrr =new QueryReplyRequest(
      "select * from exhibitagescores where exhibitnames.exhibitname='"+this.stationName+"' and exhibitnames.exhibitcode=exhibitagescores.exhibitcode order by age;",
      stationName+"StationData",true);

     System.out.println("RequestStationData.getStationData() wrote station data request");
     space.write(qrr,null,Lease.FOREVER); //write the request

     QueryResults qrsTemplate=new QueryResults();//wait on results
     qrsTemplate.replyToID=stationName+"StationData";

     System.out.println("RequestStationData.getStationData() waiting for station data results");
     QueryResults qr = null;
     try {
       qr=(QueryResults)space.take(qrsTemplate,null,timeout);
     }
     catch (Exception e) {
       System.out.println("RequestStationData.getStationData() exception during result take");
       e.printStackTrace();
     }
     System.out.println("qr:"+qr);
     if(qr==null) {
      //System.out.println("qr:"+qr.getError());
      return null;
     }
     else
     { ResultHolder rh=qr.getResults();
       int columnCt =rh.getColumnCount();
       int rowCt= rh.getRowCount();
       if(rowCt!=100)
        System.out.println("Warning: RequestStationData: getStationData: rows!=100" );
       Hashtable results =new Hashtable(); //end a hashtable based on the result


       //queries were not sorted by age, starting at 1
      //System.out.println()
      /* Vector n=rh.getColumnNames();
       Enumeration enum=n.elements();
       while(enum.hasMoreElements())
       { System.out.print(enum.nextElement()+" ");
       }
       System.out.println("--------results----------");
       System.out.println(rh);
       System.out.println();
*/
      Vector v=rh.getColumn(3);
      //since the database ordered on age, then we can count on consistency

       for(int i=1;i<=v.size();i++)
       { //System.out.println(v.get(i-1));
         Short[] s=(Short[])v.get(i-1);
         //System.out.println(s[0]);
         //System.out.println(s.length);
         results.put(new Short((short)i),s/*v.get(i-1)*/);

       }
       return results;

     //if(qr.getError()==null)
     // return qr.getResults();
      }
    }
    catch(java.rmi.RemoteException re)
    { re.printStackTrace();
    }
    catch(net.jini.core.transaction.TransactionException te)
    { te.printStackTrace();
    }
//    catch(net.jini.core.entry.UnusableEntryException ex)
//    { ex.printStackTrace();
//    }





    return null;
  }

}