package edu.ucf.cs.dml.simnets.measureme.dbase;
import java.sql.*;
import java.util.*;
/**
 * CLASS ResultHolder: A class that simply represents the objects in a
 *  resultset in a semi tabular fashion.
 * @author Dean Reed 6/12/00
 */
public class ResultHolder implements java.io.Serializable
{
  protected Object[][] table=null;
  protected String[] columnNames;
  protected int rows=0;
  protected int cols=0;
  private char readChar='-'; //for parsing
  public ResultHolder(ResultSet set) throws SQLException
  { ResultSetMetaData met = set.getMetaData();
    int i=0,j=0;

    // Edit by M. Lowery on 2002-03-21 (changed absolute(0) to absolute(1))
    // According to ResultSet documentation, absolute(0) has no meaning.  Also
    // changed while loop below to account for i starting at 1 instead of 0.
    // When referring to the table array, do i-1 to be zero-based.

    set.absolute(1);
    if(set.first())   //compute the number of rows involved
    { while(set.next())
     {i++;
      //System.out.println(set.getRow());
     }
     i++;
    }
    if(i>0)             //row then col
    { rows=i;
      table=new Object[i+1][cols=met.getColumnCount()];
      System.out.println(i+" "+cols +" cons");
    }
    else
    { table=new Object[1][1];
      table[0][0]=new String("Empty result");
      return;
    }


    set.absolute(1);

    columnNames=new String[met.getColumnCount()];
    for(j=0;j<met.getColumnCount();j++)
     columnNames[j]=met.getColumnName(j+1);
    i=1;
    set.absolute(1);
    //System.out.println("row: "+set.getRow());
    while(i<=rows)
    { //System.out.println("row: "+i);
      for(j=0;j<met.getColumnCount();j++)
      { try{
          table[i-1][j]=set.getObject(j+1);
          }
        catch(SQLException er)
        { System.out.println(met.getColumnName(j+1));
          //System.out.println(set.getAsciiStream(j+1));
          //System.out.println(set.getCharacterStream(j+1));
          //java.io.Reader r;
          java.io.ByteArrayInputStream bis;
          bis=(java.io.ByteArrayInputStream) set.getBinaryStream(j+1);
          try{
            Short[] dataArray=this.convertBStream(bis);
            table[i-1][j]=dataArray;
            System.out.println("Array is len: "+dataArray.length);
            //Vector v=new Vector();
            //for(int j=0;j<dataArray.length();j++)
            // v.add(j,dataArray[j]);

            //System.out.println("dat[0]:"+dataArray[0]);
            }
          catch(Exception e2)
          { e2.printStackTrace();
          }
         /* int count=0;
          while(bis.available()!=0 && count <5)
          { System.out.print((char)bis.read()+" | ");
            count++;
          }
          System.out.println();
          */

          //byte[] fred=set.getBytes(j+1);
          //set.get
          //System.out.println("Byte Array len "+fred.length);
          //System.out.println("ar[0]:"+fred[0]+" ar[1]:"+fred[1]+ " and "+ (fred[0]&fred[1]));
          //table[i][j]=
          //System.out.println("retry successful: "+table[i][j]);
        }
      }
      i++;
      if(i<=rows)
       set.absolute(i);
    }
  }

  //construct our object table
  public String toString()
  { int i=0;
    int j=0;
    String ret="";
    if(cols==0)
      return "Empty result";
    for(i=0;i<cols;i++)
     ret+=columnNames[i]+"    ";
    ret+="\n";
    for(i=0;i<rows;i++)
    { for(j=0;j<cols;j++)
       ret+=table[i][j]+ " ";
      ret+="\n";
    }


    return ret;
   }

   public int getRowCount()
   { return rows;
   }
   public int getColumnCount()
   { return cols;
   }

   public Vector getColumnNames()
   { Vector retVec=new Vector(cols);
     if(columnNames!=null)
     {
       for(int i=0;i<columnNames.length;i++)
         retVec.addElement(columnNames[i]);
     }
     return retVec;


   }

   public Vector getRow(int rowNum)
   { Vector retVec=new Vector(cols);
     if( (rows >= (rowNum-1)))
     { for(int i=0;i<cols;i++)
       { retVec.addElement(table[rowNum-1][i]);
       }
     }
     return retVec;

   }


   public Vector getColumn(int colNumber)
   { Vector retVec=new Vector(rows);
     if( (cols>-(colNumber-1)))
     { for(int i=0;i<rows;i++)
       { retVec.addElement(table[i][colNumber-1]);
       }
     }
     return retVec;
   }
   /**
    * PURPOSE: Converts the input stream  containing a ascii character representation
    *  of an array of short(16 bit) values formatted like "{0,1,2,3,...}" into
    *  an array of short.
    *  @throws Exception when any character != '{' or ',' or '}' or '0'..'9' and on empty stream
    *
    */
   protected Short[] convertBStream(java.io.ByteArrayInputStream bais) throws Exception
   { if(!(bais.available()>0))
      throw new Exception("Unable to process an empty stream" );
     if(  (readChar=((char)bais.read()))!='{')
      throw new Exception("Array does not start on right brace: }");
     int arrayLen=0;
     Vector tempArray=new Vector();

     Short test=null;
     while((bais.available()>0) && (readChar!='}'))
     { if((readChar==',') || (readChar=='{'))
       {/* if(readChar=='{')
         { System.out.println("left brace");
           tempArray.add(arrayLen,test=getNextShort(bais));
           System.out.println("Brace short: "+test);
         }
         else*/
        tempArray.add(arrayLen,getNextShort(bais));
         arrayLen++;

       }
       else
        readChar=(char)bais.read();

     }
     Short[] returnArray=new Short[tempArray.size()];
     for(int i=0;i<tempArray.size();i++)
       returnArray[i]=(Short)tempArray.get(i);
     return returnArray;
   }

   private Short getNextShort(java.io.ByteArrayInputStream bais) throws Exception
   {  //readChar='-';
      String shortStr="";
      if(bais.available()>0)
      { readChar=(char)bais.read();
        while((bais.available()>0) && ( (readChar>='0') && (readChar<='9')) )
        { shortStr+=readChar;
          readChar=(char)bais.read();
        }
        if(shortStr.length()==0)
         throw new Exception("Error, return string is empty");
        else
         return new Short(shortStr);
      }
      else
       throw new Exception("Invalid call to getNextShort, no input available");
   }


}









