package edu.ucf.cs.dml.simnets.measureme.dbase;
import java.sql.*;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;
import java.beans.*;

/**
 * CLASS SQLQueryObserver: Consistently watches the javaspace for database
 *  queries, and then performs the query, and writes a result back to the
 *   javaspace.
 *   @author Dean Reed 6/12/00
 */
public class SQLQueryObserver extends DatabaseQueryEngine implements Runnable
{        //
//  protected String urlConnectionStr=null;   //the network info i.e jdbc:postgresql://132.170.xxx.xxx/testdb
//  protected String userName=null;           //user name and password for connection
 // protected String pwd=null;
  protected Thread myRunThread=null;
  protected boolean stop=false;
  protected JavaSpace space;
  protected QueryReplyRequest template=new QueryReplyRequest(); //interested in all querys from the space
 // protected Connection con=null;
 // private Integer numQueriesProcessed=new Integer(0);
 // private transient PropertyChangeSupport propertyChangeListeners = new PropertyChangeSupport(this);//the remote db connection
  /**
   * CONSTRUCTOR:
   *  @param driverName the name of the database driver to use
   *  @param urlConnectionStr  the network info i.e jdbc:postgresql://132.170.xxx.xxx/testdb
   *  @param userName user name and password for connection
   *  @throws ClassNotFoundException when no class for driverName is found
   */
  public SQLQueryObserver(String driverName, String urlConnectionStr, String userName, String pwd, JavaSpace space )throws ClassNotFoundException, SQLException
  {  super(driverName,urlConnectionStr,userName,pwd);
     /*Class.forName(driverName);
      this.urlConnectionStr=urlConnectionStr;
      this.userName=userName;
      this.pwd=pwd;

      con = DriverManager.getConnection(urlConnectionStr,
                             userName, pwd);
       */
      this.space=space;
      this.myRunThread=new Thread(this);
      this.myRunThread.start();

  }


  public void run()
  { QueryReplyRequest qrr=null;
    QueryResults res=null;
    while(!stop)
    { try{ qrr=getQuery();
           System.out.println("rec'd query: "+ qrr.getQueryString());
         }
      catch(Exception e)
      { //could not read from the space
        e.printStackTrace();
        qrr=null;
      }
      if((!stop) && (qrr!=null))  //a valid query request
      {  res=handleDbQuery(qrr);  //get the results obj
         try{
           sendResults(res);       //send the results back
           //this.setNumQueriesProcessed(new Integer(this.numQueriesProcessed.intValue()+1));
           }
         catch(Exception e2)
         { e2.printStackTrace();  //error sending back the results
         }

      }


    }

  }

  public void stop()
  { this.stop=true;
  }

  private QueryReplyRequest getQuery() throws java.rmi.RemoteException,java.lang.InterruptedException,
                                       net.jini.core.transaction.TransactionException,
                                       net.jini.core.entry.UnusableEntryException

  {  System.out.println("waiting for query..");
     return (QueryReplyRequest)space.take(template,null,Long.MAX_VALUE);
  }

  private void sendResults(QueryResults qr)throws java.rmi.RemoteException,java.lang.InterruptedException,
                                       net.jini.core.transaction.TransactionException,
                                       net.jini.core.entry.UnusableEntryException
  { System.out.println("writing results back to space");
    space.write(qr,null,Lease.FOREVER);
    System.out.println("wrote results");

  }

 /* private QueryResults handleDbQuery(QueryReplyRequest query)
  { Statement stmt=null;
    QueryResults qr=null;
    System.out.println("handleing query..");
    try{
       stmt = con.createStatement();
       }
     catch(SQLException sqlEx1)
     {  qr=new QueryResults(sqlEx1.getMessage());
        qr.setReplyToID(query.getReplyToID());
        return qr;
     }

     if(query.expectResults())   //a result generating query
     { try{  System.out.println("expect results");

         ResultSet rs=stmt.executeQuery(query.getQueryString());
         qr=new QueryResults(rs);

          }
        catch(SQLException sqlEx2)
        { qr=new QueryResults(sqlEx2.getMessage());
          qr.setReplyToID(query.getReplyToID());
          sqlEx2.printStackTrace();
          return qr;
        }


     }
     else
     { try{
         stmt.executeUpdate(query.getQueryString());
         qr=new QueryResults();
          }
        catch(SQLException sqlEx3)
        { qr=new QueryResults(sqlEx3.getMessage());
          qr.setReplyToID(query.getReplyToID());
          return qr;
        }


     }
     qr.setReplyToID(query.getReplyToID());

     return qr;
  }



  public void setNumQueriesProcessed(Integer newNumQueriesProcessed)
  {
    Integer  oldNumQueriesProcessed = numQueriesProcessed;
    numQueriesProcessed = newNumQueriesProcessed;
    propertyChangeListeners.firePropertyChange("numQueriesProcessed", oldNumQueriesProcessed, newNumQueriesProcessed);
  }

  public Integer getNumQueriesProcessed()
  {
    return numQueriesProcessed;
  }

  public synchronized void removePropertyChangeListener(PropertyChangeListener l)
  {
    propertyChangeListeners.removePropertyChangeListener(l);
  }

  public synchronized void addPropertyChangeListener(PropertyChangeListener l)
  {
    propertyChangeListeners.addPropertyChangeListener(l);
  }

*/






}