CREATE TABLE countrytable(
  countryname varchar(50) UNIQUE,
  countrycode smallint UNIQUE
);
COPY countrytable FROM '/home/dreed/sql/mapCountryDB.txt' USING
DELIMITERS
'|';
CREATE TABLE countytable(
  countyname varchar(50) UNIQUE,
  countycode smallint UNIQUE
);
COPY countytable FROM '/home/dreed/sql/mapCountyDB.txt' USING
DELIMITERS
'|';
CREATE TABLE exhibitagescores(
        age  smallint,
        exhibitcode smallint, --the code for which exhibit
        scores smallint[] --a 256 val array for each exhibit
);
CREATE UNIQUE INDEX age_ecode_index ON exhibitagescores(age,exhibitcode);
DROP FUNCTION initagescores(smallint);
\i initagescorestab.plp
SELECT initagescores(15);
CREATE TABLE exhibitallscores(
        exhibitcode smallint,  --the exhibit code from
                              --exhibit table

        scores smallint[]     --the actual scores

);
CREATE UNIQUE INDEX exhibitnum_index ON exhibitallscores (exhibitnum);
DROP FUNCTION initallscores(smallint);
\i initallscorestab.plp
SELECT initallscores(15);
CREATE TABLE exhibitcountryscores(
        countrycode smallint,
        exhibitcode smallint,
        scores smallint[]   --exhibit scores
);
CREATE UNIQUE INDEX country_code_index ON exhibitcountryscores
(countrycode,exhibitcode);
DROP FUNCTION initcountryscores(smallint,smallint);
\i initcountryscorestab.plp
SELECT initcountryscores(170,15);
CREATE TABLE exhibitcountyscores(
        countycode smallint,
        exhibitcode smallint,
        scores smallint[]
);
CREATE UNIQUE INDEX county_code_index ON exhibitcountyscores
(countycode,exhibitcode);

DROP FUNCTION initcountyscores(smallint);
\i initcountyscorestab.plp
SELECT initcountyscores(15);

CREATE TABLE exhibitgenderscores(
        gender varchar,
        exhibitcode smallint,
        scores smallint[]
);
CREATE UNIQUE INDEX gender_exhibit_index ON
exhibitgenderscores(gender,exhibitcode);
-- initgender
DROP FUNCTION initgender(smallint);
\i initgenderscorestab.plp;
select initgender(15);
CREATE TABLE exhibitnames(
        exhibitname varchar(50),
        exhibitcode smallint
);
CREATE UNIQUE INDEX exhibit_name_code_index ON
exhibitnames(exhibitname,exhibitcode);
COPY exhibitnames FROM '/home/dreed/sql/exhibitnamesDB.txt'
    USING DELIMITERS '|';
drop function checkexhibitor(smallint,date);
\i checkifexhibitorexists.plp 
CREATE TABLE exhibitor(
 id  smallint PRIMARY KEY, -- the actual scancode
 visitdate date, --the day that the exhibitor visited
 age smallint, -- the age of the exhibitor
 weight smallint, --some weight value
 gender varchar, -- male or female
 guide smallint,      -- code used for which guide avatar selected
 countrycode smallint, -- the integer code of the country see the country
                       -- table
 state varchar,   -- the 2 character state representation
 countycode smallint, -- the code for the county see the county table
 schoolgroup smallint, -- the code for the school

 stationvalues smallint[100], --up to 100 2 byte integers station values
                              --station values are given multiplication
                              --Last station  score= (StationID -1)*4 +1
                              --Station id = (index-1) / 4 +1
stationsvisited smallint --denotes the number of stations actually
                          --visited by this exhibitor
 
);
 CREATE UNIQUE INDEX exhibitor_date_index ON exhibitor(id,visitdate);
\i exhibitortabtrigger.plp;
 CREATE TRIGGER trigger_exhibitor BEFORE INSERT ON exhibitor FOR EACH ROW
 EXECUTE PROCEDURE trigger_insert_exhibitor(); 

DROP FUNCTION initschoolgroupscores(smallint);
CREATE TABLE exhibitschoolgroupscores(
        schoolgroup  smallint,
        exhibitcode smallint, --the code for which exhibit
        scores smallint[] --a 256 val array for each exhibit
);
CREATE UNIQUE INDEX sg_ecode_index ON exhibitschoolgroupscores(schoolgroup,exhibitcode);
\i initschoolgroupscorestab.plp
SELECT initschoolgroupscores(15);


\i mktempstatetab.sql
--create/init the temptable
DROP FUNCTION getStateAbbrev(smallint);
\i getstateabbrev.sql
DROP FUNCTION initstatescores(smallint);                              
\i mkexhibitstatescores.sql
--create the scores table  
\i initstatetab.plp
--recreate the function
select initstatescores(15);
--inititialize the main state scores table
DROP TABLE tempstate;
--get rid of the old temp table

