package edu.ucf.cs.dml.simnets.measureme.devices;

import net.jini.core.entry.Entry;
import java.beans.*;

/**
 * CLASS Device: an abstract class that is able to be written to a JavaSpace.
 * @author Dean Reed 6/2/00
 */
public abstract class Device implements java.io.Serializable, DeviceInterface, ConnectionListener
{

  protected String inputString;

  protected String devName=null; //the device id

  protected transient PropertyChangeSupport propertyChangeListeners =null;

  public Device() {
    super();
    propertyChangeListeners=new PropertyChangeSupport(this);
  }

  public Device(String devName) {
    super();
    this.devName=devName;
  }


  public String getDevName()
  {
    return devName;
  }

  public void setDevName(String newDevName)
  {
    String  oldDevName = devName;
    devName = newDevName;
    propertyChangeListeners.firePropertyChange("devName", oldDevName, newDevName);
  }

  public synchronized void addDevicePropertyChangeListener(DevicePropertyChangeListener l)
  { if(propertyChangeListeners==null)
     propertyChangeListeners=new PropertyChangeSupport(this);
    if(propertyChangeListeners.hasListeners("devStr"))
     System.out.println("ERRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR : already a listener");
    propertyChangeListeners.addPropertyChangeListener("devStr",l);
    System.out.println("added listener, to device: ");
  }

  /**
   * PURPOSE: remove a listener from this device
   */
  public synchronized void removeDevicePropertyChangeListener(DevicePropertyChangeListener l)
  { if(propertyChangeListeners==null)
     propertyChangeListeners=new PropertyChangeSupport(this);
    propertyChangeListeners.removePropertyChangeListener("devStr",l);
    //propertyChangeListeners.removePropertyChangeListener(l);
    System.out.println("removed listener, from device: ");
  }

  /**
   * PURPOSE: return data from serial data ready
   */

   public abstract void callBack(String inputString);



}
