package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * <p>Title: Devices for Measure Me</p>
 * <p>Description: Device Wrapppers/Code for measure me.</p>
 * <p>Copyright: Copyright (c) 1999</p>
 * <p>Company: DML</p>
 * @author Mathew Lowery
 * @version
 */

import java.io.Serializable;

/**
 * Superclass for <code>SerialConnection</code> and
 * <code>SimulatorConnection</code>.
 */
public abstract class DeviceConnection implements Serializable {
  /**
   * Opens connection.
   */
  public abstract void openConnection() throws ConnectionException;

  /**
   * Sets connection parameters.  These parameters should be passed into the
   * constructor.
   */
  public abstract void setConnectionParameters() throws ConnectionException;

  /**
   * Closes connection.
   */
  public abstract void closeConnection();

  /**
   * Sends data out the connection.
   *
   * @param outputString data to send
   */
  public abstract void sendData(String outputString);

  /**
   * Sends data out the connection.
   *
   * @param outputInt data to send
   */
  public abstract void sendData(int outputInt);

  /**
   * Sends a break signal.
   */
  public abstract void sendBreak();
  /**
   * Returns true if the connection is open.
   *
   * @return connection status
   */
  public abstract boolean isOpen();
} // DeviceConnection