package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class FootLengthDeviceProxy extends GrayCodeDeviceProxy {
  public FootLengthDeviceProxy() {
    super();
  }

  public FootLengthDeviceProxy(DeviceInterface deviceInterface) {
    super(deviceInterface);
  }

  /**
   * applyOffset is overridden here because the hardware is backwards.  i.e. as
   * we move the hardware to greater foot lengths, the values become smaller.
   * The solution is to do 255 minus value.
   */
  protected Short applyOffset(Short deviceValue) {
    Short temp = null;
    temp = new Short((short)(255-super.applyOffset(deviceValue).shortValue()));

    if (temp.shortValue() == (short)255) {   // we're at zero value and we should return 0;
      return new Short((short)0);
    }
    else {
      return temp;
    }
  } // applyOffset
} // FootLengthDeviceProxy