package edu.ucf.cs.dml.simnets.measureme.devices;
import java.beans.*;
import java.util.*;
import javax.swing.UIManager;
import java.awt.*;
import java.awt.event.*;
import edu.ucf.cs.dml.simnets.measureme.client.HangTimeValue;
import java.beans.PropertyChangeEvent;
import edu.ucf.cs.dml.simnets.measureme.*;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class GripDeviceProxy extends DeviceProxy
{
  //boolean deviceResponded=false;
  //boolean deviceFinished=false;
  boolean personGripping = false;
  boolean deviceAcknowledged = false;
  long runningTally=0;
  int sampleCount=0;

  public GripDeviceProxy() {
    super();
  }
  public void propertyChange(PropertyChangeEvent parm1)
  {
     try {
      System.out.println("Mat - propertyChange on HangTimeDeviceProxy");
      String cmdValue = this.deviceInterface.readFromDevice();
      switch (Integer.parseInt(cmdValue)) {

        // acknowledge
        case 2: {
          System.out.println("Mat - Got acknowledge!");
          deviceAcknowledged = true;
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          //notifyAll();
          break;
        } // case 2

        // data
        case 10: {
          System.out.println("Mat - Got data!");
          if (deviceAcknowledged) {
            deviceAcknowledged = false;
            personGripping = true;
            //notifyAll();     // notify this object so waitForDeviceMeasure() can exit
          }
          // get data bytes (2nd and 3rd bytes)

          Short firstByte=null;
          int tempAInt=0;
          firstByte=new Short(this.deviceInterface.readFromDevice());
          tempAInt = firstByte.shortValue();
          tempAInt= tempAInt<< 8; //merge bits together
          tempAInt = tempAInt | Integer.parseInt(this.deviceInterface.readFromDevice());
          tempAInt/=2;
          if(tempAInt!=0)
          {
            this.runningTally+=tempAInt;
            this.sampleCount++;
            System.out.println("Added value: "+tempAInt + "to values");
          }
          else {
            System.out.println("Ignore 0 value");
          }

          break;
        } // case 10

        // finished measuring
        case 11: {
          System.out.println("Mat - Got finished signal!**********************");
          personGripping=false;
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          //notifyAll();     // notify this object so measure() can exit
          break;
        } // case 11

        // ignore all other command values
        default: {
          System.out.println("Mat - Unrecognized command value!  Ignoring...");
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          break;
        } // default

      } // switch
    }
    catch (Exception e) {
      if (e instanceof InterruptedException) {
        System.out.println("Mat - interrupted while Device.readFromDevice()");
      }
      else {
         e.printStackTrace();
      }
    }




  /*
   System.out.println("Event");
    Short firstByte=null;
    int tempAInt=0;
    int i;

  try{
    for (i=0; i<3; i++){
    if (i!=0){
      if(i==1) //the first byte
      { firstByte=new Short(this.deviceInterface.readFromDevice());

      }
      if(i==2)
      { tempAInt = firstByte.shortValue();
        tempAInt= tempAInt<< 8; //merge bits together
        tempAInt = tempAInt | Integer.parseInt(this.deviceInterface.readFromDevice());
        tempAInt/=2;
        if(tempAInt!=0)
        { this.runningTally+=tempAInt;
          this.sampleCount++;
          System.out.println("Added value: "+tempAInt + "to values");
        }
        else
         System.out.println("Ignore 0 value");
        return;
       // v.addElement(new Integer(tempAInt));

      }

      //v.addElement(hangTimeDevice.readFromDevice());
    } else{
    String cmdValue = this.deviceInterface.readFromDevice();
    switch (Integer.parseInt(cmdValue)){
      case 3:  //wanna read next 2
    break;
      case 10: // a command byte with data
            if(!this.deviceResponded)
            { this.deviceResponded=true;
               System.out.println("notified");
                notifyAll();
               try{
                wait(20);
               }
                catch(Exception e3)
               {
                 if (e3 instanceof InterruptedException) {
                   throw (InterruptedException) e3;
                }
                else {
                  e3.printStackTrace();
                }
               }

             }
              break;
      case 11: System.out.println("Finished Measuring"); //end command
              //System.exit(0);
              this.deviceFinished=true;
              this.notifyAll();
      default :break;
    }
    }
    }
    }catch(Exception e){
      e.printStackTrace();
      System.out.println("Paramter was: "+parm1);
      try{
      System.in.read();
      }catch(Exception e2){}
      System.exit(0);;
      }
*/
  }


  public void waitForDeviceMeasure() throws DeviceFailureException, InterruptedException {
    super.waitForDeviceMeasure();
    this.runningTally=0;
    this.sampleCount=0;
    personGripping=false;
    this.deviceInterface.removeDevicePropertyChangeListener(this);
    this.deviceInterface.addDevicePropertyChangeListener(this);
    this.deviceInterface.start();
    while (!personGripping && !stopped) {
      System.out.println("GripDeviceProxy.waitForDeviceMeasure() waiting");
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
    }
    if (stopped) {
      deviceInterface.stop();
    }
  }

  public Object measure() throws DeviceFailureException, InterruptedException {
    long beginTime=System.currentTimeMillis();
    //this.deviceFinished=false;
    System.out.println("Waiting for end signal from the device");
    while(personGripping && !stopped) {
      System.out.println("GripDeviceProxy.measure() waiting");
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
    }
    deviceInterface.stop();
    long endTime=System.currentTimeMillis();
    Short val=new Short((short) Math.round(this.returnWeight()) );
    System.out.println("Average returned: "+this.returnWeight());
    return val;
  }

   protected float returnWeight()
  {  if(this.sampleCount==0)
       return 0.0f;
     else
      return (float)(((double) this.runningTally)/((double) this.sampleCount));

  }

    public static void main(String[] args)
  {
    GripDeviceProxy vHangTimeDeviceProxy = null;
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
   // new LoadCellTest();
   try{

   vHangTimeDeviceProxy = new GripDeviceProxy();
   GripDevice htd=new GripDevice();
   //htd.initialize();
   vHangTimeDeviceProxy.setDeviceInterface(htd);
   htd.removeDevicePropertyChangeListener(vHangTimeDeviceProxy);
   System.out.println("Waiting for device use");
   vHangTimeDeviceProxy.waitForDeviceMeasure();
   System.out.println("Done: Waiting for device use");
   Short val=(Short)vHangTimeDeviceProxy.measure();
   System.out.println("Weight is: "+val);


   }catch (Exception e){
    System.out.println("error in main:");
    e.printStackTrace();}
   }

    public void doTest(){
     try {
  System.out.println("Starting Device");
  this.deviceInterface.start();
  }catch (DeviceFailureException badStart){
  }

  }





}