/**
 * Title:        Devices for Measure Me<p>
 * Description:  Device Wrapppers/Code for measure me.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */

package edu.ucf.cs.dml.simnets.measureme.devices;
import java.beans.*;
import java.util.*;
import javax.swing.UIManager;
import java.awt.*;
import java.awt.event.*;
import edu.ucf.cs.dml.simnets.measureme.client.HangTimeValue;
import java.beans.PropertyChangeEvent;
import edu.ucf.cs.dml.simnets.measureme.*;


public class HangTimeDeviceProxy extends DeviceProxy
{

  //Vector v = new Vector();
  //private int i;
  boolean personHanging=false;
  boolean deviceAcknowledged=false;
  boolean deviceFinished=false;
  long runningTally=0;
  int sampleCount=0;


  public HangTimeDeviceProxy() {
    super();
  }
    //Main method
  public static void main(String[] args)
  {
    HangTimeDeviceProxy vHangTimeDeviceProxy = null;
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
   // new LoadCellTest();
   try{

   vHangTimeDeviceProxy = new HangTimeDeviceProxy();
   HangTimeDevice htd=new HangTimeDevice();
   //htd.initialize();
   vHangTimeDeviceProxy.setDeviceInterface(htd);
   htd.removeDevicePropertyChangeListener(vHangTimeDeviceProxy);
   System.out.println("Waiting for device use");
   vHangTimeDeviceProxy.waitForDeviceMeasure();
   System.out.println("Done: Waiting for device use");
   HangTimeValue val=(HangTimeValue)vHangTimeDeviceProxy.measure();
   System.out.println("Weight is: "+val.getWeight());


   }catch (Exception e){
    System.out.println("error in main:");
    e.printStackTrace();}
   }

    public void doTest(){
 //v.removeAllElements();
  //this.deviceInterface.addDevicePropertyChangeListener(this);

  try {
  System.out.println("Starting Device");
  this.deviceInterface.start();
  }catch (DeviceFailureException badStart){
  }

  }


  public void propertyChange(PropertyChangeEvent parm1)
  {
    try {
      System.out.println("Mat - propertyChange on HangTimeDeviceProxy");
      String cmdValue = this.deviceInterface.readFromDevice();
      switch (Integer.parseInt(cmdValue)) {

        // acknowledge
        case 2: {
          System.out.println("Mat - Got acknowledge!");
          deviceAcknowledged = true;
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          //notifyAll();
          break;
        } // case 2

        // data
        case 3: {
          System.out.println("Mat - Got data!");
          if (deviceAcknowledged) {
            deviceAcknowledged = false;
            personHanging = true;
            //notifyAll();     // notify this object so waitForDeviceMeasure() can exit
          }
          // get data bytes (2nd and 3rd bytes)
          Short firstByte=new Short(this.deviceInterface.readFromDevice());
          int tempAInt = firstByte.shortValue();
          tempAInt= tempAInt<< 8; //merge bits together
          tempAInt = tempAInt | Integer.parseInt(this.deviceInterface.readFromDevice());
          tempAInt/=2;
          this.runningTally+=tempAInt;
          this.sampleCount++;
          System.out.println("Mat - Added value: "+ tempAInt + " to values");
          break;
        } // case 3

        // finished measuring
        case 4: {
          System.out.println("Mat - Got finished signal!**********************");
          deviceFinished=true;
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          //notifyAll();     // notify this object so measure() can exit
          break;
        } // case 4

        // ignore all other command values
        default: {
          System.out.println("Mat - Unrecognized command value!  Ignoring...");
          // consume the other two data bytes (meaningless)
          deviceInterface.readFromDevice();
          deviceInterface.readFromDevice();
          break;
        } // default

      } // switch
    }
    catch (Exception e) {
      if (e instanceof InterruptedException) {
        System.out.println("Mat - interrupted while Device.readFromDevice()");
      }
      else {
         e.printStackTrace();
      }
    }




      /*
    System.out.println("Event");
    Short firstByte=null;
    int tempAInt=0;
    int i;

    if(!this.deviceResponded)
    { this.deviceResponded=true;
        System.out.println("notified");
        notify();
        try{
         wait(20);
         }
         catch(Exception e3)
         {}

    }
  try{
    for (i=0; i<3; i++){
    if (i!=0){
      if(i==1) //the first byte
      { firstByte=new Short(this.deviceInterface.readFromDevice());

      }
      if(i==2)
      { tempAInt = firstByte.shortValue();
        tempAInt= tempAInt<< 8; //merge bits together
        tempAInt = tempAInt | Integer.parseInt(this.deviceInterface.readFromDevice());
        tempAInt/=2;
        this.runningTally+=tempAInt;
        this.sampleCount++;
        System.out.println("Added value: "+tempAInt + "to values");
        return;
       // v.addElement(new Integer(tempAInt));

      }

      //v.addElement(hangTimeDevice.readFromDevice());
    } else{
    String cmdValue = this.deviceInterface.readFromDevice();
    switch (Integer.parseInt(cmdValue)){


      case 2:
        notify();
        break;



      case 3:  //wanna read next 2
        if (firstDataChunk) {
          firstDataChunk = false;
          personHanging=true;
          notify();
        }
        break;
      case 4: System.out.println("Finished Measuring"); //end command
              //System.exit(0);
              this.deviceFinished=true;
              this.notify();
      default :break;
    }
    }
    }
    }catch(Exception e){
      e.printStackTrace();
      System.out.println(parm1);
      try{
      System.in.read();
      }catch(Exception e2){}
      System.exit(0);;
      }
    //this.tallyWhacker();
    */
  }
    public void tallyWhacker()
  {

    //Enumeration enum=v.elements();


   // double temp=0.0;
  /* while(enum.hasMoreElements())
    {
      //int i=0;
      for (i=0;i<2;i++)
      {
      tempA=new Short((String)enum.nextElement());
      if (i==0){
      //int tempAInt = Integer.parseInt(tempA.toString());
      tempAInt = Integer.parseInt(tempA.toString()) << 8; //merge bits together
      //System.out.println(tempAInt);
      } else tempAInt = tempAInt | Integer.parseInt(tempA.toString());


    } */
     //System.out.println("___");
     System.out.println(this.returnWeight());

     System.out.println("___");
     //frame.jProgressBar1.setValue((tempAInt)/10);
      //temp+=tempA.floatValue();

    //v.removeAllElements();

  }


  //}

  public Object measure() throws DeviceFailureException, InterruptedException {
    long beginTime=System.currentTimeMillis();
    //this.deviceFinished=false;

    System.out.println("Mat - Waiting for end signal from the device...");
    while(!deviceFinished && !stopped) {
      System.out.println("HangTimeDeviceProxy.measure() waiting");
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
    }
    System.out.println("Mat - Person stopped hanging!");
    long endTime=System.currentTimeMillis();

    HangTimeValue val=new HangTimeValue(beginTime,endTime,this.returnWeight());
    System.out.println("Average returned: "+this.returnWeight());
    //return new Integer((int)(Math.random()*256-1));
    deviceInterface.stop();
    return val;

  }

  public void waitForDeviceMeasure() throws DeviceFailureException,
                                                         InterruptedException {
    super.waitForDeviceMeasure();
    this.runningTally=0;
    this.sampleCount=0;

    // Mat - need to be reset on each client login
    deviceFinished=false;
    personHanging=false;
    deviceAcknowledged=false;

    this.deviceInterface.removeDevicePropertyChangeListener(this);
    this.deviceInterface.addDevicePropertyChangeListener(this);
    this.deviceInterface.start();

    System.out.println("Mat - waiting for device to signal person is hanging...");
    while(!personHanging && !stopped) {
      System.out.println("HangTimeDeviceProxy.waitForDeviceMeasure() waiting");
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
    }
    if (stopped) {
      deviceInterface.stop();
    }
  }


  protected float returnWeight()
  {  if(this.sampleCount==0)
       return 0.0f;
     else
      return (float)(((double) this.runningTally)/((double) this.sampleCount));

  }




}