
/**
 * Title:        Devices for Measure Me<p>
 * Description:  Device Wrapppers/Code for measure me.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.devices;
import java.util.*;
import java.beans.PropertyChangeEvent;
import java.io.*;
import edu.ucf.cs.dml.simnets.measureme.*;

public class HeightDeviceProxy extends DeviceProxy implements Serializable
{ transient private Vector v=null;
  public static final float distToTheFloor=3.06f;
  public static final float metersToInchesConversionFactor = 39.37f;
  public static final float errorVal=0.02f; //measured 2cm error
  public HeightDeviceProxy() {
    super();
    v=new Vector();
  }

  public HeightDeviceProxy(DeviceInterface deviceInterface)
  { super(deviceInterface);
    try{//deviceInterface.initialize();
    }catch(Exception e)
    { e.printStackTrace();
    }
  }

  public void propertyChange(PropertyChangeEvent parm1)
  { try{
     v.addElement(deviceInterface.readFromDevice());
    }
    catch(Exception e)
    { e.printStackTrace();
    }

  }

  public Object measure() throws DeviceFailureException, InterruptedException
  {
   System.out.println("Mat - measuring...");
   if(v!=null)
      v.clear();
    else
     v=new Vector();
     System.out.println("Mat - starting device");
    deviceInterface.start();

     //Thread.sleep(5000); //perform a 5 second scan
     // Mat edit 2001-04-12 change to wait(5000);
    System.out.println("Mat - waiting for 5 seconds.");
    int scanTime = 0;
    while (scanTime < 5000 && !stopped) {
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
      scanTime += MeasureMeGlobal.WAIT_TIME;
    }
    System.out.println("Mat - stopping device");
    deviceInterface.stop();
    System.out.println("Mat - tallying...");
    return tally();
  }
  /**
   * Returns an averaged approximation in inches
   */
  private Float tally()
  { Enumeration enum=v.elements();
    int i=0;
    Float tempA=new Float((float)0.0);
    double temp=0.0;
    while(enum.hasMoreElements())
    { tempA=new Float((String)enum.nextElement());
      temp+=tempA.floatValue();
      i++;
    }
    //System.out.println("Ding: the answer is... " + ((temp/i)+this.errorVal)  );
    System.out.println("You are " + ((metersToInchesConversionFactor *(this.distToTheFloor - (temp/i)+ this.errorVal))/12) + " feet.");
    //System.out.println("Total inputs: "+i + " total of values: "+temp);
    Float f=new Float((metersToInchesConversionFactor *(this.distToTheFloor - (temp/i)+ this.errorVal)));
    System.out.println("inches= " + f);
    return f;
    //return tempA;

  }

  void writeObject(ObjectOutputStream oos) throws IOException
  {
    oos.defaultWriteObject();
  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException
  {
    ois.defaultReadObject();
    this.v=new Vector();
  }
/*

  public void waitForDeviceMeasure()
  {
    super.waitForDeviceMeasure();
  }
*/


}