package edu.ucf.cs.dml.simnets.measureme.devices;

public class JumpSimulator extends OSCDeviceSimulator {
  private int halfInches;

  // next two vars signal start and stop of balance action
  private static final int REACH_INDICATOR = 8;
  private static final int JUMP_INDICATOR = 18;

  public JumpSimulator() {
    super();
    halfInches = 40;
  }
  public void write(int data) {
    if ((++loginCodeByteCounter % 3) == 0) {
      // start thread here to allow app to continue processing device signals
      new Thread(new Runnable() {
        public void run() {
          simGUI.appendStatus("Sim: Got login code...");
          loginCodeByteCounter = 0;
          char[] commandAndDataArray = new char[3];
          String commandAndDataString;
          commandAndDataString = new String(OSCDeviceSimulator.ACK_SIGNAL);
          simGUI.appendStatus("Sim: Sending ack signal...");
          fireSimulatorEvent(new SimulatorEvent(this, commandAndDataString));

          // pause for one sec just for reading screen
          try {
            Thread.currentThread().sleep(2000);
          } catch (InterruptedException e) { }


          // create char array for easy 3 char String creation
          commandAndDataArray[0] = (char) REACH_INDICATOR;
          commandAndDataArray[2] = (char) halfInches;
          commandAndDataString = new String(commandAndDataArray);
          simGUI.appendStatus("Sim: Sending reach signal...");
          fireSimulatorEvent(new SimulatorEvent(this, commandAndDataString));
          try {
            Thread.currentThread().sleep(10000);
          } catch (InterruptedException e) { }
          commandAndDataArray[0] = (char) JUMP_INDICATOR;
          commandAndDataArray[2] = 0;
          commandAndDataString = new String(commandAndDataArray);
          simGUI.appendStatus("Sim: Sending jump signal...");
          fireSimulatorEvent(new SimulatorEvent(this, commandAndDataString));
        } // run
      }).start(); // Thread
    } // if
  }

  public void guiEvent(SimulatorGUIEvent e) {
    // object at this point is a valid float
    float distanceF = ((Float) e.getData()).floatValue();
    halfInches = (int) (distanceF * 2);
  }
}