package edu.ucf.cs.dml.simnets.measureme.devices;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

/**
 * Load cell devices require two pieces of information: time and pressure.
 */
public abstract class LoadCellSimulatorGUI extends DeviceSimulatorGUI {
  protected JLabel field2Label = new JLabel();
  protected JTextField userValueField2 = new JTextField();

  /**
   * Override to check both fields for valid values then fire event.
   * @param e
   */
  void okButton_actionPerformed(ActionEvent e) {
    // assume field1 is time and field2 is pounds
    float time;
    try {
      time = Float.parseFloat(userValueField.getText());
    }
    catch (NumberFormatException e1) {
      JOptionPane.showMessageDialog(this, "Value in time is not a number.");
      return;
    }
    int pounds;
    try {
      pounds = Integer.parseInt(userValueField2.getText());
    }
    catch (NumberFormatException e1) {
      JOptionPane.showMessageDialog(this, "Value in pounds is not a number.");
      return;
    }
    Number[] vals = new Number[2];
    vals[0] = new Float(time);
    vals[1] = new Integer(pounds);
    fireSimulatorGUIEvent(new SimulatorGUIEvent(this, vals));
  }

  public LoadCellSimulatorGUI(String title) {
    super(title);
    fieldLabel.setText("User Value2: ");
    userValueField2.setMinimumSize(new Dimension(100, 25));
    userValueField2.setPreferredSize(new Dimension(100, 25));
    getContentPane().add(field2Label);
    getContentPane().add(userValueField2);
    pack();
  }

} // LoadCellSimulatorGUI