package edu.ucf.cs.dml.simnets.measureme.devices;


import java.util.Enumeration;
import com.objectspace.jgl.*;
import java.beans.*;
import java.io.*;

public class LoadDevice extends Device
{
  private transient SerialParameters parameters;
  private SerialConnection connection;
  private transient Queue queue;
  private int inputInt;
  private float inputFloat;
  private Short inputShort;
  private boolean killStart = false;

  public LoadDevice()
  { System.out.println("LoadDevice Constructed");
  }
  /**
  *  Purpose: create connection and parameters objects and attempt to open,
  *  reset, and close device
  */
  public void initialize() throws DeviceFailureException
  {
    this.parameters = new SerialParameters("COM1",
	     9600,
	     2,
	     2,
	     8,
	     1,
	     0);
    System.out.println("new params");
    connection = new SerialConnection(this, this.parameters);
    queue = new Queue();

    try{
    connection.openConnection();
    } catch (SerialConnectionException e2) {
    return;
    }
  }

  /**
  *  Purpose: open the serial port for device read/write
  */
  public void start() throws DeviceFailureException
  {
    System.out.println("Load Device, started");
    try{
    connection.openConnection();
    } catch (SerialConnectionException e2) {
    }
    //start data polling

    int i;
    while (killStart != true){
    connection.sendData(3);
    connection.sendData(3);
    connection.sendData(2);
     try{
      Thread.sleep(70);
      }catch (InterruptedException e4){}
    }
  }

  /**
  *  Purpose: terminate polling of device and close connection
  */
  public void stop() throws DeviceFailureException
  {
    //connection.sendData("\u0003");
    killStart = true;
    connection.closeConnection();
  }

  /**
  *  Purpose: send back recieved data buffer
  */
  public void callBack(String inputString)
  {
   //try{
   //inputInt = Integer.parseInt(inputString);
   //} catch (Exception e) {}
   //if (inputInt != 0){
   //inputFloat = (float)(((((inputInt)/2.0))/1000000)*343.0); // divide to get 1 way, convert to seconds, convert to meters.
   //String f = new String(Float.toString(inputFloat));

   //System.out.println("callback load device");
   char inputChar;
   String tempInput;
      if (inputString.length() != 3){
      System.out.println("error in length");
      System.out.println(inputString);
      //try{
      //System.in.read();
      return;
      //} catch (Exception e){}
      }
      for(int i=0;i<inputString.length();i++)
   {
     inputChar = inputString.charAt(i);
     //System.out.println("charAt "+i+" "+inputChar);
     inputShort = new Short ((short)inputString.charAt(i));
     //System.out.println(inputShort);
     tempInput = Short.toString(inputShort.shortValue());
     //System.out.println(tempInput);
     queue.push(tempInput);
   }
   //inputShort = new Short(inputString);
   //System.out.println("input short:");
   //System.out.println(inputShort);
   //inputString =  Short.toString(inputShort.shortValue());
   //queue.push(inputString);

   synchronized(this){
   propertyChangeListeners.firePropertyChange(new PropertyChangeEvent(this,"devStr",new Boolean(true) , new Boolean(false)));
   }
   }
   //}
  /**
  *  Purpose: to read from the FIFO queue on request
  */
  public String readFromDevice()
  {
   return queue.pop().toString();
  }

  /**
  *   Purpose: directly write to serial connection
  */
  public void writeToDevice(String deviceDataString) throws DeviceDataException
  {
    connection.sendData(deviceDataString);
  }

  /**
  *  Purpose: implement writeToDevice(Str) with protocol
  *  TODO: implement
  */
  public void writeToDevice(String deviceDataString, String protocolString) throws DeviceDataException, UnknownProtocolException
  {
  }

  /**
  *  Purpose: get available protocols
  *  TODO: implement
  */
  public Enumeration getProtocolCmds()
  {
   return null;
  }

  void writeObject(ObjectOutputStream oos) throws IOException
  { System.out.println("k");
    oos.defaultWriteObject();
  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException
  {
    ois.defaultReadObject();
  }
  public String toString()
  { return super.toString()+ " "+ this.parameters.getBaudRate()+"\n"+
     this.parameters.getBaudRateString();


  }

}