package edu.ucf.cs.dml.simnets.measureme.devices;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */
/**
 * CLASS ReactionTimeDevice: this is a slight variation in that the device can
 *  be operated in multiple modes: visual, sound, and tactile. The expected
 *  return value from the device is a third byte that represents time. 5 ms per
 *  bit.
 */
public class ReactionTimeDevice extends OSCDevice
{

  public ReactionTimeDevice()
  { super();
    this.deviceStartLoginCodes=OSCDeviceCodes.REACTION_CHASE_SEQUENCE; //default into chase mode
    System.out.println("Reaction time created: ");
  }

  /**
   * PURPOSE: Put this device into chase mode
   */
  public void chaseMode()
  { this.deviceStartLoginCodes=OSCDeviceCodes.REACTION_CHASE_SEQUENCE;
    try{
     this.start();
    }
    catch(Exception e)
    { System.err.println("Unable to send chase sequence");
      e.printStackTrace();
    }


  }

  public void sightMode()
  { this.deviceStartLoginCodes=OSCDeviceCodes.REACTION_SIGHT_LOGIN;
    try{
     this.start();
    }
    catch(Exception e)
    { System.err.println("Unable to send sight mode");
      e.printStackTrace();
    }

  }

  public void touchMode()
  { this.deviceStartLoginCodes=OSCDeviceCodes.REACTION_TOUCH_LOGIN;
    try{
     this.start();
    }
    catch(Exception e)
    { System.err.println("Unable to send touch mode");
      e.printStackTrace();
    }

  }

  public void soundMode()
  { this.deviceStartLoginCodes=OSCDeviceCodes.REACTION_SOUND_LOGIN;
    try{
     this.start();
    }
    catch(Exception e)
    { System.err.println("Unable to send touch mode");
      e.printStackTrace();
    }

  }


  protected boolean syncDevice()
  { return true;

  }


 public void writeToDevice(String parm1) throws edu.ucf.cs.dml.simnets.measureme.devices.DeviceDataException
 { System.out.println("Device: writeToDevice: "+parm1);
   if(parm1.equals("Sound"))
   { this.soundMode();
   }
   else
    if(parm1.equals("Touch"))
    { this.touchMode();
    }
    else
     if(parm1.equals("Sight"))
      { this.sightMode();
      }
     else
      if(parm1.equals("Chase"))
      { this.chaseMode();

       }
    else
     super.writeToDevice(parm1);

 }





}