package edu.ucf.cs.dml.simnets.measureme.devices;
import java.beans.*;
import edu.ucf.cs.dml.simnets.measureme.*;

/**
 * Title:        Devices for Measure Me
 * Description:  Device Wrapppers/Code for measure me.
 * Copyright:    Copyright (c) 1999
 * Company:      DML
 * @author Dean Reed
 * @version
 */

public class ReactionTimeDeviceProxy extends DeviceProxy
{ protected Short lastTime=new Short((short)-1);
  boolean deviceResponded=false;

  public ReactionTimeDeviceProxy()
  { super();
    deviceResponded=false;
  }

  public ReactionTimeDeviceProxy(DeviceInterface deviceInterface)
  { super(deviceInterface);
    deviceResponded=false;
  }

  public void propertyChange(PropertyChangeEvent evt)
  { System.out.println("Event");
    Short firstByte=null;
    int tempAInt=0;
    int i;
    try{
       for (i=0; i<3; i++)
       { if (i!=0)
         {
          if(i==1) //the first byte
          { firstByte=new Short(this.deviceInterface.readFromDevice());

           }
          if(i==2)
          { tempAInt = firstByte.shortValue();
            tempAInt= tempAInt<< 8; //merge bits together
            tempAInt = tempAInt | Integer.parseInt(this.deviceInterface.readFromDevice());
            tempAInt*=5;  //the number of milliseconds from the device
            System.out.println("Time value is : " +tempAInt + " ms");
            this.lastTime=new Short((short)tempAInt);
            this.deviceResponded=true;
            //System.out.println("ReactionTimeDeviceProxy.propertyChange(): Notifying one thread waiting on me!");
            //this.notifyAll();
           }
         }//end if i!=0
         else // a command byte
         {  String cmdValue = this.deviceInterface.readFromDevice();
            switch (Integer.parseInt(cmdValue))
           {
             case 2:  //wanna read next 2 data bytes, acknowledge
                      this.deviceInterface.readFromDevice();
                      this.deviceInterface.readFromDevice();
                      i++;
                      i++;
                      System.out.println("Reaction Ack");
                      break;
             case 7: // a command byte with data, let next 2 be read
                     break;
             default: System.out.println("Unknown command byte read: "+ cmdValue);
                      this.deviceInterface.readFromDevice();
                      this.deviceInterface.readFromDevice();
                      i++;
                      i++;
                      break;
           }
         }// end else
       }//end for
    }
    catch(Exception e)
    { e.printStackTrace();
    }


        return;

  }


  public void waitForDeviceMeasure() throws DeviceFailureException, InterruptedException {
    //wait for device, the device tells when measurement is through
    super.waitForDeviceMeasure();
    System.out.println("ReactionTimeDeviceProxy.waitForDeviceMeasure(): waiting on me...");
    while(!deviceResponded && !stopped) {
      System.out.println("ReactionTimeDeviceProxy.waitForDeviceMeasure() waiting");
      synchronized(this) {wait(MeasureMeGlobal.WAIT_TIME);}
    }
    if (stopped) {
      deviceInterface.stop();
    }
    System.out.println("ReactionTimeDeviceProxy.waitForDeviceMeasure(): somebody notified me!");
    this.deviceResponded=false;
  }

  public Object measure() throws DeviceFailureException, InterruptedException {
    deviceInterface.stop();
    return this.lastTime;
  }

  /**
   * PURPOSE: Switch modes of the device into
   *  Sound, Touch, Sight, Chase
   */
  public void setMode(String mode)
  { try
    { // a lousy last minute hack
      this.deviceInterface.writeToDevice(mode);
    }
    catch(Exception e)
    { e.printStackTrace();
    }

  }


}