package edu.ucf.cs.dml.simnets.measureme.devices;

public class ReactionTimeSimulator extends OSCDeviceSimulator {
  private long timeToReact;
  private static final int DATA_INDICATOR = 7;

  public ReactionTimeSimulator() {
    super();
    timeToReact = 350;
  }

  public void write(int data) {
    if ((++loginCodeByteCounter % 3) == 0) {
      // start thread here to allow app to continue processing device signals
      new Thread(new Runnable() {
        public void run() {
          simGUI.appendStatus("Sim: Got login code...");
          loginCodeByteCounter = 0;
          char[] commandAndDataArray = new char[3];
          String commandAndDataString;
          commandAndDataString = new String(OSCDeviceSimulator.ACK_SIGNAL);
          simGUI.appendStatus("Sim: Sending ack signal...");
          fireSimulatorEvent(new SimulatorEvent(this, commandAndDataString));

          // pause for one sec just for reading screen
          try {
            Thread.currentThread().sleep(1000);
          } catch (InterruptedException e) { }

          long adjustedTime = timeToReact / 5L;

          // create char array for easy 3 char String creation
          commandAndDataArray[0] = (char) DATA_INDICATOR;
          commandAndDataArray[1] = (char) (adjustedTime << 48 >> 56);
          commandAndDataArray[2] = (char) (adjustedTime << 56 >> 56);
          commandAndDataString = new String(commandAndDataArray);
          simGUI.appendStatus("Sim: Sending data signal...");
          fireSimulatorEvent(new SimulatorEvent(this, commandAndDataString));
        } // run
      }).start(); // Thread
    } // if
  }

  public void guiEvent(SimulatorGUIEvent e) {
    // object at this point is a valid float of time in ms
    long timeInMilliseconds = ((Float) e.getData()).longValue();
    timeToReact =  timeInMilliseconds;
  }
}