
/**
 * Title:        MeasureMe Server Side<p>
 * Description:  Server side code. <p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;

public class ExhibitAvailableInfo implements java.io.Serializable
{
  short stationId=0;
  boolean isAvailable=true;  //assume all stations are available
  boolean checkedIn=true;   // did it make the last checkin?
  String stationName="";

  public ExhibitAvailableInfo(short stationID)
  { this.stationId=stationID;
  }

  public ExhibitAvailableInfo(short stationID,String stationName)
  { this(stationID);
    this.stationName=stationName;
  }
  public String getStationName()
  { return this.stationName;
  }

  public short getStationID()
  { return this.stationId;
  }

  public boolean isAvalable()
  { return this.isAvailable;
  }

  /**
   * PURPOSE: The station is checking in
   */
  public void stationCheckin()
  { this.isAvailable=true;
    this.checkedIn=true;
  }
  /**
   * PURPOSE: Server checks this stations availabitity, and if the
   *  station does not check in before the next server check, then this station
   *  should be considered unavailable.
   */
  public void serverCheckStation()
  { if(!this.checkedIn) //the last checkin was missed
     this.isAvailable=false;
    this.checkedIn=false;
  }




}