
/**
 * Title:        MeasureMe Server Side<p>
 * Description:  A client side check in service. <p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;
import edu.ucf.cs.dml.simnets.measureme.dbase.*;
import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;
import java.net.*;
import java.util.*;
import java.beans.*;
import net.jini.core.transaction.*;
import net.jini.core.transaction.server.TransactionManager;

public class ExhibitAvailableManager extends StationAvailableServer
{ protected short stationID=0;

 public ExhibitAvailableManager(short stationID)
 { super();
   this.stationID=stationID;
 }

  public ExhibitAvailableManager(JavaSpace space,short stationID )
  { super(space);
    this.stationID=stationID;
  }

  public ExhibitAvailableManager(long timeToCheck,short stationID )
  { super(timeToCheck);
    this.stationID=stationID;
  }

  public ExhibitAvailableManager(JavaSpace space,long timeToCheck,short stationID )
  { super(space,timeToCheck);
    this.stationID=stationID;
  }
  /**
   * OVERIDE: set this station as available
   */
  protected boolean initialize() {
    System.out.println("ExhibitAvailableManager Initialize: start");
    while (this.stationID==0) {
      System.out.println("waiting for object construction, station id is 0");
      try {
        Thread.sleep(100);
      }
      catch (InterruptedException e) {
        // ignore interruptions
        e.printStackTrace();
      }
    }

    ExhibitAvailableQueue eaqTemplate=new ExhibitAvailableQueue();
    eaqTemplate.stationsAvailableInfo=null;  //check javaspace for existing info
    ExhibitAvailableQueue eaq=null;
    Transaction.Created trc= null;
    if (this.mgr==null) {
      System.out.println("Manager is null");
    }
    try {
      trc=TransactionFactory.create(this.mgr,60000);  //create a 60 second transactiion
    }
    catch (Exception e3) {
      // if no txn, then do not continue; we could lose the tuple
      e3.printStackTrace();
      return false;
    }
    Transaction txn=trc.transaction;

    try {
      eaq=(ExhibitAvailableQueue)space.take(eaqTemplate,txn,Lease.FOREVER);
      //get the queue from javaspace
      ExhibitAvailableInfo info=null;
      if(eaq.getExhibitAvailableInfo(this.stationID)==null)
      { //need to create a new entry
        info=new ExhibitAvailableInfo(this.stationID);
        eaq.addExhibitInfo(info);
      }
      else
       info=eaq.getExhibitAvailableInfo(this.stationID);
      info.stationCheckin(); //now try to do an initial checkin
      this.setLastActiveStations(eaq.getAvailableStations());
      space.write(eaq,txn,Lease.FOREVER);
      txn.commit();

    }
    catch(Exception e2) {
      e2.printStackTrace();
//        this.recover();
//        this.initialize();
      return false;
    }

    System.out.println("ExhibitAvailableManager: initialize done.");

    return true;

  } // initialize

  /**
   * OVERIDE: simply checks this station in and updates last available.
   */
  protected void runchecks() {
    Transaction.Created trc= null;
    Transaction txn=null;

    try {
      trc=TransactionFactory.create(this.mgr,50000);
      txn=trc.transaction;

      ExhibitAvailableQueue template=new ExhibitAvailableQueue();
      template.stationsAvailableInfo=null;  //check javaspace for existing info
      ExhibitAvailableQueue eaq=(ExhibitAvailableQueue)space.take(template,txn,Lease.FOREVER); //get rid of it
      if(!(eaq==null))
      {  //System.out.println("Got queue for updates");
        ExhibitAvailableInfo info=eaq.getExhibitAvailableInfo(this.stationID);
        info.stationCheckin();
        this.setLastActiveStations( eaq.getAvailableStations());

        space.write(eaq,txn,Lease.FOREVER);
        txn.commit();
        //System.out.println("returned que ");

        //performed routine for checkin's
      }
    }
    catch(Exception e2) {
      e2.printStackTrace();
      if (txn!=null) {
        try {
          txn.abort();
        }
        catch (Exception e3) {
          e3.printStackTrace();
        }
      }
    }
  } // runchecks

}