
/**
 * Title:        MeasureMe Server Side<p>
 * Description:  Server side code. <p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;
import net.jini.core.entry.Entry;
import java.util.*;
/**
 * This class implements a que style structure that can be used to
 *  determine which Exhibits are currently available
 */
public class ExhibitAvailableQueue implements Entry
{ public Hashtable stationsAvailableInfo=null;

  public ExhibitAvailableQueue()
  { this.stationsAvailableInfo=new Hashtable();

  }

  public void addExhibitInfo(ExhibitAvailableInfo info)
  {  this.stationsAvailableInfo.put(new Short(info.getStationID()),info);
  }

  /**
   *  PURPOSE: Return a vector with all the stations that are currently available
   */
  public Vector getAvailableStations()
  { Enumeration enum=this.stationsAvailableInfo.elements();
    Vector returnVec =new Vector();
    ExhibitAvailableInfo  sai=null;
    while(enum.hasMoreElements())
    { sai=(ExhibitAvailableInfo)enum.nextElement();
      if(sai.isAvalable())
       returnVec.add(sai);
    }
    return returnVec;
  }

  /**
   * PURPOSE: To be run on the server at some time interval, checks to make sure that
   *  the exibits have checked in
   */
  public void performServerCheck()
  { Enumeration enum=this.stationsAvailableInfo.elements();
    while(enum.hasMoreElements())
     ((ExhibitAvailableInfo)enum.nextElement()).serverCheckStation();

  }
  /**
   * PURPOSE: return the availabity object for the given id
   */
  public ExhibitAvailableInfo getExhibitAvailableInfo(short stationID)
  { return (ExhibitAvailableInfo)this.stationsAvailableInfo.get(new Short(stationID));
  }
}