
/**
 * Title:        Measure Me client side classes/source<p>
 * Description:  The source code for the measure me orlando science center project.<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      DML<p>
 * @author Dean Reed
 * @version
 */
package edu.ucf.cs.dml.simnets.measureme.server;
import java.util.Date;
import java.util.Calendar;
import java.text.*;

/**
 * CLASS ExhibitScoreInfo maintains the score data on a per exhibit basis.
 *  Time is reletive to the start of the day, and is stored in 5 second incremenets.
 *   To compute the time of day = (value*5) = number of seconds since midnight
 *
 */
public class ExhibitScoreInfo implements java.io.Serializable
{ protected short exhibitID=-1; //the id of the exhibit visited
  protected short lastScore=-1;
  protected short numberOfTimesVisited=0;
  protected short firstVisitTime=-1;
  protected short lastVisitTime=-1;

  public ExhibitScoreInfo(short exhibitID)
  { this.exhibitID=exhibitID;
  }
  public short getExhibitID()
  { return this.exhibitID;
  }

  public void setScore(short score)
  { this.numberOfTimesVisited++;
    this.lastScore=score;
  }

  public short getScore()
  { return this.lastScore;
  }



  public void setLastVisitTime(java.util.Date time)
  {   Calendar calendar = Calendar.getInstance();
      calendar.setTime(time);
   /*   System.out.println("Hour: "+calendar.get(Calendar.HOUR));
      System.out.println("Hour of day: "+calendar.get(Calendar.HOUR_OF_DAY));
      System.out.println("Minute: "+calendar.get(Calendar.MINUTE));
      System.out.println("Second: "+calendar.get(Calendar.SECOND));
      System.out.println("Ms: "+calendar.get(Calendar.MILLISECOND));
     */

      //System.out.println(time.getDate());

      this.lastVisitTime =(short) (this.getSecondsSinceMidnight(time)/5);
      System.out.println(lastVisitTime);

  }

  public void setFirstVisitTime(java.util.Date time)
  {   Calendar calendar = Calendar.getInstance();
      calendar.setTime(time);

      this.firstVisitTime =(short) (this.getSecondsSinceMidnight(time)/5);

  }


  /**
   * PURPOSE: Get the number of seconds that have passed since midnight
   */
  public static int getSecondsSinceMidnight(Date time)
  { Calendar calendar = Calendar.getInstance();
    calendar.setTime(time);
    if(calendar.get(Calendar.MILLISECOND)<500)
     return  calendar.get(Calendar.HOUR_OF_DAY) * 60 *60  +calendar.get(Calendar.MINUTE)*60+calendar.get(Calendar.SECOND);
    return calendar.get(Calendar.HOUR_OF_DAY) * 60 *60  +  calendar.get(Calendar.MINUTE)*60+calendar.get(Calendar.SECOND) +1;
  }

  public short getFirstVisitTime()
  { return this.firstVisitTime;
  }
  public short getLastVisitTime()
  { return this.lastVisitTime;
  }

  public short getNumberOfTimesVisited()
  { return this.numberOfTimesVisited;
  }

  protected void printTimeofDay(int secondSincemid)
  { int hourofDay=secondSincemid/(60*60);
    System.out.println("Hour: " +hourofDay);

    int min =((secondSincemid-hourofDay*60*60)/60 ); // % 60;
    System.out.println("min: "+ min);

    int seconds = secondSincemid - hourofDay*60*60 -min*60;
    System.out.println("sec: "+ seconds);

  }


}