package edu.ucf.cs.dml.simnets.measureme.server;

import edu.ucf.cs.dml.simnets.measureme.MeasureMeGlobal;
import net.jini.core.lookup.*;
import net.jini.core.discovery.*;
import net.jini.core.transaction.server.TransactionManager;
import java.io.*;
import java.net.*;
import java.rmi.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/**
 * This class provides one static method that returns a handle to a
 * TransactionManager object via unicast lookup on a hard-coded server.
 * This class replaces TransactionManagerAccessor since classes and methods
 * used in it have been deprecated beginning in Jini 1.1.
 */
public class MMTransactionManagerAccessor {

  public static TransactionManager getManager() {
    LookupLocator lookup = null;
    ServiceRegistrar registrar = null;

    // set security manager
    if (System.getSecurityManager() == null) {
      System.out.println("setting new security manager");
      System.setSecurityManager(new RMISecurityManager());
    }

    // Edit M. Lowery 2002-Sep-13:  current config is unicast (see below)

    DiscoveryUtil d = new DiscoveryUtil();
    try {
//      registrar = d.discoverOne();              // multicast
      registrar = d.locate(MeasureMeGlobal.ipAddress);    // unicast
    }
    catch (JiniUtilException e) {
      e.printStackTrace();
      return null;
    }



    /*
    try {
      lookup = new LookupLocator("jini://pc176.cs.ucf.edu");
    }
    catch (java.net.MalformedURLException e) {
      System.out.println("Lookup failed: " + e.toString());
      return null;
    }

    try {
      System.out.println("finding lookup service");
      registrar = lookup.getRegistrar();
    }
    catch (java.io.IOException e) {
      System.out.println("Registrar search failed: " + e.toString());
      return null;
    }
    catch (java.lang.ClassNotFoundException e) {
      System.out.println("Registrar search failed: " + e.toString());
      return null;
    }
    */

    // look for transaction manager service
    Class[] txnManagerClasses = new Class[1];
    txnManagerClasses[0] = TransactionManager.class;
    ServiceTemplate template = new ServiceTemplate(null, txnManagerClasses, null);
    TransactionManager txnManager = null;
    try {
      System.out.println("looking up transaction manager");
      txnManager = (TransactionManager) registrar.lookup(template);
    }
    catch(java.rmi.RemoteException e) {
      System.out.println("Error finding transaction manager: " + e.toString());
      return null;
    }

    return txnManager;
  } // getManager

  public static void main(String[] args) {
    MMTransactionManagerAccessor tma
      = new MMTransactionManagerAccessor();
    TransactionManager tm = tma.getManager();
    System.out.println("got transaction manager: "+tm.toString());
  }
}